      subroutine AbortMessage(s)
      character s*(*)
      call str_flush
      call str_string_out(s,'ERROR: #')
      call str_flush
      call abort
      return
      end                       ! AbortMessage
      real function AbsVec(v)
      implicit none
      real v(3)                 ! input
      AbsVec = sqrt(v(1)**2 + v(2)**2 + v(3)**2)
      return
      end                       ! AbsVec
      subroutine add2str(s1,s2,s3)
      character s1*(*)          ! input
      character s2*(*)          ! input
      character s3*(*)          ! output
      integer   L1
      integer   L2
      integer   L3
      character h*4096
      integer   lh
      L1 = len(s1)
      L3 = len(s3)
      if(L1.gt.L3) then
        s3 = s1(1:L3)
      else
        L2 = len(s2)
        lh = min(len(h),l3)
        if(L1+L2+1.gt.LH) then
          H = s1(1:L1)//' '//s2(1:L3-L1+1-1)
          s3 = H(1:lH)
        else
          H = s1(1:L1)//' '//s2(1:L2)
          s3 = H(1:L1+L2+1)
        endif
      endif
      return
      end                       ! add2str
      subroutine AddVecUniqueI(v,vlist,size,position,new)
      integer v(3)              ! input
      integer vlist(3,*)        ! input/output
      integer size              ! input/output
      integer position              ! output
      logical new               ! output
      call PosVecI(v,vlist,size,position)
      if(position.ne.0) then
        new = .false.
        return
      else
        size = size + 1
        call saveVecI(v,vlist,size)
        position = size
        new = .true.
      endif
      return
      end                       ! AddVecUniqueI
      real function AngV2(v,w)
      implicit none
      real    v(3)                 ! input
      real    w(3)                 ! input
      real    AbsVec
      real    ScalProd
      real    myacos
      logical OutputToScreen
      logical InputFromKeyboard
      real    arg
      real    av
      real    aw
      av = absvec(v)
      aw = absvec(w)
      if(av.lt.1.0e-7.or.aw.lt.1.0e-7) then
        call str_write(6,'|v| or |w| < 1.0e-7 in AngV2')
        print *,'v',v,av
        print *,'w',w,aw
        call str_flush
        if(OutputToScreen().and.InputFromKeyboard()) then
          call str_out('Type RETURN to accept 0 as result')
          call str_out('or Quit to abort')
          call operator
        else
          call abort
        endif
        AngV2 = 0.0
      else
        arg = ScalProd(v,w)/(av*aw)
        AngV2 = myacos(arg)
      endif
      return
      end                       ! AngV2
      subroutine append_file(fn,unit,message,error)
      implicit none
      character fn*(*)
      integer   unit
      character message*(*)
      integer   error
      character ROUTINE*(*)
      parameter (ROUTINE='append_file')
      integer   myfileaccess
      external  myfileaccess
      character filename*256
      integer   lf
      call tilde(fn,filename,lf)
      if(lf.eq.0) then
        call str_string(ROUTINE,'empty filename in #',message)
        error = 1
        return
      endif
      call get_lun(unit,error)
      if(error.ne.0) then
        call str_2string(ROUTINE,filename(1:lf),
     +       'No free unit in # for #',message)
        return
      endif
      if(myfileaccess(filename(1:lf),' ').eq.0) then ! if file exists
        if(myfileaccess(filename(1:lf),'w').eq.0) then ! if writeable
          open(unit=unit,file=filename(1:lf),status='old',
     +         iostat=error,access='append')
        else
          error = 1
        endif
        if(error.ne.0) then
          call str_integer(error,'Error # appending #',message)
        else
          message = 'Appending to #'
        endif
      else
        open(unit=unit,file=filename(1:lf),status='new',iostat=error)
        if(error.ne.0) then
          call str_integer(error,'Error # creating #',message)
        else
          message = 'Created #'
        endif
      endif
      call str_string(filename(1:lf),message,message)
      return
      end                       ! append_file
      subroutine applyhtmlfilter(s,t)
      character s*(*)           ! input
      character t*(*)           ! output
      character local*4096
      call str_substitute(s,'&;','&amp;;',local)
      call str_substitute(local,'<;','&lt;;',local)
      call str_substitute(local,'>;','&gt;;',t)
      return
      end                       ! applyhtmlfilter
      real function Atan2AJMD(sina_glob,cosa_glob)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      real      sina_glob
      real      cosa_glob
      real      minimal
      parameter (minimal = 1.0E-30)
      real      sina
      real      cosa
      real      a
      sina = sina_glob
      cosa = cosa_glob
      if(ABS(cosa).lt.minimal) cosa = minimal
      a = atan(sina / cosa) ! note that only the RATIO sina/cosa matters
      IF(cosa.lt.0.0) then
        IF(a.gt.0.0) then
          a = a - Pi
        else
          a = a + Pi
        endif
      endif
      Atan2AJMD = a
      return
      end                       ! Atan2ajmd
      real function between(x,y)
      real x                    ! input
      real y                    ! input
      real result
      real y2
      if(x.ge.-y.and.x.lt.y) then
        between = x
      else
        y2 = 2*y
        result = mod(x,y2)
        if(result.ge.y) then
          result = result - y2
        else if(result.lt.-y) then
          result = result + y2
        endif
        between = result
      endif
      return
      end                       ! Between
      real*8 function betweend(x,y)
      real*8 x                    ! input
      real*8 y                    ! input
      real*8 result
      real*8 y2
      if(x.ge.-y.and.x.lt.y) then
        betweend = x
      else
        y2 = 2*y
        result = mod(x,y2)
        if(result.ge.y) then
          result = result - y2
        else if(result.lt.-y) then
          result = result + y2
        endif
        betweend = result
      endif
      return
      end                       ! Betweend
      subroutine Build_file(in,name,typ,outfinal,lo)
      implicit none
      character IN*(*)         !I: inputfilename
      character NAME*(*)       !I: name if inputfilename is nameless
      character TYP*(*)        !I: type if inputfilename is typeless
      character OUTFINAL*(*)   !O: result
      integer   LO             !O: length out
      integer   length
      character string*256
      integer   ls
      integer   ip
      character out*256
      ip = 0
      call filescan(IN,'PATH',string,ls)
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      call filescan(IN,'NAME',string,ls)
      if(ls.eq.0) then
        ls = length(NAME)
        if(ls.gt.0) string = NAME(1:ls)
      endif
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      call filescan(IN,'TYPE',string,ls)
      if(ls.le.1) then
        if(length(TYP).eq.0) then
          string = '.'
          ls = 0
        else
          if(TYP(1:1).eq.'.') then
            string = TYP
          else
            string = '.'//TYP
          endif
          ls = length(string)
        endif
      endif
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      call filescan(IN,'VERSION',string,ls)
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      outfinal = out
      LO = ip
      return
      end                       ! build_file
      subroutine build_file_type(IN,NAME,TYP,OUTFINAL,LO)
      implicit none
      character IN*(*)         !I: inputfilename
      character NAME*(*)       !I: name if inputfilename is nameless
      character TYP*(*)        !I: type
      character OUTFINAL*(*)   !O: result
      integer   LO             !O: length result
      integer   length
      character string*256
      integer   ls
      integer   ip
      character out*256
      ip = 0
      call filescan(IN,'PATH',string,ls)
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      call filescan(IN,'NAME',string,ls)
      if(ls.eq.0) then
        ls = length(NAME)
        if(ls.gt.0) string = name(1:ls)
      endif
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      if(length(TYP).eq.0) then
        string = '.'
        ls = 0
      else
        if(TYP(1:1).eq.'.') then
          string = TYP
        else
          string = '.'//TYP
        endif
        ls = length(string)
      endif
      if(ls.gt.0) then
        OUT(ip+1:) = string(1:ls)
        ip = ip + ls
      endif
      outfinal = out
      LO = ip
      return
      end                       ! build_file_type
      subroutine BuildMatrix(m11,m12,m13,m21,m22,m23,m31,m32,m33,m)
      real m11,m12,m13          ! input
      real m21,m22,m23          ! input
      real m31,m32,m33          ! input
      real m(3,3)               ! output
      m(1,1) = m11
      m(1,2) = m12
      m(1,3) = m13
      m(2,1) = m21
      m(2,2) = m22
      m(2,3) = m23
      m(3,1) = m31
      m(3,2) = m32
      m(3,3) = m33
      return
      end                       ! BuildMatrix
      subroutine BuildVector(v1,v2,v3,v)
      real v1                   ! input
      real v2                   ! input
      real v3                   ! input
      real v(3)                 ! output
      v(1) = v1
      v(2) = v2
      v(3) = v3
      return
      end                       ! BuildVector
      subroutine BuildVectorI(v1,v2,v3,v)
      integer v1                ! input
      integer v2                ! input
      integer v3                ! input
      integer v(3)              ! output
      v(1) = v1
      v(2) = v2
      v(3) = v3
      return
      end                       ! BuildVectorI
      subroutine ccaction_pop
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      if (stackp.eq.0) then
        print *,'DBG> CC Stack underflow'
        action=0
        return
      end if
      action=stack(stackp)
      stackp=stackp-1
      return
      end
      subroutine ccaction_print
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      integer i
      call str_flush
      do i=1,stackp
        call str_2integer_out(i,stack(i),'stack(#)=#')
      enddo
      call str_integer_out(action,'action=#')
      call str_flush
      return
      end
      subroutine ccaction_push(i)
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      integer i
      if (stackp.eq.10) then
        print *,'DBG> CC Stack overflow'
        call ccaction_print
        action=i
        return
      end if
      stackp=stackp+1
      stack(stackp)=action
      action=i
      return
      end
      subroutine ccself
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      selfinterrupt = selfinterrupt + 1
      return
      end
      subroutine CellDim(d,a,al)
      implicit none
      real d(3,3)               ! input direct axes matrix
      real a(3)                 ! output: a,b and c
      real al(3)                ! output: alpha, beta and gamma in radians
      real absvec
      real scalprod
      real myacos
      real v1(3)
      real v2(3)
      real v3(3)
      real f
      real f1
      real f2
      call Row2Vec(1,d,v1)
      call Row2Vec(2,d,v2)
      call Row2Vec(3,d,v3)
      a(1)  = absvec(v1)
      a(2)  = absvec(v2)
      a(3)  = absvec(v3)
      f1 = scalprod(v2,v3)
      f2 = a(2)*a(3)
      f = f1/f2
      al(1) = myacos(f)
      f1 = scalprod(v3,v1)
      f2 = a(3)*a(1)
      f = f1/f2
      al(2) = myacos(f)
      f1 = scalprod(v1,v2)
      f2 = a(1)*a(2)
      f = f1/f2
      al(3) = myacos(f)
      return
      end                       ! CellDim
      subroutine CellDimStar(r,as,als)
      implicit none
      real r(3,3)               ! input:  reciprocal axes matrix
      real as(3)                ! output: as, bs and cs
      real als(3)               ! output: alphas, betas and gammas in radians
      real absvec
      real scalprod
      real v1(3)
      real v2(3)
      real v3(3)
      call Col2Vec(1,r,v1)
      call Col2Vec(2,r,v2)
      call Col2Vec(3,r,v3)
      as(1)  = absvec(v1)
      as(2)  = absvec(v2)
      as(3)  = absvec(v3)
      als(1) = acos( scalprod(v2,v3)/(as(2)*as(3)) )
      als(2) = acos( scalprod(v3,v1)/(as(3)*as(1)) )
      als(3) = acos( scalprod(v1,v2)/(as(1)*as(2)) )
      return
      end                       ! CellDimStar
      subroutine Col2Vec(ColumnNumber,m,v)
      implicit none
      integer ColumnNumber      ! input
      real    m(3,3)            ! input
      real    v(3)              ! output
      integer i
      character message*80
      if(ColumnNumber.lt.1.or.ColumnNumber.gt.3) then
        call str_integer(ColumnNumber,'Col2Vec #',message)
        call AbortMessage(message)
      endif
      do i=1,3
        v(i) = m(i,ColumnNumber)
      enddo
      return
      end                       ! Col2Vec
      subroutine commandadd(command,hid,ier)
      character command*(*)
      logical   hid  ! true=hidden
      integer   ier
      integer   maxcommand
      parameter (maxcommand=1000)
      integer   ncommand
      logical   doCommandCorrect
      logical   doOptionCorrect
      integer   correctlevel
      integer   lcl(maxcommand)
      logical   hidden(maxcommand)
      real      sl(maxcommand)
      common /common_command/ ncommand,doCommandCorrect,doOptionCorrect,
     + correctlevel,lcl,hidden,sl
      character commandlist(maxcommand)*40
      common /common_commandchar/ commandlist
      integer   i
      do i=1,ncommand
        if(command.eq.commandlist(i)) then
          ier = 0
          return
        endif
      enddo
      if(ncommand.ge.maxcommand) then
        call str_integer_out(maxcommand,'Too many commands. Max=#')
        ier = 1
      else
        ncommand = ncommand + 1
        commandlist(ncommand) = command
        hidden(ncommand) = hid
        ier = 0
      endif
      return
      end
      subroutine commandfinish(OutputLevel,nresult)
      integer OutputLevel
      integer nresult
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   maxcommand
      parameter (maxcommand=1000)
      integer   ncommand
      logical   doCommandCorrect
      logical   doOptionCorrect
      integer   correctlevel
      integer   lcl(maxcommand)
      logical   hidden(maxcommand)
      real      sl(maxcommand)
      common /common_command/ ncommand,doCommandCorrect,doOptionCorrect,
     + correctlevel,lcl,hidden,sl
      character commandlist(maxcommand)*40
      common /common_commandchar/ commandlist
      integer   length
      integer   i
      integer   L
      if(OutputLevel.ge.OutputFull) then
        call str_num_out(ncommand,'# command^')
      endif
      if(ncommand.gt.0) then
        do i=1,ncommand
          if(hidden(i)) then
            call str_expandconcat(commandlist(i),'HIDDEN')
          endif
        enddo
        call sort_char(ncommand,commandlist)
        do i=1,ncommand
          L = length(commandlist(i))
          hidden(i) = .false.
          lcl(i) = L
          if(L.gt.6) then
            if(commandlist(i)(L-5:L).eq.'HIDDEN') then
              hidden(i) = .true.
              commandlist(i) = commandlist(i)(1:L-6)
              lcl(i) = L-6
            endif
          endif
        enddo
      endif
      if(OutputLevel.ge.Outputdebug) then
        do i=1,ncommand
          call str_out(commandlist(i)(1:lcl(i)))
          if(hidden(i)) call str_out('(HIDDEN)')
        enddo
      endif
      nresult = ncommand
      return
      end                       ! commandfinish
      subroutine commandinit
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   maxcommand
      parameter (maxcommand=1000)
      integer   ncommand
      logical   doCommandCorrect
      logical   doOptionCorrect
      integer   correctlevel
      integer   lcl(maxcommand)
      logical   hidden(maxcommand)
      real      sl(maxcommand)
      common /common_command/ ncommand,doCommandCorrect,doOptionCorrect,
     + correctlevel,lcl,hidden,sl
      character commandlist(maxcommand)*40
      common /common_commandchar/ commandlist
      ncommand = 0
      correctlevel=outputnormal
      doCommandCorrect = .false.
      doOptionCorrect = .false.
      return
      end                       ! commandinit
      subroutine commandload(OutputLevel,name,nresult)
      integer   OutputLevel
      character name*(*)
      integer   nresult
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   maxcommand
      parameter (maxcommand=1000)
      integer   ncommand
      logical   doCommandCorrect
      logical   doOptionCorrect
      integer   correctlevel
      integer   lcl(maxcommand)
      logical   hidden(maxcommand)
      real      sl(maxcommand)
      common /common_command/ ncommand,doCommandCorrect,doOptionCorrect,
     + correctlevel,lcl,hidden,sl
      character commandlist(maxcommand)*40
      common /common_commandchar/ commandlist
      integer   length
      character fullname*256
      integer   ln
      character message*256
      integer   ier
      character line*256
      integer   ll
      character field*80
      integer   lf
      integer   unit
      character myname*80
      call commandinit
      nresult = 0
      call config_path(line,ln)
      if(length(name).gt.0) then
        myname = name
      else
        call image_name(myname,ln)
      endif
      call path_join(line,myname,fullname)
      call Build_File_Type(fullname,' ','.commands',fullname,ln)
      call open_file(fullname,unit,message,ier)
      if(ier.ne.0) then
        call str_out(message)
        return
      endif
      read(unit,100,iostat=ier) line
  100 format(a)
      do while(ier.eq.0)
        ll = length(line)
        do while(ll.gt.0)
          call str_header(line(1:ll),field,lf,line,ll)
          call commandadd(field,.false.,ier)
          if(ier.ne.0) goto 900
        enddo
        read(unit,100,iostat=ier) line
      enddo
  900 continue
      close(unit)
      call commandfinish(OutputLevel,nresult)
      return
      end                       ! commandload
      subroutine commandreturn(n,s,ls,hid)
      integer   n
      character s*(*)
      integer   ls
      logical   hid
      integer   maxcommand
      parameter (maxcommand=1000)
      integer   ncommand
      logical   doCommandCorrect
      logical   doOptionCorrect
      integer   correctlevel
      integer   lcl(maxcommand)
      logical   hidden(maxcommand)
      real      sl(maxcommand)
      common /common_command/ ncommand,doCommandCorrect,doOptionCorrect,
     + correctlevel,lcl,hidden,sl
      character commandlist(maxcommand)*40
      common /common_commandchar/ commandlist
      data ncommand /0/
      data correctlevel /0/
      data doCommandCorrect,doOptionCorrect /.false.,.false./
      if(ncommand.eq.0) then
        s = ' '
        ls = 0
        hid = .false.
      else
        if(n.gt.0.and.n.le.ncommand) then
          s = commandlist(n)
          ls = lcl(n)
          hid = hidden(n)
        else
          s = ' '
          ls = 0
          hid = .false.
        endif
      endif
      return
      end                       ! commandreturn
      block data common_imagenameXXX
      integer MyImageNameLength
      integer MyImageReleaseLength
      integer MyImageVersion
      common / common_imagename/ MyImageNameLength,MyImageReleaseLength,
     + MyImageVersion
      data MyImageNameLength,MyImageReleaseLength,MyImageVersion
     +  /0,0,0/
      end ! block data common_imagenameXXX
      subroutine config_path(path,lp)
      implicit none
      character path*(*)
      integer   lp
      integer   length
      character name*80
      integer   ln
      character configname*80
      integer   lcn
      logical   exist
      character line*80
      integer   ll
      call image_name(name,ln)
      call get_logical(name,line)
      ll = length(line)
      if(ll.eq.0) then
        call build_file('/usr/local/lib/',name(1:ln),' ',
     1   configname,lcn)
        inquire(file=configname(1:lcn),exist=exist)
        if(exist) then
          path = configname(1:lcn)//'/'
          lp = lcn+1
        else
          call build_file('/usr/global/lib/',name(1:ln),' ',
     1     configname,lcn)
          inquire(file=configname(1:lcn),exist=exist)
          if(exist) then
            path = configname(1:lcn)//'/'
            lp = lcn+1
          else
            call image_path(path,lp)
          endif
        endif
      else
        if(line(ll:ll).eq.'/') then
          path = line(1:ll)
          lp = ll
        else
          path = line(1:ll)//'/'
          lp = ll + 1
        endif
      endif
      return
      end                       ! config_path
      subroutine copy2str(s1,s2,s3)
      character s1*(*)          ! input
      character s2*(*)          ! input
      character s3*(*)          ! output
      integer   L1
      integer   L2
      integer   L3
      character h*4096
      integer   lh
      integer   t2
      L1 = len(s1)
      L3 = len(s3)
      if(L1.gt.L3) then
        s3 = s1(1:L3)
      else
        L2 = len(s2)
        LH = min(len(h),l3)
        if(L1+L2.gt.LH) then
          T2 = min(l2,LH-L1+1)
          h = s1(1:L1)//s2(1:T2)
          s3 = h(1:lh)
        else
          h = s1(1:L1)//s2(1:L2)
          s3 = h(1:L1+L2)
        endif
      endif
      return
      end                       ! copy2str
      subroutine CopyMat(r,s)
      implicit none
      real r(3,3)               ! input
      real s(3,3)               ! output
      integer i
      integer j
      do j=1,3
        do i=1,3
          s(i,j) = r(i,j)
        enddo
      enddo
      return
      end                       ! CopyMat
      subroutine copystr(s1,s2)
      character s1*(*)          ! input
      character s2*(*)          ! output
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      integer   maxline
      parameter (maxline=4096)
      character ROUTINE*(*)
      parameter (ROUTINE='copystr')
      integer   L
      character line*(maxline)
      if(boundcheck.and.len(s1).gt.len(s2)) then
        call str_flush
        call str_out('string bound error in')
        call str_out(ROUTINE)
        call str_flush
        print *,'requested',len(s1)
        print *,'available',len(s2)
        call str_out(s1)
        call str_flush
        call exitfatal
      endif
      L = min(len(s1),len(s2))
      if(l.gt.maxline) then
        call str_2integer(L,maxline,
     +       'Buffer overflow in CopyStr. Requested=# Available=#',line)
        call FatalMessage(line)
      endif
      line = s1(1:L)
      s2 = line(1:L)
      return
      end                       ! copystr
      subroutine CopyVec(u,v)
      implicit none
      real u(3)                 ! input
      real v(3)                 ! output
      v(1) = u(1)
      v(2) = u(2)
      v(3) = u(3)
      return
      end                       ! CopyVec
      subroutine CopyVecFI(u,v)
      implicit none
      real    u(3)              ! input
      integer v(3)              ! output
      v(1) = nint(u(1))
      v(2) = nint(u(2))
      v(3) = nint(u(3))
      return
      end                       ! CopyVecFI
      subroutine CopyVecI(u,v)
      implicit none
      integer u(3)              ! input
      integer v(3)              ! output
      v(1) = u(1)
      v(2) = u(2)
      v(3) = u(3)
      return
      end                       ! CopyVecI
      subroutine CopyVecIF(u,v)
      implicit none
      integer u(3)              ! input
      real    v(3)              ! output
      v(1) = float(u(1))
      v(2) = float(u(2))
      v(3) = float(u(3))
      return
      end                       ! CopyVecIF
      real function cpusec()
      implicit none
      integer  msec
      common /my___timer/ msec
      data msec /0/
      integer  cpu
      call get___cputime(cpu)
      cpusec = 0.01 *(float(cpu-msec)+0.5)
      return
      end                       ! cpusec
      character*13 function cputime()
      implicit none
      character sec2time*13
      real      cpusec
      external  cpusec
      character c*13
      c = sec2time(cpusec())
      cputime = c
      return
      end                       ! cputime
      subroutine create_directory(string,ier)
      implicit none
      character string*(*)
      integer   ier
      character s*256
      integer   ls
      logical   exist
      call tilde(string,s,ls)
      if(ls.eq.0) then
        ier = -1
        return
      endif
      inquire(file=s(1:ls),exist=exist)
      if(exist) then
        ier = 1
        return
      endif
      call spawn('mkdir '//s(1:ls),ier)
      return
      end                       ! create_directory
      subroutine create_file(fn,unit,message,error)
      implicit none
      character fn*(*)
      integer   unit
      character message*(*)
      integer   error
      character ROUTINE*(*)
      parameter (ROUTINE='create_file')
      logical FileExists
      logical   overwrite
      common /common___files/ overwrite
      character filename*256
      integer   lf
      data overwrite /.false./
      call tilde(fn,filename,lf)
      if(lf.eq.0) then
        call str_string(ROUTINE,'empty filename in #',message)
        error = 1
        return
      endif
      call get_lun(unit,error)
      if(error.ne.0) then
        call str_2string(ROUTINE,filename(1:lf),
     +       'No free unit in # for #',message)
        return
      endif
      if(.not.overwrite) then
        call rename_unique_file(filename(1:lf),message,error)
        if(error.ne.0) return
      else
        if(FileExists(filename(1:lf))) then
          call delete_file(filename(1:lf),message,error)
          if(error.ne.0) return
        endif
      endif
      open(unit=unit,file=filename(1:lf),status='new',iostat=error)
      if(error.ne.0) then
        message = 'Error # creating #'
        call str_integer(error,message,message)
      else
        message = 'Created #'
      endif
      call str_string(filename(1:lf),message,message)
      return
      end                       ! create_file
      subroutine create_overwrite(new,old)
      implicit none
      logical new
      logical old
      logical   overwrite
      common /common___files/ overwrite
      logical tmp
      tmp = new
      old = overwrite
      overwrite = tmp
      return
      end                       ! create_overwrite
      character*20 function datetime()
      implicit none
      character rolex*10
      character today*11
      character roltmp*10
      roltmp=rolex()
      datetime = today()//roltmp(1:9)
      return
      end                       ! datetime
      subroutine delete_file(fn,message,ier)
      implicit none
      character fn*(*)
      character message*(*)
      integer   ier
      integer   unit
      character filename*256
      integer   lf
      call tilde(fn,filename,lf)
      if(lf.eq.0) then
        message = 'empty filename in delete_file'
        ier = 1
        return
      endif
      call get_lun(unit,ier)
      if(ier.ne.0) then
        message = 'No free unit in delete_file'
        return
      endif
      open(unit=unit,file=filename(1:lf),status='old',iostat=ier)
      if(ier.ne.0) then
        message = 'error # opening #'
        call str_integer(ier,message,message)
        call str_string(filename(1:lf),message,message)
        return
      endif
      close(unit=unit,status='delete',iostat=ier)
      if(ier.ne.0) then
        close(unit)
        message = 'Error # deleting #'
        call str_integer(ier,message,message)
        call str_string(filename(1:lf),message,message)
        return
      endif
      ier = 0
      call str_string(filename(1:lf),'Deleted #',message)
      return
      end                       ! delete_file
      subroutine DifVec(u,v,w)
      implicit none
      real u(3)                 ! input
      real v(3)                 ! input
      real w(3)                 ! output
      w(1) = u(1) - v(1)
      w(2) = u(2) - v(2)
      w(3) = u(3) - v(3)
      return
      end                       ! DifVec
      subroutine directory(code,name1,name2,ier) ! sorted
      implicit none
      integer   code
      character name1*(*)
      character name2*(*)
      integer   ier
      integer   maxnn
      parameter (maxnn= 100)
      integer   maxlen
      parameter (maxlen=128)
      integer   length
      integer   n
      integer   nn
      character names(maxnn)*(maxlen)
      logical   scratchdir
      character dirname*80
      integer   direrr
      integer   l2
      integer   unit
      character s1*80
      character s2*80
      character command*80
      character message*256
      integer   i
      character u*80
      logical   debug
      integer   li
      save n,nn,names,scratchdir,unit,dirname,debug
      debug = .false.
      if(code.eq.0) then
        call getenv('DEBUGDIR',s1)
        debug =  (length(s1).gt.0)
        if(debug) then
          call str_string_out(s1,'s1=[#]')
          call str_string_write(6,name1,'start with #')
        endif
        scratchdir = .false.
        unit = 0 ! prevent compiler warning
        nn = 0
        call directorynosort(0,name1,name2,direrr)
        do while(direrr.eq.0)
          if(debug) then
            call str_string_write(6,name2,'name2=#')
          endif
          l2 = length(name2)
          nn = nn + 1
          if(scratchdir) then
            write(unit,500) name2(1:l2)
  500       format(a)
          else
            if(l2.gt.maxlen.or.nn.gt.maxnn) then
              call mytmpdir(dirname)
              call uniquename(u)
              if(debug) then
                call str_out(dirname)
              endif
              call str_string(u,'#dirlis.out',s1)
              call str_string(u,'#dirlis.sor',s2)
              call path_join(dirname,s1,s1)
              call path_join(dirname,s2,s2)
              if(debug) then
                call str_string_write(6,s1,'Go into file mode:#')
                call operator
              endif
              call create_file(s1,unit,message,ier)
              if(ier.ne.0) then
                call str_flush
                call str_write(6,message)
                call str_num_write(6,nn,
     +               'directorysearch continued with # file^.')
                goto 100        ! ignore the rest
              endif
              scratchdir = .true.
              do i=1,maxnn
                li = length(names(i))
                write(unit,500) names(i)(1:li)
              enddo
              write(unit,500) name2(1:l2)
            else
              names(nn) = name2
            endif
          endif
          call directorynosort(1,name1,name2,direrr)
        enddo
  100   continue
        call directorynosort(-1,name1,name2,direrr)
        if(debug) then
          call str_num_write(6,nn,'Found # file^')
        endif
        if(nn.gt.0) then
          if(scratchdir) then
            close(unit)
            call str_2string(s1,s2,'sort < # > #',command)
            if(debug) then
              call str_string_write(6,command,'command=#')
            endif
            call spawn(command,ier)
            if(ier.ne.0) then
              call str_flush
              call str_string_write(6,command,'Cannot execute #')
              return
            endif
            call delete_file(s1,message,ier)
            if(ier.ne.0.or.debug) then
              call str_flush
              call str_write(6,message)
            endif
            if(ier.ne.0) return
            call open_file(s2,unit,message,ier)
            if(ier.ne.0.or.debug) then
              call str_flush
              call str_write(6,message)
            endif
            if(ier.ne.0) return
            n = 0
          else
            call sort_char(nn,names)
            n = 0
          endif
        else
          ier = 1
          return
        endif
      endif
      if(code.eq.0.or.code.eq.1) then
        n = n + 1
        if(debug) then
          call str_2integer_out(n,nn,'file # out of #')
        endif
        if(scratchdir) then
          read(unit,500,iostat=ier) name2
        else
          if(n.le.nn) then
            name2 = names(n)
            ier = 0
          else
            ier = 1
          endif
        endif
        if(debug) then
          call str_string_out(name2,'[#]')
          call str_integer_out(ier,'ier=#')
        endif
      else
        if(scratchdir) then
          if(debug) then
            call str_write(6,'deleting scratchfile')
          endif
          close(unit,status='delete')
        endif
        if(debug) then
          call str_write(6,'finished')
        endif
      endif
      return
      end                       ! directory
      subroutine directorycount(wild,n)
      character wild*(*)
      integer   n
      integer   length
      character result*256
      integer   ier
      integer   lr
      n = 0
      call directorynosort(0,wild,result,ier)
      do while(ier.eq.0)
        lr = length(result)
        if(result(lr:lr).ne.'~') then
          n = n + 1
        endif
        call directorynosort(1,wild,result,ier)
      enddo
      call directorynosort(-1,wild,result,ier)
      return
      end                       ! directorycount
      subroutine directorynosort(code,name1,name2,ier)
      implicit none
      integer   code
      character name1*(*)
      character name2*(*)
      integer   ier
      integer   diropen
      integer   dirmatchfile
      external  diropen
      external  dirmatchfile
      integer   nl2
      character string*512
      integer   ls
      character path*512
      integer   lp
      if(code.eq.0) then
        call filescan(name1,'PATH',path,lp)
        if (lp.eq.0) then
          ier = diropen('.')
        else
          ier = diropen(path(1:lp))
        endif
        if (ier.ne.0) return
      endif
      if(code.eq.0.or.code.eq.1) then
        call filescan(name1,'PATH',path,lp)
        call filescan(name1,'FILE',string,ls)
        if (ls.eq.0) then
          ls=1
          string='*'
        endif
   10   continue
        ier=dirmatchfile(string(1:ls),name2,nl2)
        if(ier.eq.0) then
          if(name2(1:1).eq.'.') goto 10
        endif
        if(lp.gt.0.and.ier.eq.0) then
          call copy2str(path(1:lp),name2(1:nl2),name2)
        endif
      else
        call dirlastfile()
      endif
      return
      end                       ! directorynosort
      subroutine directorySort(code,how,name1,name2,ier) ! special sort
      implicit none
      integer   code
      integer   how
      character name1*(*)
      character name2*(*)
      integer   ier
      character ROUTINE*(*)
      parameter (ROUTINE='DirectorySort')
      integer   maxnn
      parameter (maxnn= 100)
      integer   maxlen
      parameter (maxlen=128)
      logical   debug
      parameter (debug=.false.)
      integer   length
      integer   filetime
      integer   filesize
      external  filetime
      external  filesize
      integer   n
      integer   nn
      character names(maxnn)*(maxlen)
      integer   fields(maxnn)
      integer   indx(maxnn)
      integer   sortfield
      logical   scratchdir
      character dirname*80
      integer   direrr
      integer   l
      integer   l2
      integer   unit
      character s1*80
      character s2*80
      character command*80
      character message*256
      integer   i
      logical   reverse
      character u*80
      save n,nn,names,fields,indx,scratchdir,unit
      reverse = (how.eq.2.or.how.eq.4.or.how.eq.6)
      if(code.eq.0) then
        if(debug) then
          call str_out(ROUTINE)
          call str_string_out(name1,'started with [#]')
          call str_integer_out(how,'how=#')
        endif
        scratchdir = .false.
        unit = 0 ! prevent compiler warning
        nn = 0
        call directorynosort(0,name1,name2,direrr)
        do while(direrr.eq.0)
          if(debug) then
            call str_flush
            call str_string_out(name2,'found')
          endif
          l2 = length(name2)
          if(name2(l2:l2).ne.'~') then
            nn = nn + 1
            if(how.eq.1) then
              sortfield = filetime(1,name2(1:l2))
            else if(how.eq.2) then
              sortfield = filetime(1,name2(1:l2))
            else if(how.eq.3) then
              sortfield = filesize(name2(1:l2))
            else if(how.eq.4) then
              sortfield = filesize(name2(1:l2))
            else
              sortfield = 0
            endif
            if(debug) then
              call str_integer_out(sortfield,'sort=#')
            endif
            if(scratchdir) then
              write(unit,600) sortfield,name2(1:l2)
  600         format(i10,1x,a)
            else if(l2.gt.maxlen.or.nn.gt.maxnn) then
              call mytmpdir(dirname)
              call uniquename(u)
              call str_string(u,'#dirlis.out',s1)
              call str_string(u,'#dirlis.sor',s2)
              call path_join(dirname,s1,s1)
              call path_join(dirname,s2,s2)
              if(debug) then
                call str_string_out(s1,'Go into file mode:#')
              endif
              call create_file(s1,unit,message,ier)
              if(ier.ne.0) then
                call str_flush
                call str_write(6,message)
                call str_num_write(6,nn,
     +               'directorysearch continued with # file^.')
                goto 100        ! ignore the rest
              endif
              scratchdir = .true.
              do i=1,maxnn
                l = length(names(i))
                write (unit,600) fields(i),names(i)(1:l)
              enddo
              write(unit,600) sortfield,name2(1:l2)
            else
              fields(nn) = sortfield
              names(nn) = name2
            endif
          endif
          call directorynosort(1,name1,name2,direrr)
        enddo
  100   continue
        call directorynosort(-1,name1,name2,direrr)
        if(debug) then
          call str_flush
          call str_num_out(nn,'# file^ found')
          call str_flush
        endif
        if(nn.gt.0) then
          if(scratchdir) then
            close(unit)
            if(reverse) then
              call str_2string(s1,s2,'sort -bnr < # > #',command)
            else
              call str_2string(s1,s2,'sort -bn < # > #',command)
            endif
            if(debug) then
              call str_flush
              call str_string_out(command,'command=#')
            endif
            call spawn(command,ier)
            if(ier.ne.0) then
              call str_flush
              call str_string_write(6,command,'Cannot execute #')
              return
            endif
            call delete_file(s1,message,ier)
            if(ier.ne.0) then
              call str_flush
              call str_write(6,message)
              return
            endif
            call open_file(s2,unit,message,ier)
            if(ier.ne.0) then
              call str_flush
              call str_write(6,message)
              return
            endif
            n = 0
          else
            if(how.le.4) then
              call sort_integer_index(nn,fields,indx)
            else
              call sort_char_index(nn,names,indx)
            endif
            if(debug) then
              if(reverse) then
                do n=nn,1,-1
                  call str_integer_out(fields(indx(n)),'#')
                  call str_out(names(indx(n)))
                  call str_flush
                enddo
              else
                do n=1,nn
                  call str_integer_out(fields(indx(n)),'#')
                  call str_out(names(indx(n)))
                  call str_flush
                enddo
              endif
            endif
            n = 0
          endif
        else
          ier = 1
          return
        endif
      endif
      if(code.eq.0.or.code.eq.1) then
        n = n + 1
        if(scratchdir) then
          read(unit,600,iostat=ier) sortfield,name2
        else
          if(n.le.nn) then
            if(reverse) then
              name2 = names(indx(nn-n+1))
            else
              name2 = names(indx(n))
            endif
            ier = 0
          else
            ier = 1
          endif
        endif
      else
        if(debug) then
          call str_string_out(Routine,'# finished')
          call str_flush
        endif
        if(scratchdir) then
          close(unit,status='delete')
        endif
      endif
      return
      end                       ! directorySort
      subroutine displayc(c)
      character c*1
      call flush(6)
      call cdisplayc(c)
      return
      end                       ! displayc
      subroutine displays(s)
      character s*(*)
      call flush(6)
      call cdisplays(s)
      return
      end                       ! displays
      subroutine editor(string,ier)
      implicit none
      character string*(*)
      integer   ier
      integer   lenstr
      integer   length
      character s*256
      character e*256
      integer   ls
      integer   le
      s = string
      ls = lenstr(string)
      call getenv('EDITOR',e)
      le=length(e)
      if (le.eq.0) then
        e='vi'
        le=2
      endif
      call spawn(e(1:le)//' '//s(1:ls),ier)
      return
      end ! editor
      subroutine eval_add(var,val,message,error)
      character var*(*)
      real      val
      character message*(*)
      integer   error
      integer   maxvar
      parameter (maxvar=100)
      integer   nvar
      integer   mantissa
      real*8    vals(maxvar)
      common/evl___vars/vals,nvar,mantissa
      character vars(maxvar)*20
      common/evl___vars_char/vars
      character uvar*20
      integer   i
      data nvar,mantissa /0,2/
      call str_real_len_get(i)
      mantissa = max(mantissa,i)
      call upcase(var,uvar)
      do i=1,nvar
        if(uvar.eq.vars(i)) then
          vals(i) = val
          error = 0
          call str_string(var,'Changed #=#',message)
          call str_real(val,message,message)
          return
        endif
      enddo
      if(nvar.lt.maxvar) then
        nvar = nvar + 1
        vars(i) = uvar
        vals(i) = val
        call str_string(var,'Added #=#',message)
        call str_real(val,message,message)
        error = 0
      else
        call str_integer(maxvar,'Too many vars. Max=#',message)
        error = 1
      endif
      return
      end                       ! eval_add
      subroutine eval_boolean(boolean,n)
      logical boolean
      integer n
      integer   ifac
      integer   start
      integer   narg
      common/evl___factor/ifac,narg(20),start(20)
      integer   maxarg
      parameter (maxarg=6)
      real*8    f
      common/evl___factor_real/f(20,maxarg)
      if(boolean) then
        if(narg(ifac).eq.n) then
          f(ifac,1) = 1.0d0
        else
          f(ifac,1) = f(ifac,n+1)
        endif
      else
        if(narg(ifac).eq.n) then
          f(ifac,1) = 0.0d0
        else
          f(ifac,1) = f(ifac,n+2)
        endif
      endif
      return
      end                       ! eval_boolean
      real*8 function eval_expression()
      implicit none
      real*8    simple_expression
      integer   pos
      integer   err
      integer   lf
      logical   allow_error
      common/evl___evaluate/pos,err,lf,allow_error
      character form*255
      character ch
      character reason*40
      common/evl___evaluate_char/form,ch,reason
      integer   iexp
      common/evl___expression/iexp
      character opr
      common/evl___expression_char/opr(20)
      real*8    e
      common/evl___expression_real/e(20)
      iexp=iexp+1
      eval_expression = 0.0D0 ! init
      if (iexp.gt.20) then
        reason='too much nesting'
        err=pos
        return
      endif
      e(iexp)=simple_expression()
      if (err.gt.0) return
      do while (ch.eq.'+'.or.ch.eq.'-')
        opr(iexp)=ch
        call eval_nextch
        if (opr(iexp).eq.'+') then
          e(iexp)=e(iexp)+simple_expression()
          if (err.gt.0) return
        else
          e(iexp)=e(iexp)-simple_expression()
          if (err.gt.0) return
        endif
      enddo
      eval_expression=e(iexp)
      iexp=iexp-1
      return
      end !eval_expression
      real*8 function eval_factor()
      implicit none
      real*8 Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.141592653589793D0)
      parameter (TwoPi = 2D0*Pi)
      parameter (PiOver2 = Pi / 2.0D0)
      parameter (Grad = 180.0D0/Pi)
      real*8    eval_expression
      real*8    betweend
      real      angv2
      real      rnd
      integer   pos
      integer   err
      integer   lf
      logical   allow_error
      common/evl___evaluate/pos,err,lf,allow_error
      character form*255
      character ch
      character reason*40
      common/evl___evaluate_char/form,ch,reason
      integer   ifac
      integer   start
      integer   narg
      common/evl___factor/ifac,narg(20),start(20)
      integer   maxarg
      parameter (maxarg=6)
      real*8    f
      common/evl___factor_real/f(20,maxarg)
      character line*20
      common/evl___factor_char/line(20)
      integer   maxvar
      parameter (maxvar=100)
      integer   nvar
      integer   mantissa
      real*8    vals(maxvar)
      common/evl___vars/vals,nvar,mantissa
      character vars(maxvar)*20
      common/evl___vars_char/vars
      integer ipextra
      real*8  f_extra(20)
      common /evl___extradata/ f_extra,ipextra
      character firstnamechars*80
      character namechars*80
      character string*10
      integer   ioerr
      integer   n
      integer   i
      real      v1(3)
      real      v2(3)
      real*4    gausspar(4)
      real*8    arg
      data firstnamechars/'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      data namechars/'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_$'/
      eval_factor = 0.0D0 ! init
      ifac=ifac+1
      if (ifac.gt.20) then
        reason='too much nesting'
        err=pos
        return
      endif
      if (ch.ge.'0'.and.ch.le.'9') then                        ! number
        start(ifac)=pos
        do while (ch.le.'9'.and.ch.ge.'0')
          call eval_nextch
        enddo
        if (ch.eq.'.') then
          call eval_nextch
          do while (ch.le.'9'.and.ch.ge.'0')
            call eval_nextch
          enddo
        endif
        if (ch.eq.'E') then
          call eval_nextch
          call eval_nextch
          do while (ch.le.'9'.and.ch.ge.'0')
            call eval_nextch
          enddo
        endif
        call str_integer(pos-start(ifac),'(F#.0)',string)
        read(form(start(ifac):pos-1),string,iostat=ioerr) f(ifac,1)
        if(ioerr.ne.0) then
          reason='error in constant.'
          err=pos
          return
        endif
      else if(ch.eq.'#') then
        call eval_nextch
        ipextra = ipextra + 1
        f(ifac,1) = f_extra(ipextra)
      else
        if (ch.eq.'(') then                                      ! expressie
          call eval_nextch
          f(ifac,1)=eval_expression()
          if (err.gt.0) return
          if (ch.eq.')') then
            call eval_nextch
          else
            reason='")" expected(1)'
            err=pos
            return
          endif
        else
          if (index(firstnamechars,ch).eq.0) then
            reason='number/func syntax error.'
            err=pos
            return
          endif
          start(ifac)=pos
          do while (index(namechars,ch).gt.0)
            call eval_nextch
          enddo
          line(ifac)=form(start(ifac):pos-1)
          if(line(ifac).eq.'PI') then
            f(ifac,1) = Pi
          else if(line(ifac).eq.'PIOVER2') then
            f(ifac,1) = PiOver2
          else if(line(ifac).eq.'TWOPI') then
            f(ifac,1) = TwoPi
          else if(line(ifac).eq.'GRAD') then
            f(ifac,1) = Grad
          else if(line(ifac).eq.'RND') then
            f(ifac,1) = rnd()
          else if (ch.ne.'(') then
            do i=1,nvar
              if(line(ifac).eq.vars(i)) then
                f(ifac,1) = vals(i)
                goto 10
              endif
            enddo
            call str_string(line(ifac),'variable [#] not found',reason)
            err=pos
            return
 10         continue
          else
            call eval_nextch
            f(ifac,1)=eval_expression()
            if (err.gt.0) return
            narg(ifac) = 1
            do while(ch.eq.',')
              if(narg(ifac).ge.maxarg) then
                reason='too many arguments'
                err=pos
                return
              endif
              call eval_nextch
              narg(ifac)=narg(ifac)+1
              f(ifac,narg(ifac))=eval_expression()
              if (err.gt.0) return
            enddo
            if (ch.eq.')') then
              call EVAL_nextch
            else
              reason='")" expected(2)'//ch
              err=pos
              return
            endif
            if (line(ifac).eq.'ABS') then
              f(ifac,1) = abs(f(ifac,1))
            else if (line(ifac).eq.'ACOSD') then
              if (narg(ifac).ne.1) then
                reason='acosd needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).lt.-1d0.or.f(ifac,1).gt.1d0) then
                reason='acosd-argument error'
                err=pos
                return
              endif
              f(ifac,1)=acos(f(ifac,1))*grad
            else if (line(ifac).eq.'ACOS') then
              if (narg(ifac).ne.1) then
                reason='acos needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).lt.-1d0.or.f(ifac,1).gt.1d0) then
                reason='acos-argument error'
                err=pos
                return
              endif
              f(ifac,1)=acos(f(ifac,1))
            else if (line(ifac).eq.'ANGV2') then
              if (narg(ifac).ne.6) then
                reason='angv2 needs six arguments'
                err=pos
                return
              endif
              if (f(ifac,1).lt.-1d0.or.f(ifac,1).gt.1d0) then
                reason='asind-argument error'
                err=pos
                return
              endif
              do i=1,3
                v1(i) = real(f(ifac,i))
                v2(i) = real(f(ifac,i+3))
              enddo
              f(ifac,1)=angv2(v1,v2)
            else if (line(ifac).eq.'ASIND') then
              if (narg(ifac).ne.1) then
                reason='asind needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).lt.-1d0.or.f(ifac,1).gt.1d0) then
                reason='asind-argument error'
                err=pos
                return
              endif
              f(ifac,1)=asin(f(ifac,1))*Grad
            else if (line(ifac).eq.'ASIN') then
              if (narg(ifac).ne.1) then
                reason='asin needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).lt.-1d0.or.f(ifac,1).gt.1d0) then
                reason='asin-argument error'
                err=pos
                return
              endif
              f(ifac,1)=asin(f(ifac,1))
            else if (line(ifac).eq.'ATAN2D') then
              if (narg(ifac).ne.2) then
                reason='atan2d needs two arguments'
                err=pos
                return
              endif
              f(ifac,1)=atan2(f(ifac,1),f(ifac,2))*Grad
            else if (line(ifac).eq.'ATAN2') then
              if (narg(ifac).ne.2) then
                reason='atan2 needs two arguments'
                err=pos
                return
              endif
              f(ifac,1)=atan2(f(ifac,1),f(ifac,2))
            else if (line(ifac).eq.'ATAND') then
              if (narg(ifac).ne.1) then
                reason='atand needs a single argument'
                err=pos
                return
              endif
              f(ifac,1)=atan(f(ifac,1))*Grad
            else if (line(ifac).eq.'ATAN') then
              if (narg(ifac).ne.1) then
                reason='atan needs a single argument'
                err=pos
                return
              endif
              f(ifac,1)=atan(f(ifac,1))
            else if (line(ifac).eq.'BETWEEN') then
              if (narg(ifac).ne.2) then
                reason='between needs two arguments'
                err=pos
                return
              endif
              f(ifac,1)=betweend(f(ifac,1),f(ifac,2))
            else if (line(ifac).eq.'COSD') then
              if (narg(ifac).ne.1) then
                reason='cosd needs a single argument'
                err=pos
                return
              endif
              f(ifac,1)=cos(f(ifac,1)/Grad)
            else if (line(ifac).eq.'COS') then
              if (narg(ifac).ne.1) then
                reason='cos needs a single argument'
                err=pos
                return
              endif
              f(ifac,1)=cos(f(ifac,1))
            else if(line(ifac).eq.'ENTIER') then
              if (narg(ifac).ne.1) then
                reason='entier needs a single argument'
                err=pos
                return
              endif
              n = int(f(ifac,1))
              if(f(ifac,1).lt.float(n)) n = n - 1
              f(ifac,1) = dble(n)
            else if (line(ifac).eq.'EQ') then
              if (narg(ifac).ne.2.and.narg(ifac).ne.4) then
                reason='eq needs two or four arguments'
                err=pos
                return
              endif
              call eval_boolean( (f(ifac,1).eq.f(ifac,2)),2)
            else if (line(ifac).eq.'EVEN') then
              if (narg(ifac).ne.1.and.narg(ifac).ne.3) then
                reason='even needs one or three arguments'
                err=pos
                return
              endif
              n = nint(f(ifac,1))
              call eval_boolean( (mod(n,2).eq.0),1)
            else if (line(ifac).eq.'EXP') then
              if (narg(ifac).ne.1) then
                reason='exp needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).gt.85.6d0) then
                reason='exp-argument error'
                err=pos
                return
              endif
              f(ifac,1)=exp(f(ifac,1))
            else if (line(ifac).eq.'GAUSS') then
              if (narg(ifac).ne.1) then
                reason='gauss needs a single argument'
                err=pos
                return
              endif
              do i=1,4
                call str_integer(i,'GAUSS#',string)
                call eval_get(string,gausspar(i),err)
                if(err.ne.0) then
                  call str_string(sTRING,'gauss needs variable #',
     +                 reason)
                  err=pos
                  return
                endif
              enddo
              arg = -0.5*(( f(ifac,1)-gausspar(2))/gausspar(3))**2
              f(ifac,1) = gausspar(4) + gausspar(1)*exp(arg)
            else if (line(ifac).eq.'GELE') then
              if (narg(ifac).ne.3.and.narg(ifac).ne.5) then
                reason='gele needs three or five arguments'
                err=pos
                return
              endif
              call eval_boolean(
     +             (f(ifac,1).ge.f(ifac,2).and.f(ifac,1).le.f(ifac,3)),
     +             3)
            else if (line(ifac).eq.'GELT') then
              if (narg(ifac).ne.3.and.narg(ifac).ne.5) then
                reason='gelt needs three or five arguments'
                err=pos
                return
              endif
              call eval_boolean(
     +             (f(ifac,1).ge.f(ifac,2).and.f(ifac,1).lt.f(ifac,3)),
     +             3)
            else if (line(ifac).eq.'GE') then
              if (narg(ifac).ne.2.and.narg(ifac).ne.4) then
                reason='ge needs two or four arguments'
                err=pos
                return
              endif
              call eval_boolean( (f(ifac,1).ge.f(ifac,2)),2)
            else if (line(ifac).eq.'GTLE') then
              if (narg(ifac).ne.3.and.narg(ifac).ne.5) then
                reason='gtle needs three or five arguments'
                err=pos
                return
              endif
              call eval_boolean(
     +             (f(ifac,1).gt.f(ifac,2).and.f(ifac,1).le.f(ifac,3)),
     +             3)
            else if (line(ifac).eq.'GTLT') then
              if (narg(ifac).ne.3.and.narg(ifac).ne.5) then
                reason='gtlt needs three or five arguments'
                err=pos
                return
              endif
              call eval_boolean(
     +             (f(ifac,1).gt.f(ifac,2).and.f(ifac,1).lt.f(ifac,3)),
     +             3)
            else if (line(ifac).eq.'GT') then
              if (narg(ifac).ne.2.and.narg(ifac).ne.4) then
                reason='gt needs two or four arguments'
                err=pos
                return
              endif
              call eval_boolean((f(ifac,1).gt.f(ifac,2)),2)
            else if (line(ifac).eq.'INT') then
              if (narg(ifac).ne.1) then
                reason='int needs a single argument'
                err=pos
                return
              endif
              f(ifac,1)=dble(int(f(ifac,1)))
            else if (line(ifac).eq.'LE') then
              if (narg(ifac).ne.2.and.narg(ifac).ne.4) then
                reason='le needs two or four arguments'
                err=pos
                return
              endif
              call eval_boolean((f(ifac,1).le.f(ifac,2)),2)
            else if (line(ifac).eq.'LOG10') then
              if (narg(ifac).ne.1) then
                reason='log10 needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).le.0d0) then
                reason='log10-argument error'
                err=pos
                return
              endif
              f(ifac,1)=log10(f(ifac,1))
            else if (line(ifac).eq.'LOG2') then
              if (narg(ifac).ne.1) then
                reason='log2 needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).le.0d0) then
                reason='log2-argument error'
                err=pos
                return
              endif
              f(ifac,1)=log10(f(ifac,1))/log10(dble(2.0))
            else if (line(ifac).eq.'LOG') then
              if (narg(ifac).ne.1) then
                reason='log needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).le.0d0) then
                reason='log-argument error'
                err=pos
                return
              endif
              f(ifac,1)=log(f(ifac,1))
            else if (line(ifac).eq.'LT') then
              if (narg(ifac).ne.2.and.narg(ifac).ne.4) then
                reason='lt needs two or four arguments'
                err=pos
                return
              endif
              call eval_boolean((f(ifac,1).lt.f(ifac,2)),2)
            else if (line(ifac).eq.'MAX') then
              do i=2,narg(ifac)
                f(ifac,1) = max(f(ifac,1),f(ifac,i))
              enddo
            else if (line(ifac).eq.'MIN') then
              do i=2,narg(ifac)
                f(ifac,1)=min(f(ifac,1),f(ifac,i))
              enddo
            else if (line(ifac).eq.'MOD') then
              if (narg(ifac).ne.2) then
                reason='mod needs two arguments'
                err=pos
                return
              endif
              f(ifac,1)=mod(f(ifac,1),f(ifac,2))
            else if (line(ifac).eq.'NE') then
              if (narg(ifac).ne.2.and.narg(ifac).ne.4) then
                reason='eq needs two or four arguments'
                err=pos
                return
              endif
              call eval_boolean( (f(ifac,1).ne.f(ifac,2)),2)
            else if (line(ifac).eq.'NINT') then
              if (narg(ifac).ne.1) then
                reason='nint needs a single argument'
                err=pos
                return
              endif
              f(ifac,1)=dble(nint(f(ifac,1)))
            else if (line(ifac).eq.'ODD') then
              if (narg(ifac).ne.1.and.narg(ifac).ne.3) then
                reason='odd needs one or three arguments'
                err=pos
                return
              endif
              n = nint(f(ifac,1))
              call eval_boolean((mod(n,2).ne.0),1)
            else if (line(ifac).eq.'PLOG10') then
              if (narg(ifac).ne.1) then
                reason='plog10 needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).le.1d0) then
                f(ifac,1)=0d0
              else
                f(ifac,1)=log10(f(ifac,1))
              endif
            else if (line(ifac).eq.'PLOG2') then
              if (narg(ifac).ne.1) then
                reason='plog2 needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).le.1d0) then
                f(ifac,1)=0d0
              else
                f(ifac,1)=log(f(ifac,1))/log(2.0)
              endif
            else if (line(ifac).eq.'PLOG') then
              if (narg(ifac).ne.1) then
                reason='plog needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).le.1d0) then
                f(ifac,1)=0d0
              else
                f(ifac,1)=log(f(ifac,1))
              endif
            else if (line(ifac).eq.'SIGN') then
              if (narg(ifac).ne.1) then
                reason='sign needs a single argument'
                err=pos
                return
              endif
              f(ifac,1) = sign(1.0d0,f(ifac,1))
            else if (line(ifac).eq.'SIND') then
              if (narg(ifac).ne.1) then
                reason='sind needs a single argument'
                err=pos
                return
              endif
              f(ifac,1)=sin(f(ifac,1)/Grad)
            else if (line(ifac).eq.'SIN') then
              if (narg(ifac).ne.1) then
                reason='sin needs a single argument'
                err=pos
                return
              endif
              f(ifac,1)=sin(f(ifac,1))
            else if (line(ifac).eq.'SQRT') then
              if (narg(ifac).ne.1) then
                reason='sqrt needs a single argument'
                err=pos
                return
              endif
              if (f(ifac,1).lt.0d0) then
                reason='sqrt-argument error'
                err=pos
                return
              endif
              f(ifac,1)=sqrt(f(ifac,1))
            else if (line(ifac).eq.'TAND') then
              if (narg(ifac).ne.1) then
                reason='tand needs a single argument'
                err=pos
                return
              endif
              f(ifac,1)=tan(f(ifac,1)/Grad)
            else if (line(ifac).eq.'TAN') then
              if (narg(ifac).ne.1) then
                reason='tan needs a single argument'
                err=pos
                return
              endif
              f(ifac,1)=tan(f(ifac,1))
            else if (line(ifac).eq.'WITHIN') then
              if (narg(ifac).ne.3) then
                reason='within needs three arguments'
                err=pos
                return
              endif
              if(f(ifac,1).lt.f(ifac,2)) then
                f(ifac,1) = f(ifac,2)
              else if(f(ifac,1).gt.f(ifac,3)) then
                f(ifac,1) = f(ifac,3)
              endif
            else
              reason='unknown function'
              err=pos
              return
            endif
          endif
        endif
      endif
      eval_factor=f(ifac,1)
      ifac=ifac-1
      return
      end !  eval_factor
      subroutine eval_get(var,val,error)
      character var*(*)
      real      val
      integer   error
      integer   maxvar
      parameter (maxvar=100)
      integer   nvar
      integer   mantissa
      real*8    vals(maxvar)
      common/evl___vars/vals,nvar,mantissa
      character vars(maxvar)*20
      common/evl___vars_char/vars
      character uvar*20
      integer   i
      call upcase(var,uvar)
      do i=1,nvar
        if(uvar.eq.vars(i)) then
          val = real(vals(i))
          error = 0
          return
        endif
      enddo
      error = 1
      return
      end                       ! eval_get
      subroutine eval_list
      integer   maxvar
      parameter (maxvar=100)
      integer   nvar
      integer   mantissa
      real*8    vals(maxvar)
      common/evl___vars/vals,nvar,mantissa
      character vars(maxvar)*20
      common/evl___vars_char/vars
      integer   i
      character string*80
      real      f
      call str_real_len_push(mantissa)
      do i=1,nvar
        f = real(vals(i))
        call str_string(vars(i),'#=#',string)
        call str_real_out(real(vals(i)),string)
        call str_flush
      enddo
      call str_real_len_pop
      return
      end                       ! eval_list
      subroutine eval_nextch
      implicit none
      integer   pos
      integer   err
      integer   lf
      logical   allow_error
      common/evl___evaluate/pos,err,lf,allow_error
      character form*255
      character ch
      character reason*40
      common/evl___evaluate_char/form,ch,reason
      character eofline
      character tab
      eofline = char(13)
      tab = char(9)
   10 continue
      pos=pos+1
      if (pos.le.lF) then
        ch=form(pos:pos)
      else
        ch=eofline
      endif
      if (ch.eq.' '.or.ch.eq.tab) goto 10
      return
      end ! eval_nextch
      subroutine eval_remove(var,message,error)
      character var*(*)
      character message*(*)
      integer   error
      integer   maxvar
      parameter (maxvar=100)
      integer   nvar
      integer   mantissa
      real*8    vals(maxvar)
      common/evl___vars/vals,nvar,mantissa
      character vars(maxvar)*20
      common/evl___vars_char/vars
      character uvar*20
      integer   i
      call upcase(var,uvar)
      do i=1,nvar
        if(uvar.eq.vars(i)) then
          call str_string(vars(i),'Removed #',message)
          vars(i) = vars(nvar)
          vals(i) = vals(nvar)
          nvar = nvar - 1
          error = 0
          return
        endif
      enddo
      call str_string(var,'Not found #',message)
      error = 1
      return
      end                       ! eval_remove
      real*8 function eval_term()
      implicit none
      real*8    signedfactor
      integer   pos
      integer   err
      integer   lf
      logical   allow_error
      common/evl___evaluate/pos,err,lf,allow_error
      character form*255
      character ch
      character reason*40
      common/evl___evaluate_char/form,ch,reason
      integer   iter
      common/evl___term/iter
      real*8    t,ff
      common/evl___term_real/t(20),ff(20)
      eval_term = 0.0D0 ! init
      iter=iter+1
      if (iter.gt.20) then
        reason='too much nesting'
        err=pos
        return
      endif
      t(iter)=signedfactor()
      if (err.gt.0) return
      do while (ch.eq.'^')
        call eval_nextch
        ff(iter) = signedfactor()
        if (err.gt.0) return
        if(t(iter).lt.0.0) then
          if (ff(iter).eq.2.0) then
            t(iter)=t(iter)*t(iter)
          else if (ff(iter).eq.3.0) then
            t(iter)=t(iter)*t(iter)*t(iter)
          else
            if(allow_error) then
              t(iter) = 0.0D0
            else
              reason='exp of negative number'
              err = pos
              return
            endif
          endif
        else
          t(iter)=exp(log(t(iter))*ff(iter))
        endif
      enddo
      eval_term=t(iter)
      iter=iter-1
      return
      end ! eval_term
      subroutine evaluate(formula,ZeroOnError,value,errpos,reasonret)
      implicit none
      character formula*(*)
      logical   ZeroOnError
      real      value
      integer   errpos
      character reasonret*(*)
      real*8    value8
      call evaluate8(formula,ZeroOnError,value8,errpos,reasonret)
      value = real(value8)
      return
      end ! evaluate
      subroutine evaluate8(formula,ZeroOnError,value,errpos,reasonret)
      implicit none
      character formula*(*)
      logical   ZeroOnError
      real*8    value
      integer   errpos
      character reasonret*(*)
      integer   length
      real*8    eval_expression
      integer   pos
      integer   err
      integer   lf
      logical   allow_error
      common/evl___evaluate/pos,err,lf,allow_error
      character form*255
      character ch
      character reason*40
      common/evl___evaluate_char/form,ch,reason
      integer   ifac
      integer   start
      integer   narg
      common/evl___factor/ifac,narg(20),start(20)
      integer   maxarg
      parameter (maxarg=6)
      real*8    f
      common/evl___factor_real/f(20,maxarg)
      character line*20
      common/evl___factor_char/line(20)
      integer   iexp
      common/evl___expression/iexp
      character opr
      common/evl___expression_char/opr(20)
      real*8    e
      common/evl___expression_real/e(20)
      integer   isim
      common/evl___simple/isim
      real*8    s
      real*8    s2
      common/evl___simple_real/s(20),s2(20)
      character ops
      common/evl___simple_char/ops(20)
      integer   iter
      common/evl___term/iter
      real*8    t,ff
      common/evl___term_real/t(20),ff(20)
      character eofline
      integer   i
      eofline = char(13)
      allow_error=ZeroOnError
      ifac=0
      isim=0
      iexp=0
      iter=0
      pos=0
      err=0
      errpos=0
      reason=' '
      call upcase(formula,form)
      if (form(1:1).eq.'.') form='0'//form(1:len(form)-1)
      if (form(1:1).eq.'+') form=form(2:)
      do while (index(form,'**').gt.1)
        i=index(form,'**')
        form=form(1:i-1)//'^'//form(i+2:)
      enddo
      lf = length(form)
      call eval_nextch
      value=eval_expression()
      if (err.eq.0.and.ch.ne.eofline) then
        err=pos
        reason='unexpected characters'
      endif
      errpos=err
      reasonret=reason
      return
      end ! evaluate8
      subroutine exiterror(ier)
      integer ier
      if(ier.eq.0) then
        call exitnormal
      else
        call exitfatal
      endif
      end                       ! exiterror
      subroutine exitfatal
      implicit none
      call exit(1)
      end
      subroutine exitnormal
      implicit none
      call exit(0)
      end
      subroutine FacIVec(x,v,w)
      implicit none
      integer x                 ! input
      real    v(3)              ! input
      real    w(3)              ! output
      w(1) = x*v(1)
      w(2) = x*v(2)
      w(3) = x*v(3)
      return
      end                       ! FacIVec
      subroutine FacIVecI(x,v,w)
      implicit none
      integer x                 ! input
      integer v(3)              ! input
      integer w(3)              ! output
      w(1) = x*v(1)
      w(2) = x*v(2)
      w(3) = x*v(3)
      return
      end                       ! FacIVecI
      subroutine FacVec(x,v,w)
      implicit none
      real    x                 ! input
      real    v(3)              ! input
      real    w(3)              ! output
      w(1) = x*v(1)
      w(2) = x*v(2)
      w(3) = x*v(3)
      return
      end                       ! FacVec
      subroutine FatalMessage(s)
      character s*(*)
      call str_flush
      call str_string_out(s,'ERROR: #')
      call str_flush
      call exitfatal
      return
      end                       ! FatalMessage
      logical function FileExists(filename)
      character filename*(*)
      inquire(file=filename,exist=FileExists)
      return
      end
      subroutine filescan(in,field,outfinal,lo)
      implicit none
      character in*(*)    !Input:  input filename
      character field*(*) !Input:
      character outfinal*(*)   !Output: result
      integer   lo        !Output: length of result
      integer   length
      integer   li
      character ufield*2        ! upcase first two chars of field
      integer   nodi            ! endposition of node
      integer   diri            ! endposition of directory
      integer   nami            ! endposition of name
      integer   typi            ! endposition of type
      integer   i
      character out*256
      out = ' '
      lo  = 0
      li = length(in)
      if(li.eq.0) goto 999
      nodi=index(in,':')
      diri = nodi
      do i=nodi+1,li
        if(in(i:i).eq.'/') diri = i
      enddo
      typi = li
      nami = li
      do i=li,diri+1,-1
        if(in(i:i).eq.'.') nami = i-1
      enddo
      call upcase(field(1:2),ufield)
      if(ufield.eq.'NO') then                    ! node
        lo = nodi
        if(lo.gt.0) out = in(1:nodi)
      else if(ufield.eq.'DE') then               ! device
      else if(ufield.eq.'RO') then               ! root
      else if(ufield.eq.'DI') then               ! directory
        lo = diri - nodi
        if(lo.gt.0) out = in(nodi+1:diri)
      else if(ufield.eq.'PA') then               ! path
        lo = diri
        if(lo.gt.0) out = in(1:lo)
      else if(ufield.eq.'NA') then               ! name
        lo = nami-diri
        if(lo.gt.0) out = in(diri+1:nami)
      else if(ufield.eq.'TY') then               ! type
        lo = typi-nami
        if(lo.gt.0) out = in(nami+1:typi)
      else if(ufield.eq.'FI') then               ! file
        lo = typi - diri
        if(lo.gt.0) out = in(diri+1:typi)
      else if(ufield.eq.'FU') then               ! fullfile
        lo = typi - diri
        if(lo.gt.0) out = in(diri+1:typi)
      else if(ufield.eq.'VE') then               ! version
      endif
  999 continue
      outfinal = out
      return
      end                       ! filescan
      subroutine finish(nunit)
      implicit none
      integer   nunit
      if (nunit.le.0) then
        call settime()
        if (nunit.lt.0) then
          call startlog(-nunit,' ')
        endif
      else
        call stoplog(nunit,' ')
      endif
      return
      end                       ! finish
      subroutine finish_exit(unit,message,ier)
      implicit none
      integer   unit
      character message*(*)
      integer   ier
      integer   length
      if(unit.gt.0) then
        call str_flush
        if(length(message).gt.0) call str_write(unit,message)
        call finish(unit)
      endif
      call exiterror(ier)
      end                       ! finish_exit
      subroutine GeneralRotMat(rotvec,phi,rotmat)
      implicit none
      real    rotvec(3)         ! input
      real    phi               ! input
      real    rotmat(3,3)       ! output
      integer normerror
      real    giro(3)
      real    sinphi
      real    cosphi
      real    f
      real    g
      real    h
      integer i
      integer j
      integer k
      call CopyVec(rotvec,giro)
      call NormVec(giro,giro,normerror)
      sinphi = sin(phi)
      cosphi = cos(phi)
      h = 1.0-cosphi
      do i=1,3
        rotmat(i,i) = giro(i)**2 * h + cosphi
        j = mod(i,3) + 1
        k = mod(j,3) + 1
        f = giro(j)*giro(k)*h
        g = giro(i)*sinphi
        rotmat(j,k) = f-g
        rotmat(k,j) = f+g
      enddo
      return
      end                       ! GeneralRotMat
      subroutine get___cputime(value)
      implicit none
      integer value
      real    tarray(2)
      realetime
      value = nint(100.*etime(tarray))
      return
      end                       ! get___cputime
      subroutine get_commandline(nw)
      implicit none
      integer nw
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      character ROUTINE*(*)
      parameter (ROUTINE='get_commandline')
      integer   length
      integeriargc
      integer   halflong
      parameter (halflong=long/2)
      character line(MaxPutBuffer)*(halflong)
      character word*(halflong)
      integer   l,lw
      integer   n
      integer   i
      integer   safethreshold
      safethreshold = long/2
      l=0
      n=1
      line(n)=' '
      nw = iargc()
      call getarg(nw,word)
      if(length(word).eq.0) nw = nw - 1
      do i=1,nw
        call getarg(i,word)
        lw=length(word)
        if (l+1+lw.gt.safethreshold) then
          n=n+1
          if (n.gt.MaxPutBuffer) then
            call str_flush
            call str_string_out(ROUTINE,'Too many arguments')
            call str_flush
            call exitfatal
          endif
          line(n)=' '
          l=0
        endif
        if(l.eq.0) then
          line(n) = word
          l = lw
        else
          line(n)(l+1:l+1) = ' '
          line(n)(l+2:)=word
          l=l+lw+1
        endif
      enddo
      do i=n,1,-1
        l=length(line(i))
        if(l.gt.0) then
          call put_inp(line(i)(1:l),2)
          if(OutputLevel.ge.OutputFull) then
            call str_flush
            call str_2integer_out(i,l,'Commandline buffer # (len=#):')
            call str_string_out(line(i)(1:l),'[#]')
            call str_flush
          endif
        endif
      enddo
      return
      end                       ! get_commandline
      subroutine get_create_overwrite(value)
      implicit none
      logical value
      logical   overwrite
      common /common___files/ overwrite
      value = overwrite
      return
      end                       ! get_create_overwrite
      subroutine get_default_directory(string,ier)
      implicit none
      character string*(*)
      integer   ier
      integer    length
      character pwd*1024
      integer   ls
      character message*256
      call mypwd(pwd,ier)
      if(ier.eq.0) then
        call RemoveMountPoint(pwd,pwd)
        call str_2string(pwd,'/','##',string)
        ls = length(string)
        if(index(string(1:ls),' ').gt.0) then
          call str_string(string,
     +         'space encountered in directory path #',message)
          call WarningMessage(message)
        endif
      else
        call copystr(pwd,string)
      endif
      return
      end                       ! get_default_directory
      subroutine get_double(x,dd)
      implicit none
      real*8    x
      character dd*(*)
      integer   iostat
      integer   errpos
      character message*256
      read(dd,*,iostat=iostat) x
      if (iostat.ne.0) then
        call evaluate8(dd,.false.,x,errpos,message)
      endif
      return
      end ! get_double
      subroutine get_file(selection,fullname,default,nd,result,ier)
      implicit none
      character selection*(*)   ! old new size -size az za
      character fullname*(*)
      character default*(*)
      integer   nd
      character result*(*)
      integer   ier
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   length
      integer   indexL
      character get_type*1
      logical   debug
      integer   error
      character DefaultFile*(medium)
      integer   ld
      character d*(medium)
      character filename*(medium)
      character filetype*(medium)
      character line*(medium)
      integer   ll
      integer   lr
      character wild*(medium)
      character pre*(medium)
      integer   lpre
      character post*(medium)
      integer   lpost
      integer   i
      logical   GetInpDone
      integer   selectiontype
      character fm*1
      integer   n
      integer   nn
      wild = fullname
      debug = (OutputLevel.ge.OutputDebug)
      if(selection.eq.'old') then
        selectiontype = 1
      else if(selection.eq.'new') then
        selectiontype = 2
      else if(selection.eq.'size') then
        selectiontype = 3
      else if(selection.eq.'-size') then
        selectiontype = 4
      else if(selection.eq.'az') then
        selectiontype = 5
      else if(selection.eq.'za') then
        selectiontype = 6
      else
        selectiontype = 5
      endif
      if(OutputLevel.ge.OutputFull) then
        call str_out('get_file')
        call str_string_out(selection,'selection=#')
        call str_integer_out(selectiontype,'selectiontype=#')
        call str_string_out(fullname,'fullname=[#]')
        call str_string_out(default,'default=[#]')
      endif
      call filescan(fullname,'NAME',filename,i)
      call str_remove(filename,'*',filename)
      call filescan(fullname,'TYPE',filetype,i)
      call str_remove(filetype,'*',filetype)
      i = index(fullname,'*')
      if(debug) call str_integer_out(i,'starpos=#')
      pre = ' '
      lpre = 0
      post = ' '
      lpost = 0
      if(indexL(fullname,'*').eq.i) then ! one star only
        if(i.eq.1) then
          post = fullname(2:)
          lpost = length(post)
          pre = ' '
          lpre = 0
        else if(i.gt.1) then
          pre = fullname(1:i-1)
          lpre = i-1
          post = fullname(i+1:)
          lpost = length(post)
        endif
      endif
      if(debug) then
        if(lpre.gt.0) call str_string_out(pre(1:lpre),'pre=[#]')
        if(lpost.gt.0) call str_string_out(post(1:lpost),'post=[#]')
      endif
      GetInpDone = .false.
      DefaultFile = ' '
      if(nd.ne.0) then
        call get_inp(d,nd,' ',*999)
        GetInpDone = .true.
        if(d.eq.'.'.or.d.eq.'='.or.d.eq.'?') then
          defaultFile = ' '
          call directorySort(0,selectiontype,wild,line,error)
          if(error.eq.0) then
            call filescan(line,'FILE',DefaultFile,ld)
          endif
          call directorysort(-1,selectiontype,wild,line,error)
          if(debug) call str_flush
          if(lpre.ne.0) call str_remove(DefaultFile,pre,DefaultFile)
          if(lpost.ne.0) call str_remove(DefaultFile,post,DefaultFile)
          if(d.eq.'.'.or.d.eq.'=') d = DefaultFile
        endif
      else ! i.e. nd.eq.0
        if(length(default).ne.0) then
          call build_file(default,filename,filetype,line,ld)
          call filemode(line(1:ld),fm)
          if(fm.eq.'-') then
            DefaultFile = line
          endif
        endif
        if(length(DefaultFile).eq.0) then
          call directorySort(0,selectiontype,wild,line,error)
          if(error.eq.0) then
            call filescan(line,'FILE',DefaultFile,ld)
          endif
          call directorySort(-1,selectiontype,wild,line,error)
          if(debug) call str_flush
        endif
        if(lpre.ne.0) call str_remove(DefaultFile,pre,DefaultFile)
        if(lpost.ne.0) call str_remove(DefaultFile,post,DefaultFile)
        if(debug) call str_string_out(DefaultFile,'DefaultFile=#')
      endif
   10 continue
      if(.not.GetInpDone) then
        call str_string(wild,'Enter # filename [#]',line)
        call str_string(DefaultFile,line,line)
        call get_inp_default(d,nd,line,*999)
      endif
      GetInpDone = .false.
      if(d.eq.'QUIT'.or.d.eq.'EXIT'.or.d.eq.'quit'.or.d.eq.'exit') then
        goto 999
      else if(d.eq.'?') then
        call str_unit_push(nout)
        call str_wrap(80)
        if(selectiontype.eq.1) then
          line = 'oldest first'
        else if(selectiontype.eq.2) then
          line = 'newest first'
        else if(selectiontype.eq.3) then
          line = 'smallest first'
        else if(selectiontype.eq.4) then
          line = 'largest first'
        else if(selectiontype.eq.5) then
          line = 'alfabet'
        else if(selectiontype.eq.6) then
          line = '-alfabet'
        endif
        call str_2string_out(wild,line,'Available # files (#):')
        nn = 0
        if(debug) call str_string_out(wild,'wild=#')
        call directorySort(0,selectiontype,wild,line,error)
        if(debug) call str_integer_out(error,'error=#')
        do while(error.eq.0)
          call filescan(line,'FILE',line,ll)
          if(lpre.ne.0) call str_remove(line,pre,line)
          if(lpost.ne.0) call str_remove(line,post,line)
          call str_out(line)
          nn = nn + 1
          call directorySort(1,selectiontype,wild,line,error)
        enddo
        call directorySort(-1,selectiontype,wild,line,error)
        call str_flush
        call str_integer_out(nn,'(or a number from 1 to #)')
        call str_unit_pop
        goto 10
      else
        if(debug) call str_string_out(d,'d=[#]')
        if(lpre.gt.0.or.lpost.gt.0) then
          result = d
          lr = length(result)
          if(debug) call str_string_out(result,'result1=[#]')
          call filemode(result(1:lr),fm)
          if(fm.eq.'-') goto 800
          if(lpre.gt.0) then
            if(d(1:lpre).ne.pre(1:lpre)) then
              call str_2string(pre(1:lpre),result,'##',result)
            endif
          endif
          if(debug) call str_string_out(result,'result2=[#]')
          lr = length(result)
          call filemode(result(1:lr),fm)
          if(fm.eq.'-') goto 800
          if(lpost.gt.0) then
            ll = length(d)
            if(ll.gt.lpost) then
              if(debug) call str_string_out(d(ll+1-lpost:ll),'d[#]')
              if(d(ll+1-lpost:ll).ne.post(1:lpost)) then
                call str_2string(result,post(1:lpost),'##',result)
              endif
            else
              call str_2string(result,post(1:lpost),'##',result)
            endif
          endif
          if(debug) call str_string_out(result,'result3=[#]')
          lr = length(result)
          call filemode(result(1:lr),fm)
          if(fm.eq.'-') goto 800
          result = d
          lr = length(result)
        else
          call build_file(d,filename,filetype,result,lr)
          lr = length(result)
          call filemode(result(1:lr),fm)
          if(fm.eq.'-') goto 800
        endif
        if(get_type(d).eq.'i') then
          call directorycount(wild,nn)
          call get_integer(n,d)
          if(n.lt.0) then
            n = nn+n+1
          else if(n.eq.0) then
            if(OutputLevel.ge.OutputNormal) then
              call str_out('0: selecting first file')
            endif
            n = 1
          else if(n.gt.nn) then
            if(OutputLevel.ge.OutputNormal) then
              call str_2integer_out(n,nn,'#>#: selecting last file')
            endif
            n = nn
          endif
          if(n.gt.0.and.n.le.nn) then
            call directorySort(0,selectiontype,wild,line,error)
            do i=1,n-1
              call directorySort(1,selectiontype,wild,line,error)
            enddo
            call filescan(line,'FILE',result,lr)
           call directorySort(-1,selectiontype,wild,line,error)
          endif
        endif
      endif
  800 continue
      if(OutputLevel.ge.OutputFull) then
        call str_string_out(result,'result=#')
      endif
      ier = 0
      return
  999 ier = 1
      return
      end                       ! get_file
      subroutine get_grad(x,dd)
      implicit none
      real      x
      character dd*(*)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      call get_real(x,dd)
      x = x/grad
      return
      end ! get_grad
      subroutine get_inp(d,nd,s,*)
      implicit none
      character d*(*)
      integer   nd
      character s*(*)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      character ROUTINE*(*)
      parameter (ROUTINE='get_inp')
      integer   length
      integer   lenstr
      character today*11
      character rolex*10
      character datetime*20
      character cputime*13
      real      cpusec
      external  cpusec
      logical   InputFromKeyboard
      logical   OutputToScreen
      character dd*(long)
      integer   ndd
      character FileType*3
      real*8    value
      character reason*(medium)
      character local*(long)
      character local2*(long)
      character local3*(long)
      integer   L2
      integer   L3
      logical   iftest
      logical   expr
      integer   eof
      integer   ldd
      integer   ier
      integer   lft
      integer   idd
      integer   LL
      integer   i
      integer   n
      integer   ier2
      integer   n1,n2,n3,n4
      real      r
      logical   cmprs
      character oldpath*(long)
      character path*(long)
      integer   lpath
      character fm*1
      character varname*3
      logical   dovarpush
      logical   atfile
      integer   unit
      logical   obsolete
      integer   lprefix1
      character formattype*1
      logical   boolean
      integer   npass
      if (FirstTime) call get_inp_init(-5)
      lprefix1 = max(1,lprefix)
   10 continue
      call get_inp_internal(dd,ndd,s,*900)
      if(OutputLevel.ge.OutputDebug) then
        call str_2string_out(ROUTINE,dd,'DBG (#) dd=#')
      endif
      if(dd(1:1).eq.'@'.or.dd(1:1).eq.'&') then
        atfile = dd(1:1).eq.'@'
        dd = dd(2:)
        ldd = lenstr(dd)
        call getenv(dd,local3)
        l3=length(local3)
        if (l3.gt.0) then
          dd=local3
          ldd=l3
        endif ! l3
        i = index(dd,'(')
        dovarpush = (i.gt.0)
        if(dovarpush) then
          if(dd(ldd:ldd).eq.')') ldd = ldd - 1
          local2 = dd(i:ldd)
          call str_collapse(dd(i+1:ldd),local2)
          call str_charsubstitute(local2,';',' ',local2)
          dd = dd(1:i-1)
          ldd = i-1
        endif
        npass = 0
        call tilde(dd(1:ldd),dd,ldd)
        local3 = dd(1:ldd)
        l3 = ldd
 20     continue
        npass = npass + 1
        call filemode(local3(1:l3),fm)
        if(fm.ne.'-') then
          call image_name(FileType,lft)
          if(lft.ge.3) lft = 2
          FileType = FileType(1:lft)//'c'
          lft = lft + 1
          n = l3 ! remember
          call build_file(local3(1:n),' ',FileType,local3,l3)
          call filemode(local3(1:l3),fm)
          if(fm.ne.'-') then
            call get_inp_search_alias('scripttype',i)
            if(i.gt.0) then
              call copystr(AliasDestination(i),filetype)
              call build_file(local3(1:n),' ',FileType,local3,l3)
              call filemode(local3(1:l3),fm)
            endif
          endif
        endif
        if(fm.ne.'-'.and.npass.le.1) then
          call filescan(local3,'PATH',path,lpath)
          if(lpath.eq.0.and.ninp.ne.5) then
            call filescan(inputfilename,'PATH',path,lpath)
            if(lpath.gt.0) then
              call path_join(path(1:lpath),dd(1:ldd),local3)
              l3 = length(local3)
              goto 20
            endif
          endif
        endif
        dd = local3
        ldd = l3
        if(fm.eq.'-') then
          call get_inp_stack(FlagPush,ier)
          if(ier.ne.0) then
            call get_inp_error(ier,'input file stack overflow')
          else
            if(OutputLevel.ge.OutputFull) then
              call str_string_out(dd(1:ldd),'Executing script #')
            endif
            nrepeat = 0
            call get_inp_setinputfilename(dd(1:ldd))
            call get_inp_open(dd(1:ldd),ninp,ier)
            if(ier.ne.0) then
              if(atfile) then
                if (nerr.ge.0) then
                  call str_flush
                  call str_string(ROUTINE,'#: error # opening #',local)
                  call str_integer(ier,local,local)
                  call str_string(dd(1:ldd),local,local)
                  call str_write(nerr,local)
                endif
                call get_inp_abort
              endif
              call get_inp_stack(FlagPop,ier)
              return 1
            else
              if(dovarpush) then
                i = 0
                L2 = length(local2)
                do while(l2.gt.0)
                  call str_header(local2(1:L2),local3,L3,local2,L2)
                  i = i + 1
                  call str_integer(i,'$#',varname)
                  call get_inp_add_alias(varname,local3)
                enddo
              endif
              call get_newline
              if(EchoStatus.eq.EchoAuto) then
                if(StackPointer.eq.1) then
                  nlog = nout
                else
                  nlog = 0
                endif
              endif
              if(nlog.gt.0.and.OutputLevel.ge.OutputFull) then
                call str_flush
                call str_integer_out(ninp,'(Opened #')
                call str_string_out(dd(1:ldd),'#)')
                call str_flush
              endif
              if(.not.atfile.and.outputtoscreen()) then
                call str_string_out(dd(1:ldd),'Executing #')
              endif
            endif
          endif
        else
          if(atfile) then
            call str_string(dd,'file # does not exist',local)
            call get_inp_error(1,local)
          endif
        endif
        goto 10
      else if(dd(1:lprefix1).eq.prefix(1:lprefix1).or.lprefix.eq.0) then
        dd = dd(lprefix+1:)
        ldd = lenstr(dd)
        call get_inp_find(dd,ldd,idd)   ! in upcase
        if(idd.lt.0) then
          if(lprefix.gt.0) then
            d = prefix(1:lprefix)//dd
          else
            d = dd
          endif
          nd = ndd
          return
        endif
        if(idd.eq.irepeat) then
          if(ndd.ge.2) then
            call get_inp_internal(dd,ndd,' ',*900)
            call evaluate8(dd,.false.,value,ier,reason)
            nrepeat = nint(value)
            if(nrepeat.le.0) then
              call get_newline
              nrepeat = 0
            else
              call get_restline(RepeatLine)
              call get_newline
              if(outputLevel.ge.OutputFull) then
                call str_integer_out(nrepeat,'repeat=#')
                call str_string_out(RepeatLine,'command=#')
              endif
            endif
            goto 10
          endif
        else if(idd.eq.iprefix) then
          if(ndd.eq.0) then
            prefix = ' '
            lprefix = 0
          else
            LocalUpcase = .false.
            call get_inp_internal(prefix,ndd,' ',*900)
            LocalUpcase = .true.
            lprefix = length(prefix)
          endif
        else if(idd.eq.iecho) then
          if(ndd.eq.0) then
            call get_inp_getecho(local)
            call str_out(local)
          endif
          call get_inp_internal(dd,ndd,'echo ON/OFF/AUTO/DEBUG/SOME',
     +         *900)
          if(EchoStatus.ne.EchoDebug) then
            call get_inp_setecho(dd)
          endif
        else if(idd.eq.ijournal) then
          call get_inp_internal(dd,ndd,'AUTO/ON/OFF/SUSPEND',*900)
          call upcase(dd,dd)
          if(dd.eq.'AUTO') then
            if(InputFromKeyboard()) then
              dd = 'ON'
            else
              dd = 'OFF'
            endif
          endif
          if(dd.eq.'ON') then
            if(njournal.gt.0) then
              if(.not.journalling) then
                journalling = .true. ! JOURNAL SUSPEND...JOURNAL ON
                call str_string_write(njournal,datetime(),
     +               '!JRN resume journal at #')
              else              ! JOURNAL ON ..... JOURNAL ON
                call str_string_write(njournal,datetime(),
     +               '!JRN implicit end journal at #')
                close(njournal)
                journalling = .false.
                njournal = 0
              endif
            endif
            if(njournal.eq.0) then
              call image_name(local,LL)
              call build_file(local,' ','.jrn',local,LL)
              call append_file(local(1:LL),njournal,local2,ier)
              if(ier.ne.0) then
                if(nout.gt.0) then
                  call str_write(nout,local2)
                endif
              else
                if(nout.gt.0) then
                  call str_write(nout,local2)
                endif
                call str_string_write(njournal,datetime(),
     +               '!JRN start journal at #')
                journalling = .true.
              endif
            endif
          else if(dd.eq.'OFF') then
            if (njournal.gt.0) then
              call str_string_write(njournal,datetime(),
     +             '!JRN end journal at #')
              close(njournal)
              journalling = .false.
              njournal=0
            endif
          else if(dd.eq.'SUSPEND') then
            journalling = .false.
            if(njournal.gt.0) then
              call str_string_write(njournal,datetime(),
     +             '!JRN suspend journal at #')
            endif
          endif
        else if(idd.eq.iALIAS) then
          if(ndd.eq.0) then
            if(nout.gt.0) then
              do i=1,NAlias
                call str_flush
                call str_2string_write(nout,AliasSource(i),
     +               AliasDestination(i),'#=>#')
              enddo
            endif
          else if(ndd.eq.1) then
            call get_inp_internal(dd,ndd,' ',*900)
            call get_inp_search_alias(dd,n)
            if(n.gt.0) then
              if(nout.gt.0) then
                call str_flush
                call str_2string_write(nout,AliasSource(n),
     +             AliasDestination(n),'#=>#')
              endif
            else
              if(nerr.ge.0) then
                call str_flush
                call str_2string_write(nerr,ROUTINE,dd,
     +             '#: alias # not found')
              endif
            endif
          else
            call get_inp_internal(dd,ndd,' ',*900)
            call get_restline(local)
            call get_inp_add_alias(dd,local)
          endif
          call get_newline
          goto 10
        else if(idd.eq.iALPHANUM) then
          if(ndd.ge.2) then
            call get_inp_internal(dd,ndd,' ',*900)
            call get_restline(local)
            call str_alphanumeric(local,local)
            call get_inp_add_alias(dd,local)
          else
            if(nerr.ge.0) then
              call str_2string_write(nerr,ROUTINE,dd,
     +             '#: at least 2 arguments')
            endif
          endif
          call get_newline
          goto 10
        else if(idd.eq.iARG) then
          if(ndd.eq.0) then
            if(nout.gt.0) then
              do i=1,NAlias
                call str_flush
                call str_2string_write(nout,AliasSource(i),
     +               AliasDestination(i),'#=>#')
              enddo
            endif
          else if(ndd.eq.1) then
            call get_inp_internal(dd,ndd,' ',*900)
            call get_inp_search_alias(dd,n)
            if(n.gt.0) then
              if(nout.gt.0) then
                call str_flush
                call str_2string_write(nout,AliasSource(n),
     +             AliasDestination(n),'#=>#')
              endif
            else
              if(nerr.ge.0) then
                call str_flush
                call str_2string_write(nerr,ROUTINE,dd,
     +             '#: alias # not found')
              endif
            endif
          else if(ndd.eq.2) then
            local = '\arg has at least 3 arguments'
            call get_inp_error(1,local)
          else
            call get_inp_internal(dd,ndd,' ',*900)
            call get_inp_internal(local,ndd,' ',*900)
            call get_inp_search_alias(local,n)
            if(n.gt.0) then
              call get_inp_add_alias(dd,AliasDestination(n))
            else
              call get_restline(local)
              call get_inp_add_alias(dd,local)
            endif
            call get_newline
          endif
          call get_newline
          goto 10
        else if(idd.eq.IALL) then
          if(AllowAllDefault) then
            AllDefault = .true.
            d = ' '
            nd = 0
            return
          else
            if(nerr.ge.0) then
              call str_flush
              call str_string_write(nerr,prefix,'#ALL not allowed')
            endif
          endif
        else if(idd.eq.iUNALIAS) then
          if(ndd.eq.0) then
            continue
          else
            call get_inp_internal(dd,ndd,' ',*900)
            if(dd.eq.'*') then
              NAlias = 0
            else
              call get_inp_search_alias(dd,n)
              if(n.eq.0) then
                call str_string(dd,'alias # not found',local)
                call get_inp_error(1,local)
              else
                if(outputLevel.ge.OutputFull) then
                  call str_string_out(AliasSource(n),'Removed alias')
                endif
                AliasSource(n) = AliasSource(NAlias)
                AliasDestination(n) = AliasDestination(NAlias)
                NAlias = NAlias - 1
              endif
            endif
          endif
        else if(idd.eq.IBOUND) then
          call get_inp_internal(dd,ndd,'ON/OFF',*900)
          call upcase(dd,dd)
          call str_boundcheck((dd.eq.'ON'),boolean)
        else if(idd.eq.iEVALUATE.or.idd.eq.iADDEVAL) then
          if(idd.eq.iADDEVAL) then
            call get_inp_internal(dd,ndd,'Var name',*900)
            if(ndd.eq.0) then
              call get_inp_internal(local2,ndd,'Value',*900)
              call get_restline(local)
              call str_2string(local2,local,'# #',local)
            else
              call get_restline(local)
            endif
          else
            call get_restline(local)
          endif
          call upcase(local,local)
          call str_collapse(local,local)
          call evaluate8(local,.false.,value,ier,reason)
          if(ier.eq.0) then
            if(idd.eq.iEVALUATE) then
              if(nout.gt.0) then
                call str_flush
                write (nout,*) value
              endif
              write (local,'(G23.16)') value
              call get_inp_add_alias('EVAL_RESULT',local)
            else
              r = real(value)
              call eval_add(dd,r,local,ier)
              if(ier.ne.0.or.OutputLevel.ge.OutputFull) then
                call str_out(local)
              endif
            endif
          else
            if(nerr.ge.0) then
              call str_flush
              call str_write_compress(.false.,cmprs)
              call str_write(nerr,local)
              call str_fill(local,ier,' ')
              local(ier:ier) = '^'
              call str_write(nerr,local(1:ier))
              call str_write_compress(cmprs,cmprs)
              call str_string_write(nerr,reason,'Evaluate:')
              call get_inp_abort
            endif
          endif
          call get_newline
          goto 10
        else if(idd.eq.iLISTEVAL) then
          call eval_list
        else if(idd.eq.iSTORE) then
          call get_inp_internal(dd,ndd,'Var name',*900)
          call get_inp_search_alias('EVAL_RESULT',n)
          if(n.gt.0) then
            call get_inp_add_alias(dd,AliasDestination(n))
          else
            call get_inp_error(1,'nothing to store')
          endif
        else if(idd.eq.iCOMMAND) then
          call commandreturn(1,local,ll,obsolete)
          if(ll.gt.0) then
            unit = 0
            ier = 0
          else
            call image_path(local,ll)
            call image_name(local2,l2)
            call path_join(local,local2,local)
            call Build_File_Type(local,' ','.commands',local,ll)
            if(OutputLevel.ge.OutputFull) then
              call str_string_out(local,'trying to open #')
            endif
            call open_file(local,unit,local2,ier)
            call get_inp_error(ier,local2)
          endif
          if(ier.eq.0) then
            if(ndd.gt.0) then
              call get_inp_internal(dd,ndd,'command',*900)
            else
              dd = ' '
            endif
            call get_inp_commandlist(unit,dd)
            if(unit.gt.0) close(unit)
          endif
        else if(idd.eq.iHELP) then
          call get_restline(dd)
          call image_help(' ',dd,ier)
          call get_inp_error(ier,' ')
          call get_newline
        else if(idd.eq.iHELPL) then
          call get_restline(dd)
          call help('/home/schreurs/p/rtl/get_inp',dd,ier)
          call get_inp_error(ier,' ')
          call get_newline
        else if(idd.eq.iHELPG) then
          call get_restline(dd)
          call help('/home/schreurs/p/rtl/graphics',dd,ier)
          call get_inp_error(ier,' ')
          call get_newline
        else if(idd.eq.iHISTORY) then
          call hist_show
        else if(idd.eq.iDIRECTORY) then
          if (ndd.gt.0) then
            LocalUpcase = .false.
            call get_inp_internal(local,ndd,' ',*900)
            LocalUpcase = .true.
          else
            local = '*'
          endif
          ll = lenstr(local)
          call directory(0,local(1:LL),local2,ier)
          if(ier.ne.0.and.nerr.ge.0) then
            if(OutputLevel.ge.OutputFull) then
              call str_flush
              call get_message(ier,local,ier2)
              call str_write(nerr,local)
            endif
          endif
          n = 0
          if(nout.gt.0) then
            call str_unit(nout)
            oldpath = ' '
            do while(ier.eq.0)
              n = n + 1
              call filescan(local2,'path',path,lpath)
              if(path(1:lpath).ne.oldpath(1:lpath)) then
                call str_flush
                call str_string_out(path(1:lpath),'Path=#')
              endif
              oldpath = path
              call filescan(local2,'file',local3,l3)
              call str_out(local3)
              call directory(1,local(1:LL),local2,ier)
            enddo
            call str_flush
          endif ! nout.gt.0
          call directory(-1,local(1:LL),local2,ier)
          call str_integer(n,'#',local)
          call get_inp_add_alias('DIRCOUNT',local)
        else if(idd.eq.iEDIT) then
          LocalUpcase = .false.
          call get_inp_internal(dd,ndd,'File name',*900)
          LocalUpcase = .true.
          call editor(dd,ier)
          call get_inp_error(ier,' ')
        else if(idd.eq.iEXIT) then
          call get_restline(dd)
          if(length(dd).gt.0) then
            call str_flush
            if(ninp.ne.5) then
              call str_string_out(inputfilename,'File #')
              call str_integer_out(linecount,'line #:')
            endif
            call str_out(dd)
            call str_flush
          endif
          goto 900
        else if(idd.eq.iGOTO) then
          call get_inp_internal(local,ndd,'label name',*900)
          call get_newline
          gotoactive = .true.
          local2 = ' '
          do while(local2(2:).ne.local)
            call get_inp_internal(local2,ndd,
     +           'goto active until !'//local,*900)
            call get_newline
          enddo
          gotoactive = .false.
          call get_newline
        else if(idd.eq.iCD) then
          LocalUpcase = .false.
          call get_inp_internal(dd,ndd,'Directory specification',*900)
          LocalUpcase = .true.
          call set_default_directory(dd,PreviousDirectory,ier)
          call get_inp_error(ier,' ')
          if(nout.gt.0) call str_string_write(nout,PreviousDirectory,
     +         'PreviousDirectory=#')
          if(nout.gt.0) then
            call str_flush
            call get_default_directory(local,ier)
            if(ier.ne.0) then
              call get_inp_error(ier,' ')
            else
              call str_string_write(nout,local,'Current directory=#')
            endif
          endif
        else if(idd.eq.iBACK) then
          if(length(PreviousDirectory).gt.0) then
            call set_default_directory(PreviousDirectory,local,ier)
            if(ier.ne.0) then
              call get_inp_error(ier,' ')
            else
              PreviousDirectory = local
            endif
          endif
          if(nout.gt.0) then
            call str_flush
            call get_default_directory(local,ier)
            call get_inp_error(ier,' ')
            call str_string_write(nout,local,'Current directory=#')
          endif
        else if(idd.eq.iPWD) then
          if(nout.gt.0) then
            call str_flush
            call get_default_directory(local,ier)
            if(ier.ne.0) then
              call str_out(local)
              call get_inp_error(ier,' ')
            else
              call str_string_write(nout,local,'Current directory=#')
            endif
          endif
        else if(idd.eq.iREMOVEEVAL) then
          call get_inp_internal(dd,ndd,'Var name',*900)
          call eval_remove(dd,local,ier)
          if(ier.ne.0.or.OutputLevel.ge.OutputFull) then
            call str_out(local)
          endif
        else if(idd.eq.iIMPORT) then
          call get_inp_internal(dd,ndd,'Symbol name',*900)
          ldd = lenstr(dd)
          call get_symbol(dd(1:ldd),local)
          call get_inp_add_alias(dd(1:ldd),local)
        else if(idd.eq.iEXPORT) then
          call get_inp_internal(dd,ndd,'Alias name',*900)
          call get_inp_search_alias(dd,n)
          if(n.eq.0) then
            call str_string(dd,'alias # not found',local)
            call get_inp_error(1,local)
          else
            ldd = lenstr(dd)
            ll = lenstr(AliasDestination(n))
            call set_symbol(dd(1:ldd),AliasDestination(n)(1:LL))
          endif
        else if(idd.eq.iFATAL) then
          call get_restline(dd)
          if(length(dd).gt.0) then
            call str_flush
            if(ninp.ne.5) then
              call str_string_out(inputfilename,'File #')
              call str_integer_out(linecount,'line #:')
            endif
            call str_out(dd)
            call str_flush
          endif
          call FatalMessage('aborted by \fatal')
        else if(idd.eq.iFORMAT) then
          call get_inp_internal(dd,ndd,'Alias name',*900)
          call get_inp_internal(local,ndd,'format',*900)
          call upcase(local,local)
          formattype=local(1:1)
          call str_string(local,'(#)',local)
          ll=lenstr(local)
          call get_restline(local2)
          call get_real(r,local2)
          if(formattype.eq.'I') then
            write(local3,local(1:ll),iostat=ier) nint(r)
          else
            write(local3,local(1:ll),iostat=ier) r
          endif
          if(ier.ne.0) then
            call str_integer_out(ier,'iostat=#')
          endif
          call str_2string_out(dd,local3,'#=>#')
          call get_inp_add_alias(dd,local3)
          call get_newline
          goto 10
        else if(idd.eq.iMKDIR) then
          LocalUpcase = .false.
          call get_inp_internal(dd,ndd,'Directory specification',*900)
          LocalUpcase = .true.
          call create_directory(dd,ier)
          call get_inp_error(ier,' ')
        else if(idd.eq.iSET_FILES) then
          call get_inp_internal(dd,ndd,'Input unit',*900)
          call get_integer(n1,dd)
          call get_inp_internal(dd,ndd,'Output unit',*900)
          call get_integer(n2,dd)
          call get_inp_internal(dd,ndd,'Error unit',*900)
          call get_integer(n3,dd)
          call get_inp_internal(dd,ndd,'LOG unit',*900)
          call get_integer(n4,dd)
          call set_files(n1,n2,n3,n4)
        else if(idd.eq.iSPAWN) then
          if(ndd.eq.0) then
            call get_inp_error(1,'no command given')
          else
            call get_restline(local)
            call spawn(local,ier)
            call get_newline
            if(ier.ne.0) then
              call get_inp_error(ier,' ')
            endif
          endif
        else if(idd.eq.iSTATUS) then
          call get_inp_status(.true.)
        else if(idd.eq.iVMS.or.idd.eq.iSHELL) then
          if(nout.gt.0) then
            call str_flush
            call str_write(nout,
     +     'Creating new process. Type control-D to return to program')
          endif
          call shell(ier)
          call get_inp_error(ier,' ')
        else if(idd.eq.iOUTPUT) then
          call get_inp_internal(local,ndd,'Output level',*900)
          call GetOutputValue(local,n)
          if(n.ge.0) then
            OutputLevel = n
          else
            call str_string(local,'Unknown output level #',local)
            call get_inp_error(1,local)
          endif
        else if(idd.eq.iOVERWRITE) then
          call get_inp_internal(dd,ndd,'ON/OFF',*900)
          call upcase(dd,dd)
          call create_overwrite((dd.eq.'ON'),boolean)
        else if(idd.eq.iRENAME) then
          LocalUpcase = .false.
          call get_inp_internal(local,ndd,'Old file name',*900)
          call get_inp_internal(local2,ndd,'New file name',*900)
          LocalUpcase = .true.
          call rename_file(local,local2,local3,ier)
          call get_inp_error(ier,local3)
        else if(idd.eq.iTIME) then
          if(nout.gt.0) then
            call str_flush
            call str_write(nout,rolex())
          endif
        else if(idd.eq.iTITLE) then
          local2 = ' '
          do while(ndd.gt.0)
            call get_inp_internal(local,ndd,' ',*900)
            call str_expand(local2,local)
          enddo
          call set_term_title(local2)
        else if(idd.eq.iDATE) then
          if(nout.gt.0) then
            call str_flush
            call str_write(nout,today())
          endif
        else if(idd.eq.iSETCPU) then
          call settime
        else if(idd.eq.iCPU) then
          if(nout.gt.0) then
            call str_flush
            local = cputime()
            call str_write(nout,local)
          endif
        else if(idd.eq.iSECOND) then
          if(nout.gt.0) then
            call str_flush
            call str_real_write(nout,cpusec(),'#')
          endif
        else if(idd.eq.iSETEOF) then
          call get_inp_seteof
        else if(idd.eq.iWAIT) then
          call get_inp_internal(local,ndd,'nr of seconds',*900)
          call get_real(r,local)
          if(r.gt.0.0) then
            if(nout.gt.0) then
              call str_real_len_push(2)
              call str_real_out(r,'Waiting # seconds')
              call str_real_len_pop
            endif
            call mywait(r)
          endif
        else if(idd.eq.iWRITE) then
          call get_restline(local)
          call str_flush
          call str_out(local)
          call str_flush
          if(length(local).eq.0) then
            write(6,'()')
          endif
          call get_newline
        else if(idd.eq.iPAUSE) then
          call get_mode(local)
          if(local(1:1).eq.'I') then
   11       call termline('Type GO to continue>',d,ier)
             if(ier.eq.0) then
               if(length(d).gt.0) then
                 call upcase(d,d)
                 if (d.ne.'GO') goto 11
               endif
             endif
          endif
        else if(idd.eq.iWL) then
          if(nout.gt.0) call str_write(nout,char(27)//'[?3h')
        else if(idd.eq.iWN) then
          if(nout.gt.0) call str_write(nout,char(27)//'[?3l')
        else if(idd.eq.iKEYBOARD) then
          if(ninp.eq.5) then
            call str_out('already at keyboard')
          else
            call get_inp_stack(FlagPush,ier)
            if(ier.ne.0) then
              call get_inp_error(ier,'input file stack overflow')
            else
              nrepeat = 0
              call get_inp_setinputfilename('Keyboard')
              ninp = 5
              call get_newline
              if(nlog.gt.0.and.OutputLevel.ge.OutputFull) then
                call str_integer_out(ninp,'Opened #')
                call str_out(Inputfilename)
              endif
              call str_out('Type control-d to go back')
            endif
          endif
        else if(idd.eq.iIF) then
          LocalUpcase = .false.
          call get_inp_internal(local,ndd,'expression',*900)
          if(local.eq.'not') then
            expr = .false.
            call get_inp_internal(local,ndd,'expression',*900)
          else
            expr = .true.
          endif
          if(local.eq.'dir') then
            call get_inp_internal(local2,ndd,'directoryname',*900)
            ll = lenstr(local2)
            call getenv(local2(1:ll),local3)
            l3 = length(local3)
            if(l3.gt.0) then
              local2 = local3
              ll = l3
            endif
            call filemode(local2(1:ll),fm)
            iftest = (fm.eq.'d')
            if(.not.(iftest.eqv.expr)) call get_newline
          else if(local.eq.'file') then
            call get_inp_internal(local2,ndd,'filename',*900)
            ll = lenstr(local2)
            call getenv(local2(1:ll),local3)
            l3 = length(local3)
            if(l3.gt.0) then
              local2 = local3
              ll = l3
            endif
            call filemode(local2(1:ll),fm)
            iftest = (fm.eq.'-')
            if(.not.(iftest.eqv.expr)) call get_newline
          else if(local.eq.'filez') then
            call get_inp_internal(local2,ndd,'filename',*900)
            ll = lenstr(local2)
            call getenv(local2(1:ll),local3)
            l3 = length(local3)
            if(l3.gt.0) then
              local2 = local3
              ll = l3
            endif
            call filemode(local2(1:ll),fm)
            if(fm.ne.'-') then
              call filemode(local2(1:ll)//'.Z',fm)
            endif
            if(fm.ne.'-') then
              call filemode(local2(1:ll)//'.gz',fm)
            endif
            if(fm.ne.'-') then
              call filemode(local2(1:ll)//'.bz2',fm)
            endif
            iftest = (fm.eq.'-')
            if(.not.(iftest.eqv.expr)) call get_newline
          else if(local.eq.'eqs') then
            call get_inp_internal(local,ndd,'string1',*900)
            call get_inp_internal(local2,ndd,'string2',*900)
            iftest = (local.eq.local2)
            if(.not.(iftest.eqv.expr)) call get_newline
          else if(local.eq.'alias') then
            call get_inp_internal(local,ndd,'alias name',*900)
            call get_inp_search_alias(local,n)
            iftest = (n.gt.0)
            if(.not.(iftest.eqv.expr)) call get_newline
          else if(local.eq.'expr') then
            call get_inp_internal(local,ndd,'expression',*900)
            call evaluate8(local,.false.,value,ier,reason)
            iftest = (nint(value).eq.1)
            if(.not.(iftest.eqv.expr)) call get_newline
          else
            call str_string(local,'Unknown expression #',local)
            call get_inp_error(1,local)
            call get_newline
          endif
          LocalUpcase = .true.
        else if(idd.eq.iCLS) then
          if(nout.gt.0) call str_write(nout,
     +         char(27)//'[2J'//char(27)//'[0;0H')
        else if(idd.eq.iBELL) then
          if(nout.gt.0) call str_write(nout,char(7))
        else
          return  ! prefixed unknown command, can never be true
        endif
        goto 10
      endif
      d = dd
      nd = ndd
      if(OutputLevel.ge.OutputFull.and..not.EmptyLinesAllowed) then
        call str_2string_out(ROUTINE,d,'(#) #')
      endif
      return
  900 continue
      call get_inp_close(eof)
      if(eof.ne.0) goto 10  ! ignore this end of file
      return 1
      end                       ! get_inp
      subroutine get_inp_abort
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      logical get_inp_checkabort
      if(get_inp_checkabort()) then
        call get_inp_printabort
        call FatalMessage('Aborting.....')
      endif
      return
      end                       ! get_inp_abort
      subroutine get_inp_add_alias(source,destination)
      implicit none
      character source*(*)
      character destination*(*)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer length
      integer   n
      character usource*(long)
      integer   ls
      if(NAlias.eq.MaxAlias) then
        call str_integer(MaxAlias,'Too many aliases. Max=#',usource)
        call get_inp_error(1,usource)
      else
        ls = length(source)
        if(ls.eq.0) return
        call upcase(source(1:ls),usource)
        call get_inp_search_alias(usource(1:ls),n)
        if(n.eq.0) then
          NAlias = NAlias + 1
          n = NAlias
        endif
        AliasSource(n) = usource(1:ls)
        call str_leading(destination,AliasDestination(n))
        if(OutputLevel.ge.OutputFull) then
          call str_flush
          call str_integer_out(n,'Alias[#]:')
          call str_2string_out(AliasSource(n)(1:ls),Aliasdestination(n),
     +         '#->#')
          call str_flush
        endif
      endif
      return
      end                       ! get_inp_add_alias
      logical function get_inp_checkabort()
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      logical InputFromKeyboard
      if(OutputLevel.ge.OutputDebug) then
        call str_out('get_inp_checkabort')
        call str_onoff_out(abortonerror,'AbortOnError=#')
        call str_onoff_out(inputfromkeyboard(),'InputFromKeyBoard=#')
        call str_integer_out(ninp,'ninp=#')
        call str_integer_out(FromBuffer,'FromBuffer=#')
      endif
      get_inp_checkabort = (AbortOnError.or.
     +     ninp.ne.5.or.FromBuffer.eq.2)
      return
      end                       ! get_inp_checkabort
      subroutine get_inp_close(eof)
      implicit  none
      integer   eof
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   ninp_old
      character local*(long)
      logical   LocalEof
      integer   ier
      ninp_old = ninp
      local = InputFileName
      LocalEof = noweof
      call get_inp_stack(FlagPop,ier)
      if(ier.eq.0) then
        call get_inp_close_internal(ninp_old)
        if(OutputLevel.ge.OutputDebug) then
          call str_flush
          call str_integer_out(ninp_old,'DBG Closed #')
          call str_string_out(local,'#')
          call str_flush
        else if(nlog.gt.0.and.OutputLevel.ge.OutputFull) then
          call str_string_out(local,'(Closed #)')
          call str_flush
        endif
        if(EchoStatus.eq.EchoAuto) then
          if(StackPointer.eq.1) then
            nlog = nout
          else
            nlog = 0
          endif
        endif
        if(LocalEof) then
          eof = 0   ! succes
        else
          eof = 1   ! ignore this end of file
        endif
      else
        eof = 0     ! succes
      endif
      return
      end                       ! get_inp_close
      subroutine get_inp_close_internal(unit)
      implicit none
      integer unit
      close(unit)
      return
      end                       ! get_inp_close_internal
      subroutine get_inp_commandlist(unit,first)
      integer   unit
      character first*(*)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   maxn
      parameter (maxn=1000)
      logical   debug
      parameter (debug=.false.)
      integer length
      character line*80
      integer   LL
      character field*80
      integer   lf
      integer   n
      character commands(maxn)*80
      integer   ier
      integer   lfirst
      integer   i
      logical   hidden
      lfirst = length(first)
      n = 0
      if(unit.eq.0) then
        i = 1
        call commandreturn(i,field,lf,hidden)
        do while(lf.gt.0)
          if(hidden.and.OutputLevel.le.OutputNormal) goto 200
          if(lfirst.gt.0) then
            if(field(1:lfirst).ne.first(1:lfirst)) goto 200
          endif
          if(n.lt.maxn) then
            n = n + 1
            commands(n) = field
          else
            call str_integer_out(maxn,'commandlist truncated to #')
            goto 300
          endif
  200     continue
          i = i + 1
          call commandreturn(i,field,lf,hidden)
        enddo
      else
        read(unit,100,iostat=ier) line
  100   format(a)
        do while(ier.eq.0)
          ll = length(line)
          do while(ll.gt.0)
            call str_header(line(1:ll),field,lf,line,ll)
            if(lfirst.gt.0) then
              if(field(1:lfirst).ne.first(1:lfirst)) goto 210
            endif
            if(n.lt.maxn) then
              n = n + 1
              commands(n) = field
            else
              call str_integer_out(maxn,'commandlist truncated to #')
              goto 300
            endif
  210       continue
          enddo
          read(unit,100,iostat=ier) line
        enddo
      endif
      if(n.eq.0) return
  300 continue
      call sort_char(n,commands)
      call str_flush
      call str_columns(6,n,commands)
      return
      end                       ! get_inp_commandlist
      subroutine get_inp_default(d,nd,s,*)
      implicit none
      character d*(*)
      integer   nd
      character s*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   length
      integer   indexL
      integer   i1,i2
      integer   i
      integer   n
      if (FirstTime) call get_inp_init(-5)
      if(AllDefault) then
        d = ' '
      else
        EmptyLinesAllowed = .true.
        call get_inp(d,nd,s,*900)
        EmptyLinesAllowed = .false.
        if(d.eq.'.'.or.d.eq.'=') d = ' '
      endif
      if(length(d).eq.0) then
        i1 = index(s,'[')
        if(i1.eq.0) return
        i2 = index(s,']')       ! is there a ]
        if(i2.eq.0) return
        i2 = indexL(s,']')      ! yes, get last one
        if(i2.lt.i1) return
        n = 1
        i = i2
        do while(n.gt.0)
          i = i-1
          if(i.lt.i1) return
          if(s(i:i).eq.'[') then
            n = n - 1
          else if(s(i:i).eq.']') then
            n = n + 1
          endif
        enddo
        if(i2-1.ge.i+1) then
          if(DoUpcase) then
            call upcase(s(i+1:i2-1),d)
          else
            d = s(i+1:i2-1)
          endif
          if(journalling.and.ninp.eq.5) then
            call str_string_write(njournal,s(i+1:i2-1),
     +           '!JRN default: #')
          endif
        endif
      endif
      if(Outputlevel.ge.OutputFull) then
        call str_string_out(d,'(get_inp_default) #')
      endif
      return
  900 continue
      EmptyLinesAllowed = .false.
      return 1
      end                       ! get_inp_default
      subroutine get_inp_error(ier,message)
      integer   ier
      character message*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   length
      character local*80
      if(ier.ne.0) then
        if(nerr.ge.0) then
          call str_flush
          if(length(message).gt.0) then
            call str_write(nerr,message)
          else
            call get_message(ier,local,ier)
            call str_write(nerr,local)
          endif
        endif
        call get_inp_abort
      endif
      return
      end                       ! get_inp_error
      subroutine get_inp_find(dd,ldd,idd)
      implicit none
      character dd*(*)
      integer ldd
      integer idd
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   max_test
      parameter (max_test=11)
      character test(ntest)*(max_test)
      integer   ltest(ntest)
      save test,ltest
      integer nmatch
      integer i
      character udd*(long)
      data test(iADDEVAL) /'ADDEVAL'/ ltest(iADDEVAL) / 7/
      data test(iALIAS) /'ALIAS'/ ltest(iALIAS) / 5/
      data test(iALPHANUM) /'ALPHANUM'/ ltest(iALPHANUM) /8/
      data test(iALL) /'ALL'/ ltest(iALL) / 3/
      data test(iARG) /'ARG'/ ltest(iARG) / 3/
      data test(iATTACH) /'ATTACH'/ ltest(iATTACH) / 6/
      data test(iBACK) /'BACK'/ ltest(iBACK) / 4/
      data test(iBELL) /'BELL'/ ltest(iBELL) / 4/
      data test(iBOUND) /'BOUND'/ ltest(iBOUND) / 5/
      data test(iCD) /'CD'/ ltest(iCD) / 2/
      data test(iCLS) /'CLS'/ ltest(iCLS) / 3/
      data test(iCOMMAND) /'COMMAND'/ ltest(iCOMMAND) / 7/
      data test(iCPU) /'CPU'/ ltest(iCPU) / 3/
      data test(iDATE) /'DATE'/ ltest(iDATE) / 4/
      data test(iDEFINE_KEY) /'DEFINE_KEY'/ ltest(iDEFINE_KEY) /10/
      data test(iDIRECTORY) /'DIRECTORY'/ ltest(iDIRECTORY) / 9/
      data test(iECHO) /'ECHO'/ ltest(iECHO) / 4/
      data test(iEDIT) /'EDIT'/ ltest(iEDIT) / 4/
      data test(iEXIT) /'EXIT'/ ltest(iEXIT) / 4/
      data test(iEVALUATE) /'EVALUATE'/ ltest(iEVALUATE) / 8/
      data test(iEXPORT) /'EXPORT'/ ltest(iEXPORT) / 6/
      data test(iFATAL) /'FATAL'/ ltest(iFATAL) / 5/
      data test(iFORMAT) /'FORMAT'/ ltest(iFORMAT) / 6/
      data test(iGOTO) /'GOTO'/ ltest(iGOTO) / 4/
      data test(iHELP) /'HELP'/ ltest(iHELP) / 4/
      data test(iHELPG) /'HELPG'/ ltest(iHELPG) / 5/
      data test(iHELPL) /'HELPL'/ ltest(iHELPL) / 5/
      data test(iHISTORY) /'HISTORY'/ ltest(iHISTORY) / 7/
      data test(iKEYBOARD) /'KEYBOARD'/ ltest(iKEYBOARD) / 8/
      data test(iIF) /'IF'/ ltest(iIF) / 2/
      data test(iIMPORT) /'IMPORT'/ ltest(iIMPORT) / 6/
      data test(iJOURNAL) /'JOURNAL'/ ltest(iJOURNAL) / 7/
      data test(iLISTEVAL) /'LISTEVAL'/ ltest(iLISTEVAL) / 8/
      data test(iMKDIR) /'MKDIR'/ ltest(iMKDIR) / 5/
      data test(iOUTPUT) /'OUTPUT'/ ltest(iOUTPUT) /6/
      data test(iOVERWRITE) /'OVERWRITE'/ ltest(iOVERWRITE) /9/
      data test(iPAUSE) /'PAUSE'/ ltest(iPAUSE) / 5/
      data test(iPREFIX) /'PREFIX'/ ltest(iPREFIX) / 6/
      data test(iPWD) /'PWD'/ ltest(iPWD) / 3/
      data test(iREMOVEEVAL) /'REMOVEEVAL'/ ltest(iREMOVEEVAL) / 10/
      data test(iRENAME) /'RENAME'/ ltest(iRENAME) / 6/
      data test(iREPEAT) /'REPEAT'/ ltest(iREPEAT) / 6/
      data test(iSECOND) /'SECOND'/ ltest(iSECOND) / 6/
      data test(iSETCPU) /'SETCPU'/ ltest(iSETCPU) / 6/
      data test(iSETEOF) /'SETEOF'/ ltest(iSETEOF) /6/
      data test(iSET_FILES) /'SET_FILES'/ ltest(iSET_FILES) / 9/
      data test(iSHELL) /'SHELL'/ ltest(iSHELL) / 5/
      data test(iSPAWN) /'SPAWN'/ ltest(iSPAWN) / 5/
      data test(iSTATUS) /'STATUS'/ ltest(iSTATUS) / 6/
      data test(iSTORE) /'STORE'/ ltest(iSTORE) / 5/
      data test(iTIME) /'TIME'/ ltest(iTIME) / 4/
      data test(iTITLE) /'TITLE'/ ltest(iTITLE) /5/
      data test(iUNALIAS) /'UNALIAS'/ ltest(iUNALIAS) / 7/
      data test(iVMS) /'VMS'/ ltest(iVMS) / 3/
      data test(iWAIT) /'WAIT'/ ltest(iWAIT) / 4/
      data test(iWRITE) /'WRITE'/ ltest(iWRITE) / 5/
      data test(iWL) /'WL'/ ltest(iWL) / 2/
      data test(iWN) /'WN'/ ltest(iWN) / 2/
      nmatch=0
      idd=-1
      if(ldd.gt.max_test) return
      call upcase(dd,udd)
      do i=1,ntest
        if (udd(1:ldd).eq.test(i)(1:ldd)) then
          idd=i
          if(ldd.eq.ltest(i)) return
          nmatch=nmatch+1
        endif
      enddo
      if (nmatch.gt.1) idd=-1
      return
      end                       ! get_inp_find
      subroutine get_inp_flush_all
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer eof
      if(.not.FirstTime) then
        do while (ninp.ne.5)
          call get_inp_close(eof)
        enddo
        call get_newline
        nrepeat=0
        putbufferpointer=0
      endif
      return
      end                       ! get_inp_flush_all
      subroutine get_inp_get_alias(source,result,ier)
      implicit none
      character source*(*)
      character result*(*)
      integer   ier
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   n
      call get_inp_search_alias(source,n)
      if(n.eq.0) then
        ier = 1
        result = ' '
      else
        result = AliasDestination(n)
        ier = 0
      endif
      return
      end                       ! get_inp_get_alias
      subroutine get_inp_getecho(s)
      character s*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      if(EchoStatus.eq.EchoOff) then
        s = 'off'
      else if(EchoStatus.eq.EchoOn) then
        s = 'on'
      else if(EchoStatus.eq.EchoSome) then
        s = 'some'
      else if(EchoStatus.eq.EchoAuto) then
        s = 'auto'
      else if(EchoStatus.eq.EchoDebug) then
        s = 'debug'
      else if(EchoStatus.eq.EchoInit) then
        s = 'init'
      else
        s = 'unknown'
      endif
      return
      end                       ! get_inp_getecho
      subroutine get_inp_init(flag)
      implicit none
      integer   flag
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      logical   OutputToScreen
      integer   lenstr
      character local*(long)
      character InitFileName*(long)
      character get_nodename*15
      integer   ier
      character path*(long)
      integer   lpath
      character pwd*(long)
      integer   lpwd
      character image*(medium)
      integer   li
      character release*80
      integer   lr
      integer   version
      character s80*80
      data FirstTime /.true./
      FirstTime = .false.
      if(flag.ne.0) ninp = -5
      StackPointer = 0
      nout = 6
      nerr = 0
      nlog = 0
      OutputLevel = OutputNormal
      seteof = .false.
      noweof = .false.
      DoUpcase = .true.
      DoAliasSubstitution = .true.
      DoRegexpSubstitution = .true.
      AbortOnError = .false.
      LocalUpcase = .true.
      EmptyLinesAllowed = .false.
      AllowAlldefault = .false.
      AllDefault = .false.
      InitBusy = 0
      EchoStatus = EchoInit
      gotoactive = .false.
      frombuffer = 0
      n_noecho = 0
      call GetBackSlash(prefix)
      lprefix = 1
      prompt = ' '
      lp = 2
      NAlias = 0
      journalling = .false.
      njournal = 0
      col = ' '
      istart = 1
      nrepeat = 0
      RepeatLine = ' '
      SubstituteWhole = .true.
      if(flag.ne.0) then
        call get_inp_setinputfilename('Unknown?')
      endif
      call config_path(path,lpath)
      call get_inp_add_alias('CONFIG_PATH',path(1:lpath))
      call image_name(image,li)
      call get_inp_add_alias('IMAGE_NAME',image(1:li))
      call image_version(release,lr,version)
      if(lr.gt.0) then
        call get_inp_add_alias('IMAGE_RELEASE',release(1:lr))
      endif
      if(version.gt.0) then
        call str_integer(version,'#',s80)
        call get_inp_add_alias('IMAGE_VERSION',s80)
      endif
      call str_2string(path,image,'##.init',initfilename)
      call get_username(s80)
      call get_inp_add_alias('USER_NAME',s80)
      call get_default_directory(pwd,ier)
      lpwd = lenstr(pwd)
      if(ier.eq.0) then
        call get_inp_add_alias('WORK_DIR',pwd(1:lpwd))
        call path_basename(pwd(1:lpwd),local)
        call get_inp_add_alias('BASE_NAME',local)
        call path_dirname(pwd(1:lpwd),local)
        call path_basename(local,local)
        call get_inp_add_alias('PARENT_NAME',local)
      endif
      local = get_nodename()
      call get_inp_add_alias('NODE_NAME',local)
      call get_mode(local)
      call get_inp_add_alias('PROCESS_MODE',local(1:lenstr(local)))
      call get_processname(local)
      call get_inp_add_alias('PROCESS_NAME',local(1:lenstr(local)))
      call get_inp_stack(FlagPush,ier)
      call getenv('GET_INP_INIT',InputFileName)
      call get_inp_open(InputFileName,ninp,ier)
      if(ier.ne.0) then
        call str_string(image,'#.init',InputFileName) ! in current directory
        call get_inp_open(InputFileName,ninp,ier)
        if(ier.ne.0) then
          call get_inp_stack(FlagPop,ier)
        else
          InitBusy = ninp
          call get_newline
        endif
      else
        InitBusy = ninp
        call get_newline
      endif
      if(pwd(1:lpwd).ne.path(1:lpath)) then
        call get_inp_stack(FlagPush,ier)
        call str_string(initfilename,'#local',InputFilename)
        call get_inp_open(InputFileName,ninp,ier)
        if(ier.ne.0) then
          call get_inp_stack(FlagPop,ier)
        else
          if(InitBusy.eq.0) InitBusy = ninp
          call get_newline
        endif
        call get_inp_stack(FlagPush,ier)
        call get_inp_setinputfilename(InitFileName)
        call get_inp_open(InputFileName,ninp,ier)
        if(ier.ne.0) then
          call get_inp_stack(FlagPop,ier)
        else
          if(InitBusy.eq.0) InitBusy = ninp
          call get_newline
        endif
      endif
      WordCount = 0
      LineCount = 0
      PutbufferPointer = 0
      if(OutputToScreen()) then
        call ccaction_push(1)
      else
        call ccaction_push(3)
      endif
      call resetinterrupt
      return
      end                       ! get_inp_init
      subroutine get_inp_internal(dd,ndd,s, *)
      implicit none
      character dd*(*)
      integer   ndd
      character s*(*)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      character ROUTINE*(*)
      parameter (ROUTINE='get_inp_internal')
      integer   length
      logical   InputFromKeyboard
      logical   OutputToScreen
      integer   status
      character c*1
      integer   i1,i2,i3
      integer   lc
      integer   lc1
      integer   ls
      integer   ldd
      integer   idd
      logical   interrupted
      character temp*(long)
      integer   lt
      logical   SomethingChanged
      character source*80
      integer   lprefix1
      logical   myecho
      integer   i
      integer   j
      integer   noodrem
      WordCount  = WordCount  + 1
      if(ninp.lt.0) then
        ninp = 5
        call get_inp_setinputfilename ('Keyboard')
        call get_newline
      endif
   10 continue
      if (interrupted()) then
        call resetinterrupt
      endif
      if(OutputLevel.ge.OutputDebug) then
        call str_string_out(ROUTINE,'DBG (#)')
        lc = length(col)
        lc1 = max(1,lc)
        call str_flush
        write(6,*) 'istart lc lc1',istart,lc,lc1
        write(6,'(a)') col(1:lc1)
      endif
      call get_inp_one_par(istart,i2)
      if(i2.ge.istart) then
        noodrem = 0
        if(DoAliasSubstitution) then
          SomethingChanged = .true.
          do while(SomethingChanged)
            call get_inp_substitute(istart,i2,SomethingChanged)
            call get_inp_one_par(istart,i2)
            noodrem = noodrem + 1
            if(noodrem.gt.10) then
              call FatalMessage(
     +             'too deep recursive alias substition. Aborted')
            endif
          enddo
        endif
        if(DoUpcase.and.LocalUpcase) then
          call Upcase(col(istart:i2),dd)
        else
          dd = col(istart:i2)
        endif
        istart = i2+1+1
        nitem = nitem - 1
        ndd = nitem
        return
      endif
   30 continue
      if (interrupted()) then
        call resetinterrupt
      endif
      FromBuffer = 0
      lc = 0
      lc1 = 1
      source = ' '
      if(nrepeat.gt.0) then
        col = RepeatLine
        lc = length(col)
        lc1 = max(1,lc)
        if(nlog.ne.0.and.OutputLevel.ge.OutputFull)  then
          call str_flush
          call str_integer_write(nlog,nrepeat,
     +       '<repeat #> '//col(1:lc1))
        endif
        if(OutputLevel.ge.OutputDebug) then
          call str_integer(nrepeat,'repeat #',source)
        endif
      else if(PutbufferPointer.gt.0.and.InitBusy.eq.0) then
        col = putbuffer(PutbufferPointer)
        FromBuffer = PutBufferStatus(PutBufferPointer)
        lc = length(col)
        lc1 = max(1,lc)
        if(nlog.ne.0.and.OutputLevel.ge.OutputFull)  then
          call str_flush
          call str_write(nlog,col(1:lc1))
        endif
        if(journalling) then
          write (njournal,600) col(1:lc1)
        endif
        if(OutputLevel.ge.OutputDebug) then
          call str_integer(PutBufferPointer,
     +         'col filled from PutBuffer #',source)
        endif
        PutbufferPointer = PutbufferPointer - 1
      else
        if(ninp.eq.0) goto 70  ! eof if no input file specified
        LineCount = LineCount + 1
        ls = length(s)
        if(ls.eq.0) then
          if(prompt.eq.' ') then
             call image_name(prompt,lp)
             call upcase(prompt(1:1),c)
             call lowercase(prompt(2:),temp)
             prompt = c//temp(1:lp-1)//'>'
             lp = lp + 1
          endif
          temp = prompt
          lt = lp
        else
          temp = s
          lt = ls
        endif
  600   format(a)
        if(ninp.eq.5) then
          if(OutputToScreen()) then
            call ccaction_push(2)
          endif
   75     continue
          call str_flush
          col = ' '
          if(lt+1.gt.80) then
            write(6,600) temp(1:lt)
            call cgetlin(' ',1,col,len(col),status)
          else
            call cgetlin(temp,lt+1,col,len(col),status)
          endif
          lc = length(col)
          lc1 = max(1,lc)
          if (status.ne.0) then
            if(status.eq.3) then
              if(outputlevel.ge.outputfull) then
                call str_out('empty answer? => force END-OF-FILE')
              endif
              status = 1 ! force end-of_file
            else
              write(6,620) 'PROMPT:',temp(1:lt)
              call flush(6)
              read (ninp,'(a)',iostat=status) col
              if(status.eq.0) then
                lc = length(col)
                lc1 = max(1,lc)
                write(6,620) 'INPUT :',col(1:lc1)
 620            format (a,1x,a)
                call flush(6)
              else
                write(6,630) status
 630            format('ERROR : iostatus=',i4)
              endif
            endif
          endif
          if(journalling) then
            write (njournal,600) col(1:lc1)
          endif
          if (interrupted()) then
            call resetinterrupt
            goto 75
          endif
          call resetinterrupt
          if(OutputToScreen()) then
            call ccaction_pop()
          endif
          if(OutputLevel.ge.OutputDebug) then
            source = '5'
          endif
        else
          read(ninp,'(a)',iostat=status) col
          lc = length(col)
          lc1 = max(1,lc)
          if(OutputLevel.ge.OutputDebug) then
            call str_integer(ninp,'#',source)
          endif
        endif
        if(status.ne.0) then
          goto 70
        endif
        if(OutputLevel.ge.OutputDebug) then
          call str_flush
          call str_string_out(col,'before tab [#]')
          call str_flush
        endif
        call str_charsubstitute(col,char(9),' ',col)
        if(OutputLevel.ge.OutputDebug) then
          call str_flush
          call str_string_out(col,'after tab [#]')
          call str_flush
        endif
        myecho = .false.
        if(nlog.ne.0) then
          if(gotoactive) goto 17
          do i=1,n_noecho
            j = lennoecho(i)
            if(col(1:j).eq.noecho(i)(1:j)) then
              goto 17
            endif
          enddo
          if(EchoStatus.eq.EchoSome) then
            if(lprefix.gt.0) then
              if(col(1:lprefix).eq.prefix(1:lprefix)) then
                goto 17
              endif
            endif
            if(col(1:1).eq.'!') then
              goto 17
            endif
          endif
          myecho = .true.
        else if(col(1:3).eq.'!!!') then  ! always echo
          myecho = .true.
        endif
 17     continue
        if(myecho) then
          call str_flush
          call str_write(nlog,col(1:lc1))
        endif
      endif ! nrepeat
      if(OutputLevel.ge.OutputDebug) then
        call str_flush
        call str_2string_out(source,col(1:lc1),'DBG #> 1col=#')
        call str_flush
      endif
      if(lc.eq.0.and.EmptyLinesAllowed) then
        dd = ' '
        ndd = 0
        nitem = 0
        call get_newline
        return
      endif
      if(lc.eq.0) goto 30
      if(col(1:1).eq.'!') then
        if(gotoactive) then
          continue
        else
          goto 30
        endif
      endif
      istart = 1
      do while(col(istart:istart).eq.' ')
        istart = istart + 1
      enddo
      if(istart.gt.1) then
        col = col(istart:)
        istart = 1
      endif
      if(DoRegexpSubstitution) then
        call str_regexp(col,col)
      endif
      if(OutputLevel.ge.OutputDebug) then
        call str_flush
        call str_integer_out(length(col),'before alias len=#:')
        call str_out(col)
        call str_flush
      endif
      SomethingChanged = .false.
      i1 = istart
      call get_inp_one_par(i1,i2)
      SubstituteWhole = DoAliasSubstitution
      if(i2.ge.i1.and.DoAliasSubstitution) then
        call get_inp_substitute(i1,i2,SomethingChanged)
        call get_inp_one_par(i1,i3)
        call upcase(col(i1:i3),dd)
        lprefix1 = max(1,lprefix)
        if(dd(1:lprefix1).eq.prefix(1:lprefix1).or.(lprefix.eq.0)) then
          ldd = i3-i1+1-lprefix
          call get_inp_find(dd(lprefix+1:),ldd,idd)    !  dd in upcase
          if(idd.eq.ialias.or.idd.eq.iunalias.or.idd.eq.istore.or.
     +         idd.eq.iexport.or.idd.eq.iformat.or.idd.eq.iimport.or.
     +         idd.eq.icommand.or.idd.eq.iarg.or.idd.eq.ialphanum.or.
     +         idd.eq.iif) then
            SubstituteWhole=.false.
          endif
        endif
      endif
      if(OutputLevel.ge.OutputDebug) then
        call str_flush
        call str_integer_out(length(col),'after alias len=#:')
        call str_out(col)
        call str_flush
      endif
      if(SomethingChanged) then
        if(OutputLevel.ge.OutputDebug) then
          call str_string_out(col,'DBG 2col=#')
          call str_flush
        else
          if(nlog.ne.0)  then
            call str_flush
            call str_string_write(nlog,col,'(#)')
          endif
        endif
      endif
      if(nrepeat.gt.0) then
        call get_inp_nrep
        nrepeat = nrepeat - 1
      endif
      call str_word_count(col(istart:),nitem)
      goto 10
   70 continue
      if(InitBusy.eq.ninp) then
        InitBusy = 0
        if(EchoStatus.eq.EchoInit) then
          if(.not.OutputToScreen().and.InputFromKeyboard()) then
            EchoStatus = EchoOn
            nlog = nout
          else
            EchoStatus = EchoAuto
          endif
        endif
      endif
      return 1
      end                       ! get_inp_internal
      subroutine get_inp_nrep
      implicit none
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   length
      integer   n
      integer   ld
      character result*12
      character form*80
      integer   i
      call get_inp_search_alias('NREP',n)
      if(n.gt.0) then
        ld = length(AliasDestination(n))
        call get_integer(i,AliasDestination(n))
        i = i + 1
        call str_integer(i,'#',result)
        if(AliasDestination(n)(1:1).eq.'0') then
          if(length(result).lt.ld) then
            call str_2integer(ld,ld,'(I#.#)',form)
            write(result,form) i
          endif
        endif
        AliasDestination(n) = result
      endif
      return
      end                       ! get_inp_nrep
      subroutine get_inp_one_par(i1,i2)
      implicit none
      integer i1,i2
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      if(i1.ge.len(col)) then
        i2 = i1-1
        return
      endif
      do while((col(i1:i1).eq.' ').and.
     +     i1.lt.len(col))
        i1 = i1 + 1
      enddo
      i2 = i1
      if(i1.eq.len(col)) then
        i2 = i1 - 1
        return
      endif
      do while(col(i2:i2).ne.' '.and.
     +     i2.lt.len(col))
        i2 = i2 + 1
      enddo
      if(col(i2:i2).eq.' ') then
        i2 = i2 - 1             ! i2 = last character of string
      endif
      return
      end                       ! get_inp_one_par
      subroutine get_inp_open(name,unit,ier)
      implicit none
      character name*(*)
      integer   unit
      integer   ier
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   length
      character local*(long),local2*(long)
      integer   ll,l2
      integer   status
      integer   local_unit
      integer   ln
      local_unit = unit
      ln = length(name)
      call get_lun(unit,ier)
      if (ier.ne.0) then
        status=ier
      else
        local=name
        ll=ln
        if(ll.gt.0) then
          call getenv(local(1:ll),local2)
          l2 = length(local2)
          if (l2.gt.0) then
            local=local2
            ll=l2
          endif
        endif
        if(ll.gt.0) then
          open(unit=unit,file=local(1:ll),status='old',iostat=status)
          if(OutputLevel.ge.OutputDebug) then
            call str_flush
            if(status.eq.0) then
              call str_integer_out(unit,'DBG Opened #')
              call str_out(local(1:ll))
            else
              call str_string_out(local(1:ll),'DBG Cannot open #')
              call str_integer_out(status,'status=#')
            endif
          endif
        else
          status = 1
        endif
      endif
      if(status.ne.0) then
        ier = status
      else
        if(InitBusy.eq.0.and.local_unit.gt.0) noweof=seteof
        ier = 0
      endif
      if(InitBusy.eq.0.and.local_unit.gt.0) seteof=.false.
      return
      end                       ! get_inp_open
      subroutine get_inp_printabort
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   indent
      parameter (indent=3)
      integer   i
      call str_flush
      if(AbortOnError) call str_out('Fatal Error.')
      call str_indentadd(indent)
      if(ninp.ne.5) then
        call str_string_out(Inputfilename,'from file #')
        call str_integer_out(LineCount,'line #.')
      endif
      if(StackPointer.gt.0) then
        call str_flush
        do i=StackPointer,1,-1
          if(FileStack(i).gt.0.and.FileStack(i).ne.5) then
            call str_string_out(FileNameStack(i),'from file #')
            call str_integer_out(LineCountStack(i),'line #.')
            call str_flush
          endif
        enddo
      endif
      if(FromBuffer.gt.0) call str_out('Input from inputbuffer.')
      call str_flush
      if(OutputLevel.ge.OutputFull) then
        call get_inp_status(.true.)
      endif
      call str_indentadd(-indent)
      return
      end                       ! get_inp_printabort
      subroutine get_inp_search_alias(string,n)
      implicit none
      character string*(*)
      integer   n
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   i
      character ustring*(long)
      call upcase(string,ustring)
      do i=1,NAlias
        if(ustring.eq.AliasSource(i)) then
          n = i
          return
        endif
      enddo
      n = 0
      return
      end                       ! get_inp_search_alias
      subroutine get_inp_setecho(s)
      character s*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      character us*20
      call upcase(s,us)
      if(us.eq.'ON') then
        nlog = nout
        EchoStatus = EchoOn
      else if(us.eq.'SOME') then
        nlog = nout
        EchoStatus = EchoSome
      else if(us.eq.'OFF') then
        nlog = 0
        EchoStatus = EchoOff
      else if(us.eq.'AUTO') then
        EchoStatus = EchoAuto
        if(StackPointer.eq.1) then
          nlog = nout
        else
          nlog = 0
        endif
      else if(us.eq.'DEBUG') then
        nlog = nout
        EchoStatus = EchoDebug
      endif
      return
      end                       ! get_inp_setecho
      subroutine get_inp_seteof
      implicit none
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      if (FirstTime) call get_inp_init(-5)
      seteof = .true.
      return
      end                       ! get_inp_seteof
      subroutine get_inp_setinputfilename(s)
      implicit none
      character s*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      character name*80
      integer   ln
      inputfilename = s
      call filescan(inputfilename,'NAME',name,ln)
      call get_inp_add_alias('SCRIPT',name(1:ln))
      return
      end                       ! get_inp_setinputfilename
      subroutine get_inp_stack(flag,ier)
      implicit none
      integer   flag
      integer   ier
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   lenstr
      logical   debug
      parameter (debug=.false.)
      integer   i,j
      integer   LL
      integer   DummyUnit
      character local*(long)
      logical   cmprs
      character varname*10
      if(flag.eq.FlagClear) then
        StackPointer=0
      else if(flag.eq.FlagPush) then
        if(StackPointer.ge.MaxStack) then
          ier = 1
          return
        endif
        call get_lun(DummyUnit,ier) ! check if we can open a new file
        if(ier.ne.0) return
        StackPointer = StackPointer + 1
        EofStack(StackPointer)        = noweof
        FileStack(StackPointer)       = ninp
        ColStack(StackPointer)        = col
        IstartStack(StackPointer)     = istart
        NRepeatStack(StackPointer)    = nrepeat
        RepeatLineStack(StackPointer) = RepeatLine
        FileNameStack(StackPointer)   = InputFileName
        WordCountStack(StackPointer)  = WordCount
        LineCountStack(StackPointer)  = LineCount
        WordCount = 0
        LineCount = 0
        if(debug) call str_out('pushing aliases')
        i = 1
        call str_integer(i,'$#',varname)
        call get_inp_search_alias(varname,j)
        do while(j.ne.0)
          call str_2integer(StackPointer,i,'#$#',varname)
          AliasSource(j) = varname
          if(debug) call str_out(varname)
          i = i + 1
          call str_integer(i,'$#',varname)
          call get_inp_search_alias(varname,j)
        enddo
        if(debug) call str_flush
      else if(flag.eq.FlagPop) then
        if(StackPointer.le.0) then
          ier = 1
          return
        endif
        noweof      = EofStack(StackPointer)
        ninp        = FileStack(StackPointer)
        col         = ColStack(StackPointer)
        istart      = IstartStack(StackPointer)
        nrepeat     = NRepeatStack(StackPointer)
        RepeatLine = RepeatLineStack(StackPointer)
        call get_inp_setinputfilename(FileNameStack(StackPointer))
        WordCount = WordCountStack(StackPointer)
        LineCount = LineCountStack(StackPointer)
        call str_word_count(col(istart:),nitem)
        i = 1
        if(debug)call str_out('removing aliases')
        call str_integer(i,'$#',varname)
        call get_inp_search_alias(varname,j)
        do while(j.ne.0)
          if(debug)call str_out(varname)
          AliasSource(j) = AliasSource(NAlias)
          AliasDestination(j) = AliasDestination(NAlias)
          NAlias = NAlias - 1
          i = i + 1
          call str_integer(i,'$#',varname)
          call get_inp_search_alias(varname,j)
        enddo
        if(debug)call str_flush
        i = 1
        if(debug) call str_out('popping aliases')
        call str_2integer(StackPointer,i,'#$#',varname)
        call get_inp_search_alias(varname,j)
        do while(j.ne.0)
          if(debug) call str_out(varname)
          call str_integer(i,'$#',varname)
          AliasSource(j) = varname
          i = i + 1
          call str_2integer(StackPointer,i,'#$#',varname)
          call get_inp_search_alias(varname,j)
        enddo
        if(debug) call str_flush
        StackPointer = StackPointer - 1
      else if(flag.eq.FlagStatus) then
        call str_unit(nout)
        call str_integer_write(nout,StackPointer,'Stack size=#')
        do i=1,StackPointer
          call str_integer_out(i,'File #')
          call str_integer_out(FileStack(i),'unit=#')
          call str_out(FileNameStack(i))
          call str_logical_out(EofStack(i),'Eof=#')
          LL = lenstr(ColStack(i))
          call str_integer_out(LL,'len=#')
          call str_flush
          if(IstartStack(i).eq.len(col)+1) then
            call str_write(nout,'Positioned at beginning of file')
          else
            call str_write(nout,'not at beginning of file')
            j = IstartStack(i)
            call str_write_compress(.false.,cmprs)
            call str_string_write(nout,ColStack(i)(1:LL),'command:#')
            if(j.le.len(local)) then
              call str_fill(local,j,' ')
              local(j:j) = '^'
              call str_string_write(nout,local(1:j),'pointer:#')
            endif
            call str_write_compress(cmprs,cmprs)
          endif
          if(NRepeatStack(i).gt.0) then
            call str_integer_write(nout,NRepeatStack(i),
     +           'Repeat #:'//RepeatLineStack(i))
          endif
        enddo
        LL = lenstr(col)
        j = istart
        call str_integer_out(ninp,'Current input: unit=#')
        call str_out(InputFileName)
        call str_logical_out(noweof,'Eof=#')
        call str_integer_out(LL,'len(command)=#')
        call str_integer_out(istart,'istart=#')
        call str_flush
        call str_write_compress(.false.,cmprs)
        call str_string_write(nout,col(1:LL),'command:#')
        if(j.le.len(local)) then
          call str_fill(local,j,' ')
          local(j:j) = '^'
          call str_string_write(nout,local(1:j),'pointer:#')
        endif
        call str_write_compress(cmprs,cmprs)
        if(nrepeat.gt.0) then
          call str_integer_write(nout,nrepeat,'Repeat #:'//RepeatLine)
        endif
        call str_logical_write(nout,seteof,'EOF flag for next file = #')
      endif
      ier = 0
      return
      end                       ! get_inp_stack
      subroutine get_inp_status(full)
      logical   full
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      character datetime*20
      integer   length
      character local*(long)
      character local2*(long)
      integer   LL
      logical   named
      integer   i
      integer   ier
      logical   boolean
      if(nout.gt.0) then
        call str_indent(5)
        if(full) then
          call image_name(local,LL)
          call str_2string_write(nout,local,datetime(),
     +         'Get_Inp_Status of # at #')
          if(journalling) then
            call str_string_write(nout,local,
     +           'Journalling to file #.jrn')
          else
            if(njournal.gt.0) call str_string_write(nout,local,
     +           'Journalling to file #.jrn suspended')
          endif
          if(length(PreviousDirectory).gt.0) then
            call str_string_write(nout,PreviousDirectory,
     +           'Previous directory = ')
          endif
          call get_default_directory(local,ier)
          call str_string_write(nout,local,'Current directory = ')
          call str_integer(nout,'Output file #',local2)
          if(nout.gt.0) then
            inquire (unit=nout,named=named)
            if(named) then
              inquire(unit=nout,name=local)
              call str_2string(local2,local,'# = #',local2)
            endif
          else
            call str_add(local2,'Not in Use',local2)
          endif
          call str_write(nout,local2)
          call str_integer(nerr,'Error file #',local2)
          if(nerr.ge.0) then
            inquire (unit=nerr,named=named)
            if(named) then
              inquire(unit=nerr,name=local)
              call str_2string(local2,local,'# = #',local2)
            endif
          else
            call str_add(local2,'Not in Use',local2)
          endif
          call str_write(nout,local2)
          call str_integer(nlog,'Log file #',local2)
          if(nlog.gt.0) then
            inquire (unit=nlog,named=named)
            if(named) then
              inquire(unit=nlog,name=local)
              call str_2string(local2,local,'# = #',local2)
            endif
          else
            call str_add(local2,'Not in Use',local2)
          endif
          call str_write(nout,local2)
        endif
        call get_inp_stack(FlagStatus,ier)
        do i=1,PutbufferPointer
          if(OutputLevel.ge.OutputDebug) then
            call str_2integer_write(nout,i,length(putbuffer(i)),
     +           'putbuffer # len=#')
          endif
          call str_integer_write(nout,i,'Putbuf # :'//putbuffer(i))
        enddo
        if(full) then
          call get_inp_getecho(local)
          call str_string_write(nout,local,'echo #')
          call str_2integer_write(nout,WordCount,LineCount,
     +         'Word count = # Line count = #')
        endif
        call get_create_overwrite(boolean)
        if(boolean) then
          call str_write(nout,'create_file overwrites existing files')
        else
          call str_write(nout,'create_file renames existing files')
        endif
        call str_dump
        call str_indent(0)
      endif
      return
      end ! get_inp_status
      subroutine get_inp_substitute(i1,i2,changed)
      implicit none
      integer   i1
      integer   i2
      logical   changed
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      integer   lenstr
      integer   length
      character ROUTINE*(*)
      parameter (ROUTINE='get_inp_substitute')
      integer   n1
      integer   n2
      character word*(long)
      integer   lw
      integer   n
      integer   ln
      character OldWord*(long)
      character NewWord*(long)
      character part2*(long)
      integer   lp2
      integer   lc
      integer   toremove
      logical   localchanged
      word = col(i1:i2)
      call upcase(word,OldWord)
      lw = i2-i1+1
      n1 = index(word,'(')
      n1=0
      if(n1.gt.0) then
        part2 = word(n1:lw)
        word = word(1:n1-1)
        lp2 = lw - n1 + 1
        lw = n1
      else
        lp2 = 0
      endif
      localchanged = .true.
      n1 = index(word,'''')
      if(n1.eq.0) then
        if(SubstituteWhole) then
          call get_inp_search_alias(word,n)
          if(n.gt.0) then
            ln = lenstr(AliasDestination(n))
            word = AliasDestination(n)(1:ln)
            lw = ln
          endif ! n > 0
        endif
      else
        do while(n1.gt.0)
          n2 = index(word(n1+1:),'''')
          if(n2.eq.0) then
            if(n1.eq.lw) then
              word = word(1:lw-1) ! abcd'
              localchanged = .false.
            else if(n1.gt.1) then
              word = word(1:n1-1)//word(n1+1:)   ! ab'cd
              n2 = lw-1
            else
              word = word(2:)   ! 'ab       ! ' extra quote
              n2 = lw-1
            endif
            lw = lw - 1
          else if(n2.eq.1) then
            if(n1.gt.1) then
              word = word(1:n1)//word(n1+2:)     ! ab''cd
            else
              word = word(2:)                    ! ''abc
            endif
            lw = lw - 1
            n2 = n1
            n1 = n2 + 1     ! disable substitution
          else ! n2 > 1
            n2 = n1 + n2
            if(n1.gt.1) then
              word = word(1:n1-1)//word(n1+1:n2-1)//word(n2+1:) ! ab'c'd
            else
              word = word(2:n2-1)//word(n2+1:)                  ! 'cd'e
            endif
            lw = lw - 2
            n2 = n2 - 2
          endif ! n2
          if(n1.le.n2) then
            call get_inp_search_alias(word(n1:n2),n)
            if(n.gt.0) then
              ln = lenstr(AliasDestination(n))
              if(n1.gt.1) then
                word = word(1:n1-1)//AliasDestination(n)(1:ln)//
     +               word(n2+1:)
              else
                word = AliasDestination(n)(1:ln)//word(n2+1:)
              endif
              lw = lw - (n2-n1+1) + ln
              n2 = n1 + ln - 1
            endif ! n > 0
          endif ! n1 < n2
          n1 = index(word(n2+1:),'''')
          if (n1.gt.0) n1 = n1 + n2
        enddo
      endif
      if(lp2.gt.0) then
        call str_concat(word,part2,word)
        lw = lw + lp2
      endif
      call upcase(word,NewWord)
      if(NewWord.eq.OldWord) then
        changed = .false.
        continue
      else
        changed = localchanged
        lc = length(col)
        toremove = i2-i1+1
        if(lc-toremove+lw.gt.len(col)) then
          call str_flush
          call str_string_out(ROUTINE,'buffer overrun in #')
          call str_flush
          call str_string_out(col,'col=[#]')
          call str_flush
          call str_integer_out(lc,'current length=#')
          call str_flush
          call str_integer_out(toremove,'toremove=#')
          call str_string_out(col(i1:i2),'[#]')
          call str_integer_out(lw,'to insert=#')
          call str_string_out(word(1:lw),'[#]')
          call str_flush
          call exitfatal
        endif
        if(i1.gt.1) then
          col = col(1:i1-1)//word(1:lw)//col(i2+1:)
        else
          col = word(1:lw)//col(i2+1:)
        endif
        i2 = i1 + lw - 1
      endif
      return
      end                       ! get_inp_substitute
      subroutine get_inp_upcase(b)
      implicit none
      character b*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      character onoff*3
      if (FirstTime) call get_inp_init(-5)
      call upcase(b,ONOFF)
      DoUpcase = (ONOFF.eq.'ON')
      return
      end                       ! get_inp_upcase
      subroutine get_integer(ix,dd)
      implicit none
      integer   ix
      character dd*(*)
      real*8    r
      call get_double(r,dd)
      ix = nint(r)
      return
      end ! get_integer
      subroutine get_logical(s1,s2)
      implicit none
      character s1*(*)
      character s2*(*)
      integer   lenstr
      character s3*256
      call upcase(s1,s3)
      call getenv(s3(1:lenstr(s3)),s2)
      return
      end ! get_logical
      subroutine get_lun(unit,ier)
      implicit none
      integer unit                        ! returned unit number
      integer ier                         ! 0=ok, <>0 = no free unit available
      integer max_lun
      parameter (max_lun=99)
      integer i
      logical opened
      do i=max_lun,1,-1
        inquire(unit=i,opened=opened)
        if(.not.opened) then
          unit = i
          ier  = 0
          return
        endif
      enddo
      ier = 1
      unit = 0
      return
      end                       ! get_lun
      subroutine get_message(nr,string,ier)
      implicit none
      integer   nr
      character string*(*)
      integer   ier
      call str_integer(nr,'Message error number = #',string)
      ier=0
      return
      end ! get_message
      subroutine get_mode(c)
      implicit none
      character c*(*)
      logical InputFromKeyboard
      character lastmode*11
      save lastmode
      data lastmode /'unknown'/
      if(lastmode.eq.'unknown') then
        if(inputFromKeyboard()) then
          lastmode = 'INTERACTIVE'
        else
          lastmode = 'OTHER'
        endif
      endif
      call CopyStr(lastmode,c)
      return
      end ! get_mode
      subroutine get_newline
      implicit none
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      if (FirstTime) call get_inp_init(-5)
      istart = len(col) + 1
      nitem = 0
      return
      end                       ! get_newline
      character*15 function get_nodename()
      implicit none
      integer mygethostname
      integer lenstr
      character s*100
      integer ier
      integer ls
      ier = mygethostname(s,len(s))
      if (ier.ne.0) then
        get_nodename='HostNameError'
      else
        ls = index(s,'.') - 1
        if(ls.eq.-1) ls = lenstr(s)
        get_nodename=s(1:ls)
      endif
      return
      end ! get_nodename
      subroutine get_processname(value)
      implicit none
      character value*(*)
      integergetpid
      character s*6
      write(s,'(i6.6)') getpid()
      call str_leading(s,value)
      return
      end ! get_processname
      subroutine get_real(x,dd)
      implicit none
      real      x
      character dd*(*)
      integer   iostat
      integer   errpos
      character message*256
      read(dd,*,iostat=iostat) x
      if (iostat.ne.0) then
        call evaluate(dd,.false.,x,errpos,message)
      endif
      return
      end ! get_real
      subroutine get_restline(l)
      implicit none
      character l*(*)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      if (FirstTime) call get_inp_init(-5)
      if(istart.lt.len(col)) then
        l = col(istart:)
      else
        l = ' '
      endif
      return
      end                       ! get_restline
      subroutine get_symbol(symbol,value)
      implicit none
      character symbol*(*)
      character value*(*)
      integer   lenstr
      call getenv(symbol(1:lenstr(symbol)),value)
      return
      end ! get_symbol
      subroutine get_term_size(x,y)
      implicit none
      integer x
      integer y
      call termsz(x,y)
      if(x.eq.0.or.y.eq.0) then
        x = 128
        y = 24
      endif
      return
      end
      character*1 function get_type(dd)
      implicit none
      character dd*(*)
      integer   length
      character type_alfa*1
      character type_real*1
      character type_int*1
      character type*1
      logical   sign_used
      logical   number_used
      integer   i
      data type_alfa,type_real,type_int /'a','r','i'/
      type = type_int
      sign_used = .false.
      number_used = .false.
      do i=1,length(dd)
        if(dd(i:i).ge.'0'.and.dd(i:i).le.'9') then
          number_used = .true.
        else if(dd(i:i).eq.'+'.or.dd(i:i).eq.'-') then
          if(sign_used) then
            get_type = type_alfa
            return
          else if(number_used) then
            get_type = type_alfa
            return
          else
            sign_used = .true.
          endif
        else if(dd(i:i).eq.'.') then
          if(type.eq.type_int) then
            type = type_real
          else if(type.eq.type_real) then
            type = type_alfa
          endif
        else
          get_type = type_alfa
          return
        endif
      enddo
      get_type = type
      return
      end ! get_type
      subroutine get_username(name)
      implicit none
      character name*(*)
      call getenv('LOGNAME',name)
      return
      end ! get_username
      subroutine GetBackSlash(result)
      character result*1        ! output
      result = '\' ! '
      return
      end                       ! GetBackSlash
      subroutine GetFullImageName(result)
      character result*(*)
      character name*80
      integer   ln
      character release*80
      integer   lr
      integer   version
      call image_name(name,ln)
      call image_version(release,lr,version)
      if(lr.gt.0.and.version.gt.0) then
        call str_string(name,'# (version # #)',result)
        call str_string(release,result,result)
        call str_integer(version,result,result)
      else if(lr.gt.0) then
        call str_string(name,'# (version #)',result)
        call str_string(release,result,result)
      else if(version.gt.0) then
        call str_string(name,'# (version #)',result)
        call str_integer(version,result,result)
      else
        call copystr(name,result)
      endif
      return
      end                       ! GetFullImageName
      subroutine GetMat(mlist,Position,m)
      implicit none
      real    mlist(3,3,*)      ! input: array of matrices
      integer Position          ! input: element nr
      real    m(3,3)            ! output
      integer i
      integer j
      character message*80
      if(Position.le.0) then
        call str_integer(Position,'GetMat',message)
        call AbortMessage(message)
      endif
      do j=1,3
        do i=1,3
          m(i,j) = mlist(i,j,Position)
        enddo
      enddo
      return
      end                       ! GetMat
      subroutine GetNormal(v1,v2,v3,normal)
      real v1(3)                ! input
      real v2(3)                ! input
      real v3(3)                ! input
      real normal(3)            ! output
      real absvec
      real v12(3)
      real v23(3)
      real v31(3)
      real av12
      real av23
      real av31
      call vecProd(v1,v2,v12)
      call vecProd(v2,v3,v23)
      call vecProd(v3,v1,v31)
      call Sum3Vec(v12,v23,v31,normal)
      if(absvec(normal).lt.0.1) then
        av12 = AbsVec(v12)
        av23 = AbsVec(v23)
        av31 = AbsVec(v31)
        call CopyVec(v12,normal)
        if(av23.gt.av12) then
          if(av23.gt.av31) then
            call CopyVec(v23,normal)
          else
            call CopyVec(v31,normal)
          endif
        else if(av31.gt.av12) then
          if(av31.gt.av23) then
            call CopyVec(v31,normal)
          else
            call copyvec(v23,normal)
          endif
        endif
      endif
      return
      end                       ! GetNormal
      subroutine GetOutputValue(variable,value)
      character variable*(*)
      integer   value
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      if(variable.eq.'none') then
        value = OutputNone
      else if(variable.eq.'normal') then
        value = OutputNormal
      else if(variable.eq.'full') then
        value = OutputFull
      else if(variable.eq.'debug') then
        value = OutputDebug
      else
        value = -1
      endif
      return
      end                       ! GetOutputValue
      subroutine getpar(n,text,error)
      implicit none
      integer   n
      character text*(*)
      integer   error
      integeriargc
      error = 0
      if (iargc().lt.n) error=1
      if (error.eq.0) then
        call getarg(n,text)
      else
        text = ' '
      endif
      return
      end                       ! getpar
      subroutine GetRotVec2Vec(out,v1,v2,rotmat,rotvec,rotang)
      implicit none
      integer   out             ! input (>0 = do output)
      real      v1(3)           ! input
      real      v2(3)           ! input
      real      rotmat(3,3)     ! output
      real      rotvec(3)       ! output
      real      rotang          ! output
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      logical   debug
      parameter (debug=.false.)
      real      angv2
      real      w(3)
      rotang = AngV2(v1,v2)
      if(abs(rotang).gt.1.0e-6) then
        call VecProd(v1,v2,rotvec)
        call generalRotMat(rotvec,rotang,rotmat)
      else
        call UnitMatrix(rotmat)
        call BuildVector(0.0,0.0,1.0,rotvec)
      endif
      if(out.gt.0) then
        call str_flush
        call writemat(out,rotmat,'GetRotVec2Vec')
        call str_vector_out(rotvec,'RotVec=')
        call str_grad_out(rotang,'RotAng=#')
        call str_flush
      endif
      if(debug) then
        call str_flush
        call str_real_len_push(5)
        call str_vector_out(v1,'v1=')
        call str_vector_out(v2,'v2=')
        call MatVec(rotmat,v1,w)
        call str_vector_out(w,'v3=')
        call str_real_len_pop
        call str_flush
      endif
      return
      end                       ! GetRotVec2Vec
      subroutine GetVec(vlist,Position,v)
      implicit none
      real    vlist(3,*)        ! input
      integer Position          ! input
      real    v(3)              ! output
      character message*80
      if(Position.le.0) then
        call str_integer(Position,'GetVec',message)
        call AbortMessage(message)
      endif
      v(1) = vlist(1,Position)
      v(2) = vlist(2,Position)
      v(3) = vlist(3,Position)
      return
      end                       ! GetVec
      subroutine GetVecI(vlist,Position,v)
      implicit none
      integer vlist(3,*)        ! input
      integer Position          ! input
      integer v(3)              ! output
      character message*80
      if(Position.le.0) then
        call str_integer(Position,'GetVecI',message)
        call AbortMessage(message)
      endif
      v(1) = vlist(1,Position)
      v(2) = vlist(2,Position)
      v(3) = vlist(3,Position)
      return
      end                       ! GetVecI
      subroutine GradVec(u,v)
      real u(3)                 ! input
      real v(3)                 ! output
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      call FacVec(grad,u,v)
      return
      end                       ! Gradvec
      subroutine help(library,key,ier)
      implicit none
      character library*(*)
      character key*(*)
      integer   ier
      integer   maxitem
      parameter (maxitem=500)
      logical   debug
      parameter (debug=.false.)
      integer   lenstr
      integer   length
      character filename*256
      integer   lf
      integer   unit
      integer   ni
      integer   nl
      character line*256
      character item(maxitem)*20
      integer   li
      character lcitem(maxitem)*20
      integer   level(maxitem)
      integer   start(maxitem)
      integer   stop(maxitem)
      integer   i
      integer   LL
      integer   iostat
      integer   currentlevel
      integer   nextlevel
      integer   pointer
      integer   k1,k2
      character answer*80
      integer   la
      character lclkey*80
      logical   display
      integer   pagex,pagey
      character message*256
      integer   iy
      integer   lkey
      lclkey = key
      call build_file(library,'help','.hlp',filename,lf)
      call open_file(filename(1:lf),unit,message,ier)
      if(ier.ne.0) then
        call str_write(6,message)
        return
      endif
      call get_term_size(pagex,pagey)
      if(pagex.gt.len(line)) pagex = len(line)
      ni = 1
      nl = 0
      start(ni) = 0
      stop(ni) =  0
      level(ni) = 0
      call filescan(filename,'NAME',item(ni),li)
      read(unit,100,iostat=iostat) line
  100 format(a)
      do while(iostat.eq.0)
        nl = nl + 1
        if(line(1:1).ge.'1'.and.line(1:1).le.'9'.and.
     1   line(2:2).eq.' ') then
          if(ni.lt.maxitem) then
            ni = ni + 1
          else
            call str_write(6,'Too many items in help')
          endif
          start(ni) = 0
          stop(ni) = 0
          call str_leading(line(2:),item(ni))
          call lowercase(item(ni),lcitem(ni))
          level(ni) = ichar(line(1:1))-48
        else
          if(start(ni).eq.0) start(ni) = nl
          stop(ni) = stop(ni) + 1
        endif
        read(unit,100,iostat=iostat) line
      enddo
      if(debug) call str_num_write(6,ni,'# item^')
      currentlevel = 0
      pointer = 1
   10 continue
      display = (length(lclkey).eq.0)
      if(.not.display) then
        call str_header(lclkey,answer,la,lclkey,lkey)
      else
        if(debug) call str_integer_write(6,currentlevel,'currentlevel=')
        if (currentlevel.lt.0) goto 900
        rewind unit
        do i=1,start(pointer)-1
          read(unit,100)
        enddo
        iy = 0
        do i=1,stop(pointer)
          read(unit,100) line
          write(6,100) line(1:lenstr(line))
          iy = iy + 1
          if(iy.gt.pagey) then
            call termline('Type return',answer,ier)
            iy = 0
          endif
        enddo
      endif
      nextlevel = currentlevel + 1
      i = pointer+1
      k1 = 0
      k2 = 0
      line = ' '
      LL = 1
      do while(i.le.ni)
        if(level(i).eq.nextlevel) then
          if(k1.eq.0) then
            if(display) call str_write(6,'Information available on:')
            k1 = i
          endif
          k2 = i
          li = length(item(i))
          if(LL+li.ge.pagex) then
            if(display) write(6,100) line(1:Lenstr(line))
            line = ' '
            LL = 1
          endif
          line = line(1:LL)//item(i)
          LL = LL + 10*(1+(li/10))
        else if(level(i).lt.nextlevel) then
          i = ni
        endif
        i = i + 1
      enddo
      if(display) then
        if(LL.gt.1) write(6,100) line(1:Lenstr(line))
        if(currentlevel.eq.0) then
          line = 'Topic?'
        else if(k1.eq.0) then
          line = 'type return'
        else
          li = lenstr(item(pointer))
          line = item(pointer)(1:li)//' Subtopic?'
        endif
        ll = lenstr(line)
        if(debug) call str_write(6,'before termline:'//line(1:ll))
        call termline(line(1:ll),answer,ier)
        if(debug) call str_integer_write(6,ier,'error after termline=#')
        if(ier.ne.0) then
          call str_write(6,' ')
          goto 900
        endif
      endif
      la = length(answer)
      call lowercase(answer,answer)
      if(la.eq.0) then
        currentlevel = currentlevel - 1
        k1 = pointer
        do i=1,k1
          if(level(i).eq.currentlevel) pointer = i
        enddo
        goto 10
      else if(k1.eq.0) then
        if(answer(1:1).eq.'q') then
          goto 900
        endif
        currentlevel = currentlevel - 1
        k1 = pointer
        do i=1,k1
          if(level(i).eq.currentlevel) pointer = i
        enddo
        goto 10
      else
        do i=k1,k2
          if(level(i).eq.nextlevel) then
            if(answer(1:la).eq.lcitem(i)(1:la)) then
              pointer = i
              currentlevel = nextlevel
              goto 10
            endif
          endif
        enddo
        if(answer(1:1).eq.'q') then
          goto 900
        endif
        call str_write(6,answer//' not found')
        if(display) then
          lclkey = ' '
          currentlevel = 0
        endif
        goto 10
      endif
  900 continue
      close(unit)
      ier = 0
      return
      end ! help
      subroutine image_file(name,ln)
      implicit none
      character name*(*)
      integer   ln
      integer   lenstr
      integer   ier
      call getpar(0,name,ier)
      ln = lenstr(name)
      return
      end                       ! image_file
      subroutine image_help(name,text,ier)
      implicit  none
      character name*(*)
      character text*(*)
      integer   ier
      character url*256
      call SearchUrl(name,text,url,ier)
      if(ier.eq.0) then
        call WebBrowser(url,ier)
        return
      endif
      call SearchHlp(url,ier)
      if(ier.eq.0) then
        call help(url,text,ier)
        return
      endif
      call str_out('Could not find html or hlp files')
      call str_flush
      ier = 1
      return
      end                       ! image_help
      subroutine image_name(name,ln)
      implicit none
      character name*(*)
      integer   ln
      character s*80
      integer   ls
      integer MyImageNameLength
      integer MyImageReleaseLength
      integer MyImageVersion
      common / common_imagename/ MyImageNameLength,MyImageReleaseLength,
     + MyImageVersion
      character MyImageName*80
      character MyImageRelease*80
      common / common_imagename_char/ MyImageName,MyImageRelease
      external common_imagenameXXX
      if(MyImageNameLength.eq.0) then
        call image_file(s,ls)
        call filescan(s(1:ls),'NAME',MyImageName,MyImageNameLength)
      endif
      call copystr(MyImageName(1:MyImageNameLength),name)
      ln = MyImageNameLength
      return
      end                       ! image_name
      subroutine image_path(name,ln)
      implicit none
      character name*(*)
      integer   ln
      integer   lenstr
      character s*80
      integer   ls
      integer   ier
      call image_file(s,ls)
      call filescan(s(1:ls),'PATH',name,ln)
      if(ln.eq.0) then
        call get_default_directory(name,ier)
        ln = lenstr(name)
      else if(name(1:ln).eq.'./') then
        call get_default_directory(name,ier)
        ln = lenstr(name)
      endif
      return
      end                       ! image_path
      subroutine image_version(release,lr,version)
      implicit none
      character release*(*)
      integer   lr
      integer   version
      integer MyImageNameLength
      integer MyImageReleaseLength
      integer MyImageVersion
      common / common_imagename/ MyImageNameLength,MyImageReleaseLength,
     + MyImageVersion
      character MyImageName*80
      character MyImageRelease*80
      common / common_imagename_char/ MyImageName,MyImageRelease
      external common_imagenameXXX
      if(MyImageReleaseLength.eq.0) then
        release = ' '
      else
        call CopyStr(MyImageRelease(1:MyImageReleaseLength),release)
      endif
      lr = MyImageReleaseLength
      version = MyImageVersion
      return
      end                       ! image_version
      integer function indexL(s,c)
      character s*(*)
      character c*(*)
      integer lc,ls
      integer i,n
      lc = len(c)
      ls = len(s)
      do i=ls-lc+1,1,-1
        if(s(i:i+lc-1).eq.c(1:lc)) then
          n = i
          goto 20
        endif
      enddo
      n = ls
   20 continue
      indexl = n
      return
      end ! indexL
      logical function InputFromKeyboard()
      implicit none
      integer   lastmode
      save lastmode
      data lastmode /-1/
      if(lastmode.eq.-1) then
        call myinputmode(lastmode)
      endif
      InputFromKeyboard= (lastmode.eq.1)
      return
      end !  InputFromKeyboard()
      logical function interrupted()
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      logical debug
      parameter (debug=.false.)
      logical   str_startswith
      integer   length
      character datetime*20
      integer   getcc
      external  getcc
      integer   count
      integer   ier
      character col*80
      character c*1
      character myprog*80
      integer   lm
      character prompt*80
      if (action.eq.0) then
        if(debug) write(77,*) datetime(),' DBG action=0'
        interrupted=.false.
        return
      endif
      count=getcc()
      if(debug) write (77,*) datetime(),' DBG> count=',count,
     +     ' self=',selfinterrupt,' action=',action
      if (count+selfinterrupt.eq.0) then
        interrupted=.false.
        return
      endif
      if (action.eq.0) then
        if(debug)write(77,*) datetime(),' DBG> Interrupt ignored'
        interrupted=.false.
      else if (action.eq.1) then
        if(debug) write(77,*) datetime(),
     +       ' DBG> Interrupted, back to command line'
        call get_inp_flush_all
        interrupted=.true.
      else if (action.eq.2) then
        if(debug) write(77,*) datetime(),' DBG> Interrupted action 2'
        call get_mode(c)
        if(c.eq.'I') then
          if(debug) write(77,*) datetime(),' INTERACIVE'
          call image_name(myprog,lm)
          call str_string(myprog,'Do you want to terminate # [y]?',
     +         prompt)
          call termline(prompt(1:length(prompt)),col,ier)
          if (ier.ne.0) then
            if(debug) write(77,*) datetime(),' DBG> exitfatal ier'
            call exitfatal
          else if (length(col).eq.0) then
            if(debug) write(77,*) datetime(),' DBG> exitfatal length'
            call exitfatal
          else if (str_startswith(col,'y')) then
            if(debug) write(77,*) datetime(),' DBG> exitfatal yes'
            call exitfatal
          endif
        else
          if(debug) write(77,*) datetime(),' non INTERACIVE'
        endif
        interrupted=.true.
        action = 3
      else if (action.eq.3) then
        if(debug) write(77,*) datetime(),
     +       ' DBG> Interrupted exitfatal at action 3'
        call exitfatal
        interrupted=.false.
      else if (action.eq.4) then
        if(debug) write(77,*) datetime(),
     +       ' DBG> Interrupted core dump at action 4'
        call abort
        interrupted=.false.
      else
        if(debug) write(77,*) datetime(),
     +       'DBG> Interrupted, illegal interrupt action'
        interrupted=.true.
      end if
      return
      end
      subroutine InvertMat(u,v,ier)
      implicit none
      real    u(3,3)            ! input
      real    v(3,3)            ! output
      integer ier               ! output
      real    MatVol
      real    x(3,3)
      real    volu
      volu = MatVol(u)
      if(abs(volu).lt.1.0e-10) then
        ier = 1
        call UnitMatrix(v)
      else
        ier = 0
        x(1,1) =  (u(2,2)*u(3,3)-u(2,3)*u(3,2)) /volu
        x(1,2) = -(u(2,1)*u(3,3)-u(2,3)*u(3,1)) /volu
        x(1,3) =  (u(2,1)*u(3,2)-u(2,2)*u(3,1)) /volu   ! 11 12 13
        x(2,1) = -(u(1,2)*u(3,3)-u(1,3)*u(3,2)) /volu   ! 21 22 23
        x(2,2) =  (u(1,1)*u(3,3)-u(1,3)*u(3,1)) /volu   ! 31 32 33
        x(2,3) = -(u(1,1)*u(3,2)-u(1,2)*u(3,1)) /volu
        x(3,1) =  (u(1,2)*u(2,3)-u(1,3)*u(2,2)) /volu
        x(3,2) = -(u(1,1)*u(2,3)-u(1,3)*u(2,1)) /volu
        x(3,3) =  (u(1,1)*u(2,2)-u(1,2)*u(2,1)) /volu
        call TransMat(x,v)
      endif
      return
      end                       ! InvertMat
      integer function length(str)
      implicit none
      character str*(*)
      integer   ic
      integer   i
      do i=len(str),1,-1
        ic = ichar(str(i:i))
        if(ic.ne.ichar(' ').and.ic.ne.0) then
          length = i
          return
        endif
      enddo
      length = 0
      return
      end ! length
      integer function lenstr(s)
      implicit none
      character s*(*)
      integer   length
      lenstr = max(1,length(s))
      return
      end ! lenstr
      subroutine lowercase(string1,string2)
      implicit none
      character string1*(*)     ! input
      character string2*(*)     ! output
      integer   length
      character c*1
      integer   i
      integer   delta
      integer   ls
      delta = ichar('a')-ichar('A')
      ls = length(string1)
      if(ls.eq.0) then
        string2 = ' '
        return
      endif
      call CopyStr(string1(1:ls),string2)
      do i=1,ls
        c = string2(i:i)
        if(c.ge.'A'.and.c.le.'Z') then
          string2(i:i) = char( ichar(c)+delta)
        endif
      enddo
      return
      end
      subroutine MakeViewMat(v,m)
      implicit none
      real    v(3)              ! input
      real    m(3,3)            ! output
      real    Ax(3)
      real    Ay(3)
      real    Az(3)
      real    f
      integer normerror
      call NormVec(v,Az,normerror)
      if(normerror.ne.0) then
        call UnitMatrix(m)
        return
      endif
      f = sqrt(Az(1)**2 + Az(2)**2)
      if(f.gt.0.00001745) then
        call BuildVector(-Az(2)/f, Az(1)/f, 0.0, Ax)
      else
        call BuildVector(1.0, 0.0, 0.0, Ax)
      endif
      call VecProd(Az,Ax,Ay)
      call Vec2Row(Ax,m,1)
      call Vec2Row(Ay,m,2)
      call Vec2Row(Az,m,3)
      return
      end                       ! MakeViewMat
      subroutine MatMat(r,s,t)  ! FFF
      implicit none
      real    r(3,3)            ! input
      real    s(3,3)            ! input
      real    t(3,3)            ! output
      real    u(3,3)
      u(1,1) = r(1,1)*s(1,1) + r(1,2)*s(2,1) + r(1,3)*s(3,1)
      u(1,2) = r(1,1)*s(1,2) + r(1,2)*s(2,2) + r(1,3)*s(3,2)
      u(1,3) = r(1,1)*s(1,3) + r(1,2)*s(2,3) + r(1,3)*s(3,3)
      u(2,1) = r(2,1)*s(1,1) + r(2,2)*s(2,1) + r(2,3)*s(3,1)
      u(2,2) = r(2,1)*s(1,2) + r(2,2)*s(2,2) + r(2,3)*s(3,2)
      u(2,3) = r(2,1)*s(1,3) + r(2,2)*s(2,3) + r(2,3)*s(3,3)
      u(3,1) = r(3,1)*s(1,1) + r(3,2)*s(2,1) + r(3,3)*s(3,1)
      u(3,2) = r(3,1)*s(1,2) + r(3,2)*s(2,2) + r(3,3)*s(3,2)
      u(3,3) = r(3,1)*s(1,3) + r(3,2)*s(2,3) + r(3,3)*s(3,3)
      call CopyMat(u,t)
      return
      end                       ! Matmat
      subroutine MatVec(r,v,u)
      implicit none
      real    r(3,3)            ! input
      real    v(3)              ! input
      real    u(3)              ! output
      real    x1
      real    x2
      x1 = r(1,1)*v(1) + r(1,2)*v(2) + r(1,3)*v(3)
      x2 = r(2,1)*v(1) + r(2,2)*v(2) + r(2,3)*v(3)
      u(3) = r(3,1)*v(1) + r(3,2)*v(2) + r(3,3)*v(3)
      u(1) = x1
      u(2) = x2
      return
      end                       ! MatVec
      subroutine MatVecFIF(r,v,u)
      implicit none
      real    r(3,3)            ! input
      integer v(3)              ! input
      real    u(3)              ! output
      real    w(3)
      call CopyVecIF(v,w)
      call MatVec(r,w,u)
      return
      end                       ! MatVecFIF
      real function MatVol(r)
      implicit none
      real r(3,3)               ! input
      MatVol = r(1,1)*r(2,2)*r(3,3) + ! 11 12 13 11 12
     1     r(1,2)*r(2,3)*r(3,1) + ! 21 22 23 21 22
     2     r(1,3)*r(2,1)*r(3,2) - ! 31 32 33 31 32
     3     r(3,1)*r(2,2)*r(1,3) -
     4     r(3,2)*r(2,3)*r(1,1) -
     5     r(3,3)*r(2,1)*r(1,2)
      return
      end                       ! MatVol
      subroutine more(delta,header)
      implicit none
      integer   delta
      character header*(*)
      integer   length
      integer   lh
      integer   iostat
      integer   ncol
      character c*1
      character mode*1
      integer   nout
      logical   question
      logical   init
      logical   interactive
      integer   nrow
      character formatstring*6
      integer   lf
      save nout,question,init,interactive,nrow,formatstring,lf
      data init /.true./
      if(init) then
        call get_mode(mode)
        interactive = (mode.eq.'I')
        init = .false.
        call get_term_size(ncol,nrow)
        if(nrow.lt.5) nrow = 5
        question = .true.
        nout = 0
        formatstring='(A)'
        lf = 3
      endif
      if(delta.lt.0) then
        lh = length(header)
        if(lh.gt.0) write (6,formatstring(1:lf)) header(1:lh)
      endif
      if(interactive) then
        if(delta.eq.0) then
          nout = 0
        else if(delta.lt.0) then
          nout = 1
        else
          nout = nout + delta
        endif
        if(nout.gt.nrow-2) then
          if(question) then
            call termline('Type return to continue >',c,iostat)
            call upcase(c,c)
            if(iostat.ne.0) c = 'A'
            if(c.eq.'A') then
              question = .false.
            else if(c.eq.'Q') then
              call exitfatal
            endif
          endif
          lh = length(header)
          if(lh.gt.0) then
            write (6,formatstring(1:lf)) header(1:lh)
            nout = 1
          else
            nout = 0
          endif
        endif
      endif
      return
      end ! more
      real function myacos(arg)
      real arg                  ! input
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      if(arg.gt.1.0) then
        myacos = 0
      else if(arg.lt.-1.0) then
        myacos = Pi
      else
        myacos = acos(arg)
      endif
      return
      end
      real function myran(iseed)
      implicit none
      integer iseed
      integer ia,ic,im
      parameter(ia=7141,ic=54773,im=259200)
      iseed=mod(iseed*ia+ic,im)
      myran=float(iseed)/float(im)
      return
      end
      subroutine mywait(delta)
      implicit none
      real delta
      if(delta.ge.0.0) then
        call mysleep(delta)
      else
        call operator
      endif
      return
      end                       ! mywait
      subroutine NegVec(v,w)
      real    v(3)              ! input
      real    w(3)              ! output
      integer i
      do i=1,3
        w(i) = -v(i)
      enddo
      return
      end                       ! NegVec
      subroutine NegVecI(v,w)
      integer v(3)              ! input
      integer w(3)              ! output
      integer i
      do i=1,3
        w(i) = -v(i)
      enddo
      return
      end                       ! NegVecI
      subroutine NormVec(v,w,ier)
      implicit none
      real    v(3)              ! input
      real    w(3)              ! output
      integer ier               ! output
      real    AbsVec
      real    s
      real    f
      s = AbsVec(v)
      if(s.lt.1.0e-8) then   ! 1.0e-15
        ier = 1
        call BuildVector(0.0,0.0,0.0,w)
      else
        f = 1.0/s
        w(1) = f*v(1)
        w(2) = f*v(2)
        w(3) = f*v(3)
        ier = 0
      endif
      return
      end                       ! NormVec
      subroutine open_file(fn,unit,message,error)
      implicit none
      character fn*(*)
      integer   unit
      character message*(*)
      integer   error
      character ROUTINE*(*)
      parameter (ROUTINE='open_file')
      character filename*256
      integer   lf
      character fm*1
      call tilde(fn,filename,lf)
      if(lf.eq.0) then
        call str_string(ROUTINE,'empty filename in #',message)
        error = 1
        return
      endif
      call get_lun(unit,error)
      if(error.ne.0) then
        call str_2string(ROUTINE,filename(1:lf),
     +       'No free unit in # for #',message)
        return
      endif
      call filemode(filename(1:lf),fm)
      if(fm.eq.'d') then
        error = 1
        call str_string(filename(1:lf),
     +       'Error file # is a directory',message)
        return
      endif
      open(unit=unit,file=filename(1:lf),status='old',action='read',
     +     iostat=error)
      if(error.ne.0) then
        call str_integer(error,'Error # opening #',message)
      else
        message = 'Opened #'
      endif
      call str_string(filename(1:lf),message,message)
      return
      end                       ! open_file
      subroutine operator
      character c*1
      call OperatorWait(c)
      return
      end                       ! Operator
      subroutine OperatorWait(c)
      character c*(*)
      integer   iostat
      call str_flush
      call termline('Type return to continue >',c,iostat)
      if(iostat.ne.0) call exitfatal
      if(c.eq.'Q'.or.c.eq.'q') call exitfatal
      return
      end                       ! OperatorWait
      logical function OutputToScreen()
      implicit none
      integer   lastmode
      save lastmode
      data lastmode /-1/
      if(lastmode.eq.-1) then
        call myoutputmode(lastmode)
      endif
      OutputToScreen = (lastmode.eq.1)
      return
      end ! get_mode
      subroutine path_basename(s1,s2)
      character s1*(*)
      character s2*(*)
      integer   length
      integer   indexL
      integer   ls1
      integer   i
      ls1=length(s1)
      if(ls1.eq.0) then
        s2 = ' '
        return
      endif
      if(s1(ls1:ls1).eq.'/') then
        if(ls1.gt.1) then
          ls1 = ls1 - 1
        endif
      endif
      i=indexL(s1(1:ls1),'/')
      if(i.eq.ls1) then ! not found
        call copystr(s1(1:ls1),s2)
      else
        call copystr(s1(i+1:ls1),s2)
      endif
      return
      end                       ! path_basename
      subroutine path_dirname(s1,s2)
      character s1*(*)
      character s2*(*)
      integer   length
      integer   indexL
      integer   ls1
      integer   i
      ls1=length(s1)
      if(ls1.eq.0) then
        s2 = ' '
        return
      endif
      if(s1(ls1:ls1).eq.'/') then
        if(ls1.gt.1) then
          ls1 = ls1 - 1
        endif
      endif
      i=indexL(s1(1:ls1),'/')
      if(i.eq.ls1) then ! not found
        s2 = ' '
      else
        call copystr(s1(1:i),s2)
      endif
      return
      end                       ! path_dirname
      subroutine path_join(s1,s2,sout)
      character s1*(*)
      character s2*(*)
      character sout*(*)
      integer   lenstr
      integer   length
      integer   ls1, ls2
      character t*512
      if (s2(1:1).eq.'/') then
        call copystr(s2,sout)
        return
      endif
      ls1=length(s1)
      if(ls1.eq.0) then
        call copystr(s2,sout)
        return
      endif
      ls2=lenstr(s2)
      if(s1(ls1:ls1).eq.'/') then
        call copy2str(s1(1:ls1),s2(1:ls2),sout)
      else
        call copy2str(s1(1:ls1),'/',t)
        call copy2str(t(1:ls1+len('/')),s2(1:ls2),sout)
      endif
      return
      end                       ! path_join
      subroutine path_name_ext(path,name,ext,out)
      character path*(*)
      character name*(*)
      character ext*(*)
      character out*(*)
      integer   length
      character s*256
      integer   ln
      integer   le
      integer   lp
      ln = length(name)
      if(ln.eq.0) then
        call copystr(ext,s)
      else
        le = length(ext)
        if(le.eq.0) then
          call copystr(name,s)
        else
          call copy2str(name(1:ln),ext(1:le),s)
        endif
      endif
      lp = length(path)
      if(lp.eq.0) then
        call copystr(s,out)
      else
        call path_join(path(1:lp),s,out)
      endif
      return
      end                       ! path_name_ext
      subroutine PosVec(v,vlist,size,tol,position)
      real    v(3)              ! input
      real    vlist(3,*)        ! input
      integer size              ! input
      real    tol               ! input
      integer position          ! output: 0=not found
      logical SameVec
      integer i
      real    w(3)
      do i=1,size
        call getVec(vlist,i,w)
        if(SameVec(v,w,tol)) then
          position = i
          return
        endif
      enddo
      position = 0
      return
      end                       ! PosVec
      subroutine PosVecI(v,vlist,size,position)
      integer v(3)              ! input
      integer vlist(3,*)        ! input
      integer size              ! input
      integer position          ! output 0=not found
      integer i
      do i=1,size
        if(v(1).eq.vlist(1,i).and.v(2).eq.vlist(2,i).and.
     +       v(3).eq.vlist(3,i)) then
          position = i
          return
        endif
      enddo
      position = 0
      return
      end                       ! PosVecI
      subroutine put_inp(dd,status)
      implicit none
      character dd*(*)
      integer   status ! 1=non-fatal 2=fatal
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      if (FirstTime) call get_inp_init(-5)
      if(PutbufferPointer.ge.MaxPutbuffer) then
        call get_inp_error(1,'put buffer overflow')
        return
      endif
      PutbufferPointer = PutbufferPointer + 1
      putbuffer(PutbufferPointer) = dd
      PutBufferStatus(PutBufferPointer) = status
      if(OutputLevel.ge.OutputDebug) then
        call str_flush
        call str_integer_out(PutBufferPointer,'DBG putinp #:')
        call str_string_out(dd,'[#]')
        call str_integer_out(status,'(status=#)')
        call str_flush
      endif
      return
      end                       ! put_inp
      subroutine randomize(seed)
      implicit none
      integer seed
      character rolex*10
      integergetpid
      character t*10
      integer n1,n2,n3
      t = rolex()
      read(t,100) n1,n2,n3
  100 format(1x,i2,1x,i2,1x,i2)
      seed = ((n1+1)*(n2+1)*(n3+1)*2)+1
      n1 = getpid()
      seed = ieor(seed,n1)
      call randseed(seed)
      return
      end ! randomize
      subroutine RandSeed(s)
      implicit none
      integer s
      integer seed
      common /rnd___random/ seed
      seed = s
      return
      end ! randseed
      subroutine RemoveMountpoint(source,result)
      character source*(*)
      character result*(*)
      if(source(1:18).eq.'/var/autofs/pauken') then
        result = source(19:)
      else if(source(1:19).eq.'/var/autofs/timpani') then
        result = source(20:)
      else
        result = source
      endif
      return
      end                       ! RemoveMountPoint
      subroutine rename_file(file1,file2,message,ier)
      implicit none
      character file1*(*)
      character file2*(*)
      character message*(*)
      integer ier
      integer   lenstr
      integer   myrename
      character f1*256
      character f2*256
      integer   lf1
      integer   lf2
      f1 = file1
      f2 = file2
      lf1 = lenstr(f1)
      lf2 = lenstr(f2)
      call rename_unique_file(f2(1:lf2),message,ier)
      if(ier.ne.0) return
      ier = myrename(f1(1:lf1),f2(1:lf2))
      if(ier.eq.0) then
        message = 'renamed # into #'
      else
        message = 'cannot rename # into #'
      endif
      call str_2string(f1(1:lf1),f2(1:lf2),message,message)
      return
      end                       ! rename_file
      subroutine rename_unique_file(globalin,message,ier)
      implicit none
      character globalin*(*)
      character message*(*)
      integer   ier
      integer   lenstr
      integer   myrename
      integer   li
      character f*256
      integer   lf
      logical   exist
      integer   ic
      character template*256
      integer   lt
      character in*256
      call tilde(globalin,in,li)
      if(li.eq.0) then
        message = 'empty filename in RenameUnique'
        ier = 1
        return
      endif
      inquire(file=in(1:li),exist=exist)
      if(.not.exist) then
        call str_string(in(1:li),
     +       'RenameUnique: file # does not exist',message)
        ier = 0
        return
      endif
      template = in(1:li)
      lt = li
      ic = 0
      template(lt+1:lt+4) = '.~#~'
      lt = lt + 4
      lf = 0                    ! compiler warning
      do while(exist)
        ic = ic + 1
        call str_integer(ic,template,f)
        lf = lenstr(f)
        inquire(file=f(1:lf),exist=exist)
      enddo
      ier = myrename(in(1:li),f(1:lf))
      if(ier.eq.0) then
        call str_2string(in(1:li),f(1:lf),
     +       'renaming existing file # into #',message)
        call WarningMessage(message)
      else
        call str_2string(in(1:li),f(1:lf),
     +       'ERROR: could not rename existing file # into #',message)
      endif
      return
      end                       ! rename_unique_file
      subroutine resetinterrupt
      integer selfinterrupt,action,stack(10),stackp
      common /ccstatus/ selfinterrupt,action,stack,stackp
      data selfinterrupt,action,stackp /0,0,0/
      if (action.gt.0) then
        selfinterrupt = 0
        call setcc
      endif
      return
      end
      real function Rnd()
      implicit none
      real    myran
      integer seed
      common /rnd___random/ seed
      data seed /-1/
      if(seed.eq.-1) call randomize(seed)
      rnd = myran(seed)
      return
      end ! rnd
      character*10 function rolex()
      implicit none
      character hlp*8
      call mytime(hlp)
      rolex = ' '//hlp(1:8)//' '
      return
      end                       ! rolex
      subroutine RotateMat(rold,rotvec,rotang,rnew)
      implicit none
      real rold(3,3)            ! input
      real rotvec(3)            ! input
      real rotang               ! input
      real rnew(3,3)            ! output
      real rotmat(3,3)
      call GeneralRotMat(rotvec,rotang,rotmat)
      call MatMat(rotmat,rold,rnew)
      return
      end                       ! RotateMat
      subroutine Row2Vec(RowNumber,m,v)
      implicit none
      integer RowNumber         ! input
      real    m(3,3)            ! input
      real    v(3)              ! output
      integer i
      character message*80
      if(RowNumber.lt.1.or.RowNumber.gt.3) then
        call str_integer(RowNumber,'Row2Vec #',message)
        call AbortMessage(message)
      endif
      do i=1,3
        v(i) = m(RowNumber,i)
      enddo
      return
      end                       ! Row2Vec
      logical function SameVec(v1,v2,tol)
      real    v1(3)             ! input
      real    v2(3)             ! input
      real    tol               ! input
      integer i
      real    diff
      do i=1,3
        diff = abs(v1(i) - v2(i))
        if(diff.gt.tol) then
          SameVec = .false.
          return
        endif
      enddo
      SameVec = .true.
      return
      end                       ! SameVec
      logical function SameVecI(v1,v2)
      integer v1(3)             ! input
      integer v2(3)             ! input
      integer i
      do i=1,3
        if(v1(i)-v2(i).ne.0) then
          SameVecI = .false.
          return
        endif
      enddo
      SameVecI = .true.
      return
      end                       ! SameVecI
      subroutine SaveMat(m,mlist,position)
      implicit none
      real    m(3,3)            ! input
      real    mlist(3,3,*)      ! input/output
      integer position          ! input
      integer i
      integer j
      character message*80
      if(position.le.0) then
        call str_integer(position,'SaveMat',message)
        call AbortMessage(message)
      endif
      do j=1,3
        do i=1,3
          mlist(i,j,position)= m(i,j)
        enddo
      enddo
      return
      end                       ! SaveMat
      subroutine SaveVec(v,vlist,position)
      implicit none
      real    v(3)              ! input
      real    vlist(3,*)        ! input/output
      integer position          ! input
      character message*80
      if(position.le.0) then
        call str_integer(position,'SaveVec',message)
        call AbortMessage(message)
      endif
      vlist(1,position) = v(1)
      vlist(2,position) = v(2)
      vlist(3,position) = v(3)
      return
      end                       ! SaveVec
      subroutine SaveVecI(v,vlist,position)
      implicit none
      integer v(3)              ! input
      integer vlist(3,*)        ! input/output
      integer position          ! input
      character message*80
      if(position.le.0) then
        call str_integer(position,'SaveVecI',message)
        call AbortMessage(message)
      endif
      vlist(1,position) = v(1)
      vlist(2,position) = v(2)
      vlist(3,position) = v(3)
      return
      end                       ! SaveVecI
      real function ScalProd(u,v)
      implicit none
      real u(3)                 ! input
      real v(3)                 ! input
      ScalProd = u(1)*v(1) + u(2)*v(2) + u(3)*v(3)
      return
      end                       ! ScalProd
      subroutine SearchHlp(hlpfile,ier)
      character hlpfile*(*)
      integer   ier
      integer length
      character name*132
      integer   ln
      character path*132
      integer   lp
      character fullname*132
      integer   lf
      character fm*1
      logical   exist
      call image_name(name,ln)
      call config_path(path,lp)
      call str_string(path,'#doc',fullname)
      lf = length(fullname)
      call filemode(fullname(1:lf),fm)
      ier = 1
      if(fm.eq.'d') then
        path = fullname
        call path_name_ext(path,name,'.hlp',fullname)
        inquire(file=fullname,exist=exist)
        if(exist) then
          hlpfile = fullname
          ier = 0
        endif
      else
        call str_2string(path,name,'##.hlp',fullname)
        inquire(file=fullname,exist=exist)
        if(exist) then
          hlpfile = fullname
          ier = 0
        endif
      endif
      return
      end                       ! SearchHlp
      subroutine SearchUrl(imname,text,url,ier)
      character imname*(*)
      character text*(*)
      character url*(*)
      integer   ier
      character fm*1
      integer   length
      character name*132
      integer   lp
      character path*132
      integer   ln
      character fullname*132
      logical   exist
      character uname*132
      integer   lf
      if(length(imname).eq.0) then
        call image_name(name,ln)
      else
        name = imname
      endif
      call upcase(name,uname)
      call getenv(uname,fullname)
      if(length(fullname).gt.0) then
        inquire(file=fullname,exist=exist)
        if(exist) goto 100
      endif
      call config_path(path,lp) ! Note: path ends in separator
      call str_2string(path,name,'##.html',fullname)
      inquire(file=fullname,exist=exist)
      if(exist) goto 100
      call str_string(path,'#html',fullname)
      lf = length(fullname)
      call filemode(fullname(1:lf),fm)
      if(fm.ne.'d') then
        call str_string(path,'#doc',fullname)
        lf = length(fullname)
        call filemode(fullname(1:lf),fm)
      endif
      if(fm.eq.'d') then
        path = fullname
        if(length(text).gt.0) then
          call path_join(path,'commands.html',fullname)
          inquire(file=fullname,exist=exist)
          if(exist) goto 100
          call path_name_ext(path,name,'commands.html',fullname)
          inquire(file=fullname,exist=exist)
          if(exist) goto 100
        endif
        call path_join(path,'index.html',fullname)
        inquire(file=fullname,exist=exist)
        if(exist) goto 100
        call path_name_ext(path,name,'.html',fullname)
        inquire(file=fullname,exist=exist)
        if(exist) goto 100
      endif
      ier = 1
      return
  100 continue
      if(length(text).gt.0) then
        call str_concat(fullname,'#',fullname)
        call str_concat(fullname,text,fullname)
      endif
      call str_string(fullname,'file://#',url)
      ier = 0
      return
      end                       ! SearchUrl
      character*13 function sec2time(t)
      implicit none
      real      t
      integer   days
      integer   minutes
      integer   hours
      integer   seconds
      integer   n
      integer   ioerr
      character dummy*13
      n = nint(t)
      seconds = mod(n,60)
      n = n/60
      minutes = mod(n,60)
      n = n/60
      hours = mod(n,24)
      days = n/24
      write(dummy,100,iostat=ioerr) days,hours,minutes,seconds
  100 format(i4.0,1x,i2.2,':',i2.2,':',i2.2)
      sec2time = dummy
      return
      end                       ! sec2time
      subroutine set_default_directory(new,old,ier)
      implicit none
      character new*(*)
      character old*(*)
      integer ier
      integer   length
      integerchdir
      character n*256
      integer   ln
      n = new
      ln = length(n)
      call get_default_directory(old,ier)
      ier = chdir(n(1:ln))
      return
      end                       ! set_default_directory
      subroutine set_files(n1,n2,n3,n4)
      implicit none
      integer n1,n2,n3,n4
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer   MaxAlias
      parameter (MaxAlias=100)
      integer   MaxPutbuffer
      parameter (MaxPutbuffer=80)
      integer   MaxNoEcho
      parameter (MaxNoEcho=10)
      integer   long,medium,short
      parameter (long=512)
      parameter (medium=256)
      parameter (short=12)
      integer FlagPop,FlagPush,FlagStatus,FlagClear
      parameter (FlagPop = 1)
      parameter (FlagPush = 2)
      parameter (FlagStatus = 3)
      parameter (FlagClear = 4)
      integer EchoInit,EchoOff,EchoOn,EchoAuto,EchoDebug,EchoSome
      parameter (EchoInit  =-1)
      parameter (EchoOff   = 0)
      parameter (EchoOn    = 1)
      parameter (EchoAuto  = 2)
      parameter (EchoDebug = 3)
      parameter (EchoSome = 4)
      integer   iADDEVAL,iALIAS,iALPHANUM,iAll,iARG,iATTACH,iBACK,iBELL,
     + iBOUND
      parameter (iADDEVAL=1)
      parameter (iALIAS = iADDEVAL+1)
      parameter (iALPHANUM = iALIAS+1)
      parameter (iALL = iAlPHANUM+1)
      parameter (iARG = iALL+1)
      parameter (iATTACH = iARG+1)
      parameter (iBACK = iATTACH+1)
      parameter (iBELL = iBACK+1)
      parameter (iBOUND = iBELL+1)
      integer   iCD,iCLS,iCOMMAND,iCPU,iDATE
      parameter (iCD = iBOUND+1)
      parameter (iCLS = iCD+1)
      parameter (iCOMMAND = iCls+1)
      parameter (iCPU = iCOMMAND+1)
      parameter (iDATE = iCPU+1)
      integer   iDEFINE_KEY,iDIRECTORY,iECHO,iEDIT,iEXIT,iEVALUATE
      parameter (iDEFINE_KEY = iDATE+1)
      parameter (iDIRECTORY = iDEFINE_KEY+1)
      parameter (iECHO = iDIRECTORY+1)
      parameter (iEDIT = iECHO+1)
      parameter (iEXIT = iEDIT+1)
      parameter (iEVALUATE = iEXIT+1)
      integer   iEXPORT,iFATAL,iFORMAT,iGOTO,iHELP,iHELPG,iHELPL
      parameter (iEXPORT = iEVALUATE+1)
      parameter (iFATAL = iEXPORT+1)
      parameter (iFORMAT = iFATAL+1)
      parameter (iGOTO = iFORMAT+1)
      parameter (iHELP = iGOTO+1)
      parameter (iHELPG = iHELP+1)
      parameter (iHELPL = iHELPG+1)
      integer   iHISTORY,iKEYBOARD,iIF
      parameter (iHISTORY=iHELPL+1)
      parameter (iKEYBOARD=iHISTORY+1)
      parameter (iIF = iKEYBOARD+1)
      integer iIMPORT,iJOURNAL,iLISTEVAL,iMKDIR
      parameter (iIMPORT = iIF+1)
      parameter (iJOURNAL = iIMPORT+1)
      parameter (iLISTEVAL=iJOURNAL+1)
      parameter (iMKDIR = iLISTEVAL+1)
      integer iOUTPUT,iOVERWRITE,iPAUSE
      parameter (iOUTPUT = IMKDIR+1)
      parameter (iOVERWRITE = iOUTPUT+1)
      parameter (iPAUSE = iOVERWRITE+1)
      integer iPREFIX,iPWD,iREMOVEEVAL,iRENAME,iREPEAT,iSECOND
      integer iSETCPU,iSETEOF
      parameter (iPREFIX = iPAUSE+1)
      parameter (iPWD = iPREFIX+1)
      parameter (iREMOVEEVAL = iPWD+1)
      parameter (iRENAME = iREMOVEEVAL+1)
      parameter (iREPEAT = iRENAME+1)
      parameter (iSECOND = iREPEAT+1)
      parameter (iSETCPU = iSECOND+1)
      parameter (iSETEOF = iSETCPU+1)
      integer  iSET_FILES,iSHELL,iSPAWN,iSTATUS,iSTORE
      parameter (iSET_FILES = iSETEOF+1)
      parameter (iSHELL = iSET_FILES+1)
      parameter (iSPAWN = iSHELL+1)
      parameter (iSTATUS = iSPAWN+1)
      parameter (iSTORE = iSTATUS+1)
      integer   iTIME,iTITLE,iUNALIAS,iVMS,iWAIT,iWRITE,iWL,iWN
      parameter (iTIME = iSTORE+1)
      parameter (iTITLE = iTIME+1)
      parameter (iUNALIAS = iTITLE+1)
      parameter (iVMS = iUNALIAS+1)
      parameter (iWAIT = iVMS+1)
      parameter (iWRITE = iWAIT+1)
      parameter (iWL = iWRITE+1)
      parameter (iWN = iWL+1)
      integer   ntest
      parameter (ntest=iWN)
      integer   nitem      ! nr of items in col
      integer   lp         ! length prompt
      integer   istart
      integer   nrepeat
      integer   NAlias
      integer   njournal
      integer   WordCount
      integer   LineCount
      integer   lprefix
      integer   PutbufferPointer
      integer   PutBufferStatus(MaxPutBuffer)
      integer   ninp
      integer   nout
      integer   nerr
      integer   nlog
      integer   InitBusy
      integer   EchoStatus
      integer   OutputLevel
      integer   n_noecho
      integer   lennoecho(maxnoecho)
      logical   SubstituteWhole
      common /gp___commmon/ nitem,lp,istart,nrepeat,NAlias,njournal,
     +     WordCount,LineCount,lprefix,PutbufferPointer,PutBufferStatus,
     +     ninp,nout,nerr,nlog,InitBusy,EchoStatus,OutputLevel,n_noecho,
     +     lennoecho,SubstituteWhole
      logical   journalling
      logical   FirstTime
      logical   seteof
      logical   noweof
      logical   EmptyLinesAllowed
      logical   DoUpcase
      logical   DoAliasSubstitution
      logical   DoRegexpSubstitution
      logical   LocalUpcase
      logical   gotoactive
      logical   AbortOnError
      logical   AllowAllDefault
      logical   AllDefault
      integer   FromBuffer ! 0=no 1=yes non-fatal 2=yes fatal
      common /gp___commmon_log/ journalling,FirstTime,seteof,noweof,
     +     EmptyLinesAllowed,DoUpcase,DoAliasSubstitution,
     +     DoRegexpSubstitution,LocalUpcase,gotoactive,AbortOnError,
     +     AllowAlldefault,AllDefault,FromBuffer
      character col*(long)
      character prompt*(medium)
      character AliasSource(MaxAlias)*(medium)
      character AliasDestination(MaxAlias)*(medium)
      character RepeatLine*(long)
      character PreviousDirectory*(long)
      character prefix*(short)
      character putbuffer(MaxPutbuffer)*(long)
      character InputFileName*(long)
      character NoEcho(maxnoecho)*(medium)
      common /gp___commmon_char/ col,prompt,AliasSource,
     +     AliasDestination,RepeatLine,PreviousDirectory,prefix,
     +     putbuffer,InputFileName,NoEcho
      integer   MaxStack
      parameter (MaxStack=20)
      integer   StackPointer
      integer   FileStack(MaxStack)
      integer   IstartStack(MaxStack)
      integer   NRepeatStack(MaxStack)
      logical   EofStack(MaxStack)
      integer   WordCountStack(MaxStack)
      integer   LineCountStack(MaxStack)
      common /gp___common_stack/ StackPointer,FileStack,IstartStack,
     +     NRepeatStack,EofStack,WordCountStack,LineCountStack
      character ColStack(MaxStack)*(long)
      character RepeatLineStack(MaxStack)*(long)
      character FileNameStack(MaxStack)*(long)
      common /gp___common_stack_char/ ColStack,RepeatLineStack,
     +     FileNameStack
      if (n2.ge.0) nout = n2
      if (n3.ge.0) nerr = n3
      if (n4.ge.0) nlog = n4
      if (n1.gt.0) then
        if(ninp.gt.0) call get_inp_close_internal(ninp)
        call get_newline
      else if(n1.eq.0) then
        if(ninp.gt.0) call get_inp_close_internal(ninp)
        ninp = 0
      endif
      if (FirstTime) then
        if (n1.ge.0) then
          call get_inp_init(0)
        else
          call get_inp_init(-5)
        endif
      endif
      if(OutputLevel.ge.OutputDebug) then
        call str_flush
        write(6,600) n1,n2,n3,n4
 600    format('n1 n2 n3 n4:',4i4)
        write(6,610) ninp,nout,nerr,nlog
 610    format('ninp nout nerr nlog:',4i4)
      endif
      return
      end                       ! set_files
      subroutine set_symbol(symbol,value)
      implicit none
      character symbol*(*)
      character value*(*)
      integer   ier
      integer   lenstr
      integer   myputenv
      character line*256
      integer   ls,lv
      ls = lenstr(symbol)
      lv = lenstr(value)
      line = symbol(1:ls)//'='//value(1:lv)
      ier = myputenv(line)
      if(ier.ne.0) write (*,*) 'set_symbol failed'
      return
      end
      subroutine set_term_title(string)
      character string*(*)
      integer lenstr
      character s*256
      integer   ls
      ls = lenstr(string)
      s = char(27)//']2;'//string(1:ls)//char(7)
      ls = lenstr(s)
      call edisplays(s(1:ls))
      return
      end                       ! set_term_title
      subroutine SetImageName(name)
      implicit none
      character name*(*)
      integer   length
      integer MyImageNameLength
      integer MyImageReleaseLength
      integer MyImageVersion
      common / common_imagename/ MyImageNameLength,MyImageReleaseLength,
     + MyImageVersion
      character MyImageName*80
      character MyImageRelease*80
      common / common_imagename_char/ MyImageName,MyImageRelease
      external common_imagenameXXX
      MyImageNameLength = length(name)
      if(MyImageNameLength.gt.0) then
        MyImageName = name
      endif
      return
      end                       ! SetImageName
      subroutine SetImageVersion(release,version)
      implicit none
      character release*(*)
      integer   version
      integer   length
      integer MyImageNameLength
      integer MyImageReleaseLength
      integer MyImageVersion
      common / common_imagename/ MyImageNameLength,MyImageReleaseLength,
     + MyImageVersion
      character MyImageName*80
      character MyImageRelease*80
      common / common_imagename_char/ MyImageName,MyImageRelease
      external common_imagenameXXX
      MyImageReleaseLength = length(release)
      if(MyImageReleaseLength.gt.0) then
        MyImageRelease = release
      endif
      MyImageVersion = Version
      return
      end                       ! SetImageVersion
      subroutine SetStopWatch
      integer sw1
      integer sw2
      common /common_stopwatch/ sw1,sw2
      call mysec(sw1,sw2)
      return
      end
      subroutine settime
      implicit none
      integer msec
      common /my___timer/ msec
      call get___cputime(msec)
      return
      end                       ! settime
      subroutine shell(ier)
      implicit none
      integer   ier
      integer   length
      integer   ls
      character shellname*80
      call getenv('SHELL',shellname)
      ls = length(shellname)
      call spawn(shellname(1:ls),ier)
      return
      end ! shell
      real*8 function signedfactor()
      implicit none
      real*8    eval_factor
      integer   pos
      integer   err
      integer   lf
      logical   allow_error
      common/evl___evaluate/pos,err,lf,allow_error
      character form*255
      character ch
      character reason*40
      common/evl___evaluate_char/form,ch,reason
      if (ch.eq.'-') then
        call eval_nextch
        signedfactor=-eval_factor()
        if (err.gt.0) return
      ELSE
        signedfactor=eval_factor()
        if (err.gt.0) return
      endif
      return
      end ! signedfactor
      real*8 function simple_expression()
      implicit none
      real*8    eval_term
      integer   pos
      integer   err
      integer   lf
      logical   allow_error
      common/evl___evaluate/pos,err,lf,allow_error
      character form*255
      character ch
      character reason*40
      common/evl___evaluate_char/form,ch,reason
      integer   isim
      common/evl___simple/isim
      real*8    s
      real*8    s2
      common/evl___simple_real/s(20),s2(20)
      character ops
      common/evl___simple_char/ops(20)
      simple_expression = 0.0D0 ! init
      isim=isim+1
      if (isim.gt.20) then
        reason='too much nesting'
        err=pos
        return
      endif
      s(isim)=eval_term()
      if (err.gt.0) return
      do while (ch.eq.'*'.or.ch.eq.'/')
        ops(isim)=ch
        call eval_nextch
        if (ops(isim).eq.'*') then
          s(isim)=s(isim)*eval_term()
          if (err.gt.0) return
        else
          s2(isim)=eval_term()
          if (err.gt.0) return
          if (s2(isim).eq.0) then
            if(allow_error) then
              s(isim) = 0.0D0
            else
              reason='divide overflow'
              err=pos
              return
            endif
          else
            s(isim)=s(isim)/s2(isim)
          endif
        endif
      enddo
      simple_expression=s(isim)
      isim=isim-1
      return
      end ! simple_expression
      subroutine sort_char(n,ra)
      implicit none
      integer   n           ! input
      character ra(*)*(*)   ! input and output
      integer   l
      integer   ir
      character rra*256
      integer   i
      integer   j
      if(n.le.1) return
      l=n/2+1
      ir=n
   10 continue
        if(l.gt.1)then
          l=l-1
          rra=ra(l)
        else
          rra=ra(ir)
          ra(ir)=ra(1)
          ir=ir-1
          if(ir.eq.1)then
            ra(1)=rra
            return
          endif
        endif
        i=l
        j=l+l
   20   if(j.le.ir)then
          if(j.lt.ir)then
            if(ra(j).lt.ra(j+1))j=j+1
          endif
          if(rra.lt.ra(j))then
            ra(i)=ra(j)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        go to 20
        endif
        ra(i)=rra
      go to 10
      end ! sort_char
      subroutine sort_char_index(n,ra,ira)
      implicit none
      integer   n            ! input
      character ra(*)*(*)    ! input
      integer   ira(*)       ! output
      integer   i
      integer   l
      integer   ir
      character rra*256
      integer   irra
      integer   j
      do i=1,n
        ira(i) = i
      enddo
      if(n.le.1) return
      l=n/2+1
      ir=n
   10 continue
        if(l.gt.1)then
          l=l-1
          irra=ira(l)
          rra=ra(irra)
        else
          irra=ira(ir)
          rra=ra(irra)
          ira(ir)=ira(1)
          ir=ir-1
          if(ir.eq.1)then
            ira(1)=irra
            return
          endif
        endif
        i=l
        j=l+l
   20   if(j.le.ir)then
          if(j.lt.ir)then
            if(ra(ira(j)).lt.ra(ira(j+1)))j=j+1
          endif
          if(rra.lt.ra(ira(j)))then
            ira(i)=ira(j)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        go to 20
        endif
        ira(i)=irra
      go to 10
      end ! sort_char_index
      subroutine sort_integer_index(n,ra,ira)
      implicit none
      integer n        ! input
      integer ra(*)    ! input
      integer ira(*)   ! output
      integer i
      integer l
      integer ir
      integer rra
      integer irra
      integer j
      do i=1,n
        ira(i) = i
      enddo
      if(n.le.1) return
      l=n/2+1
      ir=n
   10 continue
        if(l.gt.1)then
          l=l-1
          irra=ira(l)
          rra=ra(irra)
        else
          irra=ira(ir)
          rra=ra(irra)
          ira(ir)=ira(1)
          ir=ir-1
          if(ir.eq.1)then
            ira(1)=irra
            return
          endif
        endif
        i=l
        j=l+l
   20   if(j.le.ir)then
          if(j.lt.ir)then
            if(ra(ira(j)).lt.ra(ira(j+1)))j=j+1
          endif
          if(rra.lt.ra(ira(j)))then
            ira(i)=ira(j)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        go to 20
        endif
        ira(i)=irra
      go to 10
      end ! sort_integer_index
      subroutine sort_real_index(n,ra,ira)
      implicit none
      integer n        ! input
      real    ra(*)    ! input
      integer ira(*)   ! output
      integer i
      integer l
      integer ir
      real    rra
      integer irra
      integer j
      do i=1,n
        ira(i) = i
      enddo
      if(n.le.1) return
      l=n/2+1
      ir=n
   10 continue
        if(l.gt.1)then
          l=l-1
          irra=ira(l)
          rra=ra(irra)
        else
          irra=ira(ir)
          rra=ra(irra)
          ira(ir)=ira(1)
          ir=ir-1
          if(ir.eq.1)then
            ira(1)=irra
            return
          endif
        endif
        i=l
        j=l+l
   20   if(j.le.ir)then
          if(j.lt.ir)then
            if(ra(ira(j)).lt.ra(ira(j+1)))j=j+1
          endif
          if(rra.lt.ra(ira(j)))then
            ira(i)=ira(j)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        go to 20
        endif
        ira(i)=irra
      go to 10
      end ! sort_real_index
      subroutine spawn(command,ier)
      implicit none
      character command*(*)
      integer   ier
      character c*256
      integer   length
      integer   lc
      integer   mysystem
      external  mysystem
      lc=length(command)
      c = command(1:lc)
      ier=mysystem(c(1:lc))
      if(ier.ne.0) then
        call str_integer_out(ier,'SPAWN error #')
        call str_out('after')
        call str_out(c(1:lc))
        call str_flush
      endif
      return
      end ! spawn
      subroutine spawn_nowait(command,pid,ier)
      implicit none
      character command*(*)
      integer   pid
      integer   ier
      integer   length
      integer   lc
      character c*256
      lc=length(command)
      c = command(1:lc)
      lc = lc + 1
      c(lc:lc)='&'
      call spawn(c(1:lc),ier)
      pid=0
      return
      end ! spawn_nowait
      subroutine spawncc(command,ier)
      implicit none
      character command*(*)
      integer   ier
      character c*256
      integer   length
      integer   lc
      integer   mysystem
      external  mysystem
      lc=length(command)
      c = command(1:lc)
      ier=mysystem(c(1:lc))
      if(mod(ier,128).eq.2) call ccself
      if(ier.ne.0) then
        call str_integer_out(ier,'SPAWN error #')
        call str_out('after')
        call str_out(c(1:lc))
        call str_flush
        call str_integer_out(mod(ier,128),'mod(ier,128)=#.')
        call str_out('Calling ccself.')
        call ccself
        call str_flush
      endif
      return
      end                       ! spawncc
      subroutine startlog(unit,comment)
      character comment*(*)
      integer   unit
      character datetime*20
      character get_nodename*15
      integer   length
      character fullname*80
      character line*256
      if(unit.le.0) return
      call GetFullImageName(fullname)
      call str_3string(fullname,get_nodename(),datetime(),
     +     '# started on # at #',line)
      if(length(comment).gt.0) then
        call str_2string_write(unit,comment,line,'# #')
      else
        call str_write(unit,line)
      endif
      return
      end                       ! startlog
      subroutine stoplog(unit,comment)
      character comment*(*)
      integer   unit
      character datetime*20
      character cputime*13
      integer   length
      character name*80
      integer   ln
      character line*256
      if(unit.le.0) return
      call image_name(name,ln)
      call str_3string(name,datetime(),cputime(),
     +       '# ended at # CPU time used #',line)
      if(length(comment).gt.0) then
        call str_2string_write(unit,comment,line,'# #')
      else
        call str_write(unit,line)
      endif
      return
      end                       ! stoplog
      real function stopwatch()
      integer sw1
      integer sw2
      common /common_stopwatch/ sw1,sw2
      integer new1
      integer new2
      integer d1
      integer d2
      call mysec(new1,new2)
      if(new2.lt.sw2) then
        d1 = new1-1-sw1
        d2 = new2+1000000-sw2
      else
        d1 = new1-sw1
        d2 = new2-sw2
      endif
      stopwatch = float(d1)+float(d2)/1.0e6
      return
      end
      subroutine str_1substitute(source,old,new,destination)
      implicit none
      character source*(*)     ! input
      character old*(*)        ! string to change. No Empty string
      character new*(*)        ! into this one.    Empty string allowed
      character destination*(*)! output
      integer   length
      integer   KO         ! length old
      integer   i
      integer   KN         ! length new
      integer   ls
      character tmp*4096
      integer   lt
      ls = length(source)
      if(ls.eq.0) then
        destination = ' '
        return
      endif
      KO = length(old)-1   ! changed into length 10-mar-2011
      if(KO.le.0) then
        call CopyStr(source(1:ls),destination)
        return
      endif
      i = index(source(1:ls),old(1:KO))
      if(i.eq.0) then
        call CopyStr(source(1:ls),destination)
        return
      endif
      KN = length(new) - 1  ! hier stond len 160896
      if(KN.lt.0) then
        call CopyStr(source(1:ls),destination)
        return
      endif
      if(KN.eq.0) then
        if(i.gt.1) then
          call CopyStr(source(1:i-1),tmp)
          lt = i-1
        else
          lt = 0
        endif
      else
        if(i.gt.1) then
          call Copy2Str(source(1:i-1),new(1:KN),tmp)
          lt = i-1+KN
        else
          call CopyStr(new(1:KN),tmp)
          lt = kn
        endif
      endif
      if(i+KO.le.ls) then
        if(lt.gt.0) then
          call Copy2Str(tmp(1:lt),source(i+KO:ls),tmp)
        else
          call CopyStr(source(i+KO:ls),tmp)
        endif
      endif
      call CopyStr(tmp,destination)
      return
      end ! str_1substitute
      subroutine str_2integer(n1,n2,s,dest)
      implicit none
      integer   n1,n2
      character s*(*)
      character dest*(*)        ! output
      integer ir(2)
      ir(1) = n1
      ir(2) = n2
      call str_iarray(2,ir,s,dest)
      return
      end                       ! str_2integer
      subroutine str_2integer_out(n1,n2,s)
      implicit none
      integer   n1,n2
      character s*(*)
      character line*1024
      call str_2integer(n1,n2,s,line)
      call str_out(line)
      return
      end                       ! str_2integer_out
      subroutine str_2integer_write(unit,n1,n2,s)
      implicit none
      integer   unit
      integer   n1,n2
      character s*(*)
      character line*1024
      call str_2integer(n1,n2,s,line)
      call str_write(unit,line)
      return
      end                       ! str_2integer_write
      subroutine str_2real(r1,r2,s,dest)
      implicit none
      real      r1,r2
      character s*(*)
      character dest*(*)        ! output
      real      r(2)
      r(1) = r1
      r(2) = r2
      call str_array(2,r,s,dest)
      return
      end                       ! str_2real
      subroutine str_2real_out(r1,r2,s)
      implicit none
      real      r1,r2
      character s*(*)
      character line*1024
      call str_2real(r1,r2,s,line)
      call str_out(line)
      return
      end                       ! str_2real_out
      subroutine str_2string(string1,string2,s,dest)
      implicit none
      character string1*(*)
      character string2*(*)
      character s*(*)
      character dest*(*)        ! output
      character temp*1024
      call str_string(string1,s,temp)
      call str_string(string2,temp,dest)
      return
      end                       ! str_2string
      subroutine str_2string_out(string1,string2,s)
      implicit none
      character string1*(*)
      character string2*(*)
      character s*(*)
      character line*1024
      call str_2string(string1,string2,s,line)
      call str_out(line)
      return
      end                       ! str_2string_out
      subroutine str_2string_write(unit,string1,string2,s)
      implicit none
      integer   unit
      character string1*(*)
      character string2*(*)
      character s*(*)
      character line*1024
      call str_2string(string1,string2,s,line)
      call str_write(unit,line)
      return
      end                       ! str_2string_write
      subroutine str_3integer(n1,n2,n3,s,dest)
      implicit none
      integer   n1,n2,n3
      character s*(*)
      character dest*(*)        ! output
      integer ir(3)
      ir(1) = n1
      ir(2) = n2
      ir(3) = n3
      call str_iarray(3,ir,s,dest)
      return
      end ! str_3integer
      subroutine str_3integer_out(n1,n2,n3,s)
      implicit none
      integer   n1,n2,n3
      character s*(*)
      character line*1024
      call str_3integer(n1,n2,n3,s,line)
      call str_out(line)
      return
      end ! str_3integer_out
      subroutine str_3string(string1,string2,string3,s,dest)
      implicit none
      character string1*(*)
      character string2*(*)
      character string3*(*)
      character s*(*)
      character dest*(*)        ! output
      character temp*1024
      call str_string(string1,s,temp)
      call str_string(string2,temp,temp)
      call str_string(string3,temp,dest)
      return
      end                       ! str_3string
      subroutine str_add(s1,s2,s3)
      implicit none
      character s1*(*)          ! input
      character s2*(*)          ! input
      character s3*(*)          ! output
      integer   length
      integer   ls1
      integer   ls2
      ls1 = length(s1)
      ls2 = length(s2)
      if(ls1.eq.0) then
        if(ls2.eq.0) then
          s3 = ' '
        else
          call CopyStr(s2(1:ls2),s3)
        endif
      else
        if(ls2.eq.0) then
          call CopyStr(s1(1:ls1),s3)
        else
          call Add2Str(s1(1:ls1),s2(1:ls2),s3)
        endif
      endif
      return
      end ! str_add
      subroutine str_alphanumeric(source,result)
      character source*(*)      ! input
      character result*(*)      ! output
      integer length
      integer   ls
      character c*1
      integer   ic
      integer   i
      integer   j
      character temp*4096   ! scratch
      ls = length(source)
      temp = ' '
      j = 0
      do i=1,ls
        c=source(i:i)
        ic=ichar(c)
        if( (ic.ge.ichar('0').and.ic.le.ichar('9')).or.
     +       (ic.ge.ichar('A').and.ic.le.ichar('Z')).or.
     +       (ic.ge.ichar('a').and.ic.le.ichar('z')).or.
     +       ic.eq.ichar(' ')) then
          j = j + 1
          temp(j:j) = c
        endif
      enddo
      if(j.gt.0) then
        call copystr(temp(1:j),result)
      else
        result = ' '
      endif
      return
      end                       ! str_alphanumeric
      subroutine str_array(n,r,s,dest)
      implicit none
      integer   n
      real      r(n)
      character s*(*)
      character dest*(*)        ! output
      integer   length
      character local*20
      integer   i
      integer   j
      integer   L
      character c*1
      character from*2
      integer   ld
      c = ';'
      from='#'//c
      ld = length(s)
      if(ld.eq.0) then
        dest = '#'
        ld = 1
      else
        call copystr(s(1:ld),dest)
      endif
      j = 0
      do i=1,ld
        if(dest(i:i).eq.'#') then
          j = j + 1
        endif
      enddo
      if(j.ne.n) then
        do i=1,n-j
          call copy2str(dest(1:ld),' #',dest)
          ld = ld + 2
        enddo
      endif
      do i=1,n
        call str_real_internal(r(i),local,L)
        call str_1substitute(dest(1:ld),from,local(1:L)//c,dest)
        ld = ld + L - 1
      enddo
      return
      end                       ! str_array
      subroutine str_array_out(n,r,s)
      implicit none
      integer   n
      real      r(n)
      character s*(*)
      character line*1024
      call str_array(n,r,s,line)
      call str_out(line)
      return
      end ! str_array_out
      subroutine str_boolean(b,strue,sfalse,s,dest)
      implicit none
      logical   b
      character strue*(*)
      character sfalse*(*)
      character s*(*)
      character dest*(*)        ! output
      integer   length
      character c*1
      integer   ld
      character from*2
      character into*80
      c = ';'
      from='#'//c
      ld = length(s)
      dest = s
      if(ld.eq.0) then
        dest = '#'
        ld = 1
      else if(index(dest(1:ld),'#').eq.0) then
        call copy2str(dest(1:ld),' #',dest)
        ld = ld + 2
      endif
      if(b) then
        call str_2string(strue,c,'##',into)
      else
        call str_2string(sfalse,c,'##',into)
      endif
      call str_1substitute(dest(1:ld),from,into,dest)
      return
      end                       ! str_boolean
      subroutine str_boundcheck(set,previous)
      implicit none
      logical  set              ! input
      logical previous          ! output
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      logical b
      b = set
      previous = boundcheck
      boundcheck = b
      return
      end                       ! str_boundcheck
      subroutine str_charsubstitute(source,old,new,destination)
      implicit none
      character source*(*)     ! input
      character old*1          ! character to change. (all allowed)
      character new*1          ! into this one.       (all allowed)
      character destination*(*)! output
      integer   length
      integer   i
      integer   K
      integer   ld
      ld = length(source)
      if(ld.eq.0) then
        destination = ' '
        return
      endif
      call copystr(source(1:ld),destination)
      if(old.eq.new) return
      k = index(destination(1:ld),old)
      if(k.eq.0) return
      do i=k,ld
        if(destination(i:i).eq.old) then
          destination(i:i) = new
        endif
      enddo
      return
      end                       ! str_charsubstitute
      subroutine str_collapse(source,destination)
      implicit none
      character source*(*)
      character destination*(*)
      integer   i
      integer   j
      integer   ic
      j = 0
      do i=1,len(source)
        ic = ichar(source(i:i))
        if (ic.ne.0.and.ic.ne.9.and.ic.ne.32) then
          j = j + 1
          destination(j:j) = source(i:i)
          if (j.ge.len(destination)) return
        endif
      enddo
      destination(j+1:) = ' '
      return
      end ! str_collapse
      subroutine str_columns(unit,n,s)
      integer   unit
      integer   n
      character s(*)*(*)
      logical   debug
      parameter (debug=.false.)
      integer   length
      integer   lmax
      integer   i
      integer   ncol
      integer   nrow
      integer   columns
      integer   rows
      character form*80
      integer   j
      if(n.eq.0) return
      lmax = 0
      do i=1,n
        lmax = max(length(s(i)),lmax)
      enddo
      call get_term_size(ncol,nrow)
      if(debug) then
        call str_integer_out(n,'# lines')
        call str_integer_out(ncol,'ncol=#')
        call str_integer_out(nrow,'nrow=#')
        call str_integer_out(lmax,'lmax=#')
      endif
      columns = ncol/(lmax+1)
      if(columns.eq.0) columns = 1
      rows = (n-1)/columns + 1
      if(debug) then
        call str_2integer_out(columns,rows,'# columns # rows')
        call str_flush
      endif
      if(columns.gt.1) then
        call str_integer(columns-1,'(#(a,1x),a)',form)
      else
        form='(a)'
      endif
      do i=1,rows
        write(unit,form) (s(j)(1:lmax),j=i,n,rows)
      enddo
      return
      end                       ! str_columns
      integer function str_compress(source,destination)
      implicit none
      character source*(*)
      character destination*(*)
      integer   i
      integer   j
      integer   ic
      logical   addspace
      integer   ld
      j=0
      ld = len(destination)
      addspace = .false.
      do i=1,len(source)
        ic=ichar(source(i:i))
        if (ic.eq.0.or.ic.eq.32) then
          if(j.gt.0) addspace = .true.
        else
          if(addspace) then
            j=j+1
            destination(j:j)=' '
            if (j.ge.ld) then
              str_compress = ld - 1
              return
            endif
            addspace = .false.
          endif
          j=j+1
          destination(j:j)=source(i:i)
          if (j.ge.ld) then
            str_compress = ld
            return
          endif
        endif
      enddo
      destination(j+1:)=' '
      str_compress = j
      return
      end ! str_compress
      subroutine str_concat(s1,s2,s3)
      implicit none
      character s1*(*)          ! input
      character s2*(*)          ! input
      character s3*(*)          ! output
      integer   length
      integer   ls1
      ls1 = length(s1)
      if(ls1.eq.0) then
        call CopyStr(s2,s3)
      else
        call Copy2Str(s1(1:ls1),s2,s3)
      endif
      return
      end ! str_concat
      subroutine str_conditional_flush(n)
      implicit none
      integer n
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      if(n+lb+indent+append_length.ge.wrap) call str_flush
      return
      end                       ! str_conditional_flush
      subroutine str_dump
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer   i
      call str_flush
      call str_out('str_dump:')
      call str_integer_out(unit,'unit=#')
      call str_integer_out(wrap,'wrap=#')
      call str_integer_out(wrap6,'wrap6=#')
      call str_integer_out(lb,'lb=#')
      call str_onoff_out(dirtylb,'dirtylb=#')
      if(lb.gt.0.and.unit.ne.6) then
        call str_string_out(str_buffer,'str_buffer=[#]')
      endif
      call str_integer_out(indent,'indent=#')
      call str_integer_out(paragraph_length,'paragraph_length=#')
      call str_integer_out(append_length,'append_length=#')
      call str_logical_out(str_more_active,'str_more_active=#')
      call str_logical_out(OutConcat,'OutConcat=#')
      call str_logical_out(OutCount,'OutCount=#')
      call str_integer_out(flush_count,'flush_count=#')
      call str_integer_out(lff,'lff=#')
      call str_logical_out(changepercent,'changepercent=#')
      call str_logical_out(filterhtml,'filterhtml=#')
      call str_logical_out(boundcheck,'boundcheck=#')
      call str_logical_out(write_compress,'write_compress=#')
      call str_string_out(flush_format,'flush_format=#')
      if(paragraph_length.gt.0) then
        call str_string_out(paragraph_string,'paragraph_string=[#]')
      endif
      if(append_length.gt.0) then
        call str_string_out(append_string,'append_string=[#]')
      endif
      call str_logical_out(real_trim,'real_trim=#')
      call str_integer_out(real_len,'real_len=#')
      if(real_len_p.gt.0) then
        call str_flush
        call str_out('reallenstack')
        do i=1,real_len_p
          call str_integer_out(real_len_stack(i),'#')
        enddo
      endif
      if(unitp.gt.0) then
        call str_flush
        call str_out('unitstack,indentstack')
        do i=1,unitp
          call str_2integer_out(unitstack(i),indentstack(i),'#,#')
        enddo
      endif
      call str_flush
      return
      end                       ! str_dump
      subroutine str_expand(s1,s2)
      implicit none
      character s1*(*)          ! input/output
      character s2*(*)          ! input
      integer   length
      integer   ls1
      integer   ls2
      ls2 = length(s2)
      if(ls2.gt.0) then
        ls1 = length(s1)
        if(ls1.eq.0) then
          call CopyStr(s2(1:ls2),s1)
        else
          call Add2Str(s1(1:ls1),s2(1:ls2),s1)
        endif
      endif
      return
      end                       ! str_expand
      subroutine str_expandconcat(s1,s2)
      implicit none
      character s1*(*)          ! input/output
      character s2*(*)          ! input
      integer   length
      integer   ls1
      integer   ls2
      ls2 = length(s2)
      if(ls2.gt.0) then
        ls1 = length(s1)
        if(ls1.eq.0) then
          call CopyStr(s2(1:ls2),s1)
        else
          call Copy2Str(s1(1:ls1),s2(1:ls2),s1)
        endif
      endif
      return
      end                       ! str_expandconcat
      subroutine str_extract(source,n,destination)
      implicit none
      character source*(*)      ! input
      integer   n               ! input
      character destination*(*) ! output
      integer   str_compress
      character line*1024
      integer   p1,p2
      integer   i
      integer   nc
      nc = str_compress(source,line)
      destination = ' '
      if(n.le.0) return
      p1 = 1
      p2 = index(line(p1:),' ')
      do i=2,n
        p1 = p1+p2
        p2 = index(line(p1:),' ')
      enddo
      if (p2.gt.0) then
        call CopyStr(line(p1:p1+p2-1),destination)
      else
        destination = ' '
      endif
      return
      end ! str_extract
      subroutine str_fill(s,n,c)
      implicit none
      character s*(*)           ! output
      integer   n               ! input
      character c*1             ! input
      integer   i
      s = ' '
      do i=1,min(n,len(s))
        s(i:i) = c
      enddo
      return
      end                       ! str_fill
      subroutine str_filtered_write(u,s)
      integer   u
      character s*(*)
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer   lenstr
      integer   ioerr
      character local*4096
      integer   ll
      if(filterhtml) then
        call applyhtmlfilter(s,local)
        ll = lenstr(local)
        write(u,'(a)',iostat=ioerr) local(1:ll)
      else
        write(u,'(a)',iostat=ioerr) s
      endif
      if(ioerr.ne.0) call str_write_error(ioerr)
      return
      end                       ! str_filtered_write
      subroutine str_firstnonblanc(source,n)
      character source*(*)
      integer   n               ! output. 0 for empty string
      integer   i
      i = 1
      do while(source(i:i).eq.' ')
        if(i.eq.len(source)) then
          n = 0
          return
        endif
        i = i + 1
      enddo
      n = i
      return
      end                       ! str_firstnonblanc
      subroutine str_flush
      implicit none
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer ioerr
      if(lb.gt.0) then
        if(unit.eq.6) then
          if(str_more_active) call more(1,' ')
          if(append_length.gt.0) then
            call displays(append_string(1:append_length))
          endif
          call displaynl()
        else
          if(append_length.eq.0) then
            write (unit,flush_format(1:lff),iostat=ioerr)
     +           str_buffer(1:lb)
          else
            write (unit,flush_format(1:lff),iostat=ioerr)
     +           str_buffer(1:lb)//append_string(1:append_length)
          endif
          if(ioerr.ne.0) call str_write_error(ioerr)
        endif
        lb = 0
        dirtylb = .true.
        if(flush_count.ge.0) flush_count = flush_count + 1
      endif
      return
      end ! str_flush
      subroutine str_grad(r,s,dest)
      implicit none
      real      r
      character s*(*)
      character dest*(*)        ! output
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      call str_real(grad*r,s,dest)
      return
      end ! str_grad
      subroutine str_grad_out(r,s)
      implicit none
      real      r
      character s*(*)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      call str_real_out(grad*r,s)
      return
      end ! str_grad_out
      subroutine str_gradvector(v,s,dest)
      implicit none
      real      v(3)
      character s*(*)
      character dest*(*)        ! output
      real      w(3)
      call GradVec(v,w)
      call str_array(3,w,s,dest)
      return
      end                       ! str_gradvector
      subroutine str_gradvector_out(v,s)
      implicit none
      real      v(3)
      character s*(*)
      real      w(3)
      call Gradvec(v,w)
      call str_array_out(3,w,s)
      return
      end                       ! str_gradvector_out
      subroutine str_header(source,field,lf,rest,lr)
      implicit none
      character source*(*)      ! input
      character field*(*)       ! output
      integer   lf              ! output
      character rest*(*)        ! output
      integer   lr              ! output
      character ROUTINE*(*)
      parameter (ROUTINE='STR_HEADER')
      logical   DEBUG
      parameter (DEBUG=.false.)
      integer   length
      integer   i
      integer   j
      integer   ls
      if(DEBUG) then
        call str_flush
        call str_out(ROUTINE)
      endif
      ls = length(source)
      if(ls.eq.0) then
        if(DEBUG) then
          call str_out('zero length')
          call str_flush
        endif
        field = ' '
        lf = 0
        rest = ' '
        lr = 0
        goto 900
      endif
      if(DEBUG) then
        call str_string_out(source,'src=[#]')
      endif
      call str_firstnonblanc(source,i)
      if(i.eq.0) then
        if(DEBUG) then
          call str_out('firstnonblanc zero')
          call str_flush
        endif
        field = ' '
        lf = 0
        rest = ' '
        lr = 0
        goto 900
      endif
      j = index(source(i:ls),' ')
      if(j.eq.0) then
        if(DEBUG) then
          call str_out('nospace')
          call str_2integer_out(i,ls,'copy from # to #')
        endif
        call CopyStr(source(i:ls),field)
        lf = ls-i+1
        rest = ' '
        lr = 0
        if(DEBUG) then
          call str_integer_out(lf,'lf=#')
          call str_string_out(field,'field=[#]')
        endif
      else
        if(DEBUG) then
          call str_2integer_out(i,i+j-2,'copy from # to #')
        endif
        call CopyStr(source(i:i+j-2),field)
        lf = j-1  ! i+j-2 - i + 1
        if(DEBUG) then
          call str_integer_out(lf,'lf=#')
          call str_string_out(field,'field=[#]')
        endif
        i = i + j
        call str_firstnonblanc(source(i:ls),j)
        if(j.eq.0) then
          if(DEBUG) then
            call str_out('firstnonblanc=0')
          endif
          rest = ' '
          lr = 0
        else
          i = i+j-1
          if(DEBUG) then
            call str_2integer_out(i,ls,'copy from # to #')
          endif
          lr = ls - i + 1
            call CopyStr(source(i:ls),rest)
          if(DEBUG) then
            call str_integer_out(lr,'lr=#')
            call str_string_out(rest,'rest=[#]')
          endif
        endif
      endif
 900  continue
      if(DEBUG) then
        call str_string_out(ROUTINE,'END#')
        call str_flush
      endif
      return
      end ! str_header
      subroutine str_iarray(n,ir,s,dest)
      implicit none
      integer   n
      integer   ir(n)
      character s*(*)
      character dest*(*)        ! output
      integer   length
      integer   ioerr
      character local*20
      integer   i
      integer   L
      character c*1
      character from*2
      integer   ld
      integer   j
      c= ';'
      from='#'//c
      ld = length(s)
      if(ld.eq.0) then
        dest = '#'
        ld = 1
      else
        call copystr(s(1:ld),dest)
      endif
      j = 0
      do i=1,ld
        if(dest(i:i).eq.'#') then
          j = j + 1
        endif
      enddo
      if(j.ne.n) then
        do i=1,n-j
          call copy2str(dest(1:ld),' #',dest)
          ld = ld + 2
        enddo
      endif
      do i=1,n
        write (local,*,iostat=ioerr) ir(i)
        call str_leading(local,local)
        L = length(local)
        call str_1substitute(dest(1:ld),from,local(1:L)//c,dest)
        ld = ld + L - 1
      enddo
      return
      end ! str_iarray
      subroutine str_iarray_out(n,ir,s)
      implicit none
      integer   n
      integer   ir(n)
      character s*(*)
      character line*1024
      call str_iarray(n,ir,s,line)
      call str_out(line)
      return
      end ! str_iarray_out
      subroutine str_indent(n)
      implicit none
      integer n
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer length
      if(n.ge.0) indent = n
      if(indent.gt.0) then
        call str_integer(indent,'(#X,A)',flush_format)
        lff = length(flush_format)
      else
        flush_format = '(A)'
        lff = 3
      endif
      return
      end ! str_indent
      subroutine str_indentadd(n)
      implicit none
      integer n
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer m
      m = indent
      if(m+n.ge.0) then
        m = m + n
      else
        m = 0
      endif
      call str_indent(m)
      return
      end ! str_indentadd
      subroutine str_integer(n,s,dest)
      implicit none
      integer   n
      character s*(*)
      character dest*(*)        ! output
      integer   length
      integer   ioerr
      character local*20
      integer   L
      character c*1
      integer   ld
      character from*2
      c = ';'
      from='#'//c
      ld = length(s)
      dest = s
      if(ld.eq.0) then
        dest = '#'
        ld = 1
      else if(index(dest(1:ld),'#').eq.0) then
        call copy2str(dest(1:ld),' #',dest)
        ld = ld + 2
      endif
      write (local,*,iostat=ioerr) n
      call str_leading(local,local)
      L = length(local)
      call str_1substitute(dest(1:ld),from,local(1:L)//c,dest)
      return
      end                       ! str_integer
      subroutine str_integer_out(n,s)
      implicit none
      integer   n
      character s*(*)
      character line*1024
      call str_integer(n,s,line)
      call str_out(line)
      return
      end ! str_integer_out
      subroutine str_integer_write(unit,n,s)
      implicit none
      integer   unit
      integer   n
      character s*(*)
      character line*1024
      call str_integer(n,s,line)
      call str_write(unit,line)
      return
      end ! str_integer_write
      subroutine str_join(N,s,result)
      integer   n               ! input
      character s(n)*(*)        ! input
      character result*(*)      ! output
      integer   i
      do i=1,n
        call str_expand(result,s(i))
      enddo
      return
      end                       ! str_join
      subroutine str_leading(source,destination)
      implicit none
      character source*(*)
      character destination*(*)
      integer   n
      call str_firstnonblanc(source,n)
      if(n.eq.0) then ! full blanc
        destination = ' '
      else
        call CopyStr(source(n:),destination)
      endif
      return
      end                       ! str_leading
      subroutine str_logical(b,s,dest)
      implicit none
      logical   b
      character s*(*)
      character dest*(*)        ! output
      call str_boolean(b,'true','false',s,dest)
      return
      end                       ! str_logical
      subroutine str_logical_out(b,s)
      implicit none
      logical   b
      character s*(*)
      character line*1024
      call str_logical(b,s,line)
      call str_out(line)
      return
      end                       ! str_logical_out
      subroutine str_logical_write(unit,b,s)
      implicit none
      integer   unit
      logical   b
      character s*(*)
      character line*1024
      call str_logical(b,s,line)
      call str_write(unit,line)
      return
      end                       ! str_logical_write
      subroutine str_num(n,s,dest)
      implicit none
      integer   n
      character s*(*)
      character dest*(*)        ! output
      integer   length
      integer   str_compress
      character c*1
      character from*2
      integer   nc
      integer   ld
      c = ';'
      from='#'//c
      ld = length(s)
      if(ld.eq.0) then
        dest = '#'
        ld = 1
      else
        call copystr(s(1:ld),dest)
        if(index(dest(1:ld),'#').eq.0) then
          call copy2str('# ',s,dest)
          ld = ld + 2
        endif
      endif
      if(n.eq.0) then
        call str_1substitute(dest(1:ld),from,'no'//c,dest)
        ld = ld + 1
      else if(n.eq.1) then
        call str_1substitute(dest(1:ld),from,'one'//c,dest)
        ld = ld + 2
      else
        call str_integer(n,dest(1:ld),dest)
        ld = length(dest)
      endif
      from='^'//c
      if(n.eq.1) then
        call str_1substitute(dest(1:ld),from,c,dest)
      else
        call str_1substitute(dest(1:ld),from,'s'//c,dest)
      endif
      nc = str_compress(dest(1:ld),dest)  ! ll can be too big. No problem
      return
      end                       ! str_num
      subroutine str_num_out(n,s)
      implicit none
      integer   n
      character s*(*)
      character message*1024
      call str_num(n,s,message)
      call str_out(message)
      return
      end                       ! str_num_out
      subroutine str_num_write(unit,n,s)
      implicit none
      integer   unit
      integer   n
      character s*(*)
      character message*1024
      call str_num(n,s,message)
      call str_write(unit,message)
      return
      end                       ! str_num_write
      subroutine str_OnOff(b,s,dest)
      implicit none
      logical   b
      character s*(*)
      character dest*(*)        ! output
      call str_boolean(b,'on','off',s,dest)
      return
      end                       ! str_OnOff
      subroutine str_OnOff_out(b,s)
      implicit none
      logical   b
      character s*(*)
      character line*1024
      call str_OnOff(b,s,line)
      call str_out(line)
      return
      end                       ! str_OnOff_out
      subroutine str_optionslist(n,s,prepend,append,result)
      integer   n
      character s(n)*(*)
      character prepend*(*)
      character append*(*)
      character result*(*)      ! output
      integer length
      integer i
      if(length(prepend).gt.0) then
        call str_2string(prepend,s(1),'#/#',result)
      else
        call copystr(s(1),result)
      endif
      do i=2,n
        call str_2string(result,s(i),'#/#',result)
      enddo
      if(length(append).gt.0) then
        call str_2string(result,append,'#/#',result)
      endif
      return
      end                       ! str_optionslist
      subroutine str_out(string)
      implicit none
      character string*(*)
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer length
      integer   ls
      integer   i
      character mystring*1024
      ls = length(string)
      if(ls.eq.0) return
      if(changepercent) then
        call str_substitute(string(1:ls),'%;','#;',mystring)
      else
        call CopyStr(string(1:ls),mystring)
      endif
      if(filterhtml) then
        call applyhtmlfilter(mystring,mystring)
        ls = length(mystring)
      endif
      call str_conditional_flush(ls+1)
      if(lb.eq.0) then
        if(paragraph_length.ne.0) then
          if(unit.eq.6) then
            do i=1,indent
              call displayc(' ')
            enddo
            call displays(paragraph_string(1:paragraph_length))
            call displays(mystring(1:ls))
          else
            call copy2str(paragraph_string(1:paragraph_length),
     +           mystring(1:ls),str_buffer)
          endif
          lb = paragraph_length + ls
          dirtylb = .true.
        else
          if(unit.eq.6) then
            do i=1,indent
              call displayc(' ')
            enddo
            call displays(mystring(1:ls))
          else
            str_buffer =  mystring(1:ls)
          endif
          lb = ls
          dirtylb = .true.
        endif
      else
        if(unit.eq.6) then
          if(.not.OutConcat) then
            call displayc(' ')
          endif
          call displays(mystring(1:ls))
        else
          if(OutConcat) then
            call copy2str(str_buffer(1:lb),mystring(1:ls),str_buffer)
          else
            call add2str(str_buffer(1:lb),mystring(1:ls),str_buffer)
          endif
        endif
        if(OutCount) then
          lb = lb + ls
          dirtylb = .true.
          if(.not.OutConcat) then
            lb = lb + 1
          endif
        endif
      endif
      return
      end                       ! str_out
      subroutine str_real(r,s,dest)
      implicit none
      real      r
      character s*(*)
      character dest*(*)        ! output
      integer   length
      character local*20
      integer   L
      character c*1
      character from*2
      integer   ld
      c = ';'
      from='#'//c
      ld = length(s)
      dest = s
      if(ld.eq.0) then
        dest = '#'
        ld = 1
      else if (index(dest,'#').eq.0) then
        call copy2str(dest(1:ld),' #',dest)
        ld = ld + 2
      endif
      call str_real_internal(r,local,L)
      call str_1substitute(dest(1:ld),from,local(1:L)//c,dest)
      return
      end                       ! str_real
      subroutine str_real_internal(r,dest,ld)
      implicit none
      real      r
      character dest*(*)        ! output
      integer   ld              ! output
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer   length
      integer   ioerr
      character local*20
      integer   L
      if(abs(r).lt.0.1.and.abs(r).gt.1.0e-5) then
        write (local,real_form1,iostat=ioerr) r
      else if(r.eq.0.0) then
        local = '0.0'
      else
        write (local,real_form2,iostat=ioerr) r
      endif
      call str_leading(local,local)
      l = length(local)
      if(real_trim) then
        do while(local(L:L).eq.'0')
          L = L - 1
        enddo
        if(local(L:L).eq.'.'.or.local(L:L).eq.'+') L = L + 1
      endif
      dest = local(1:L)
      ld = L
      return
      end                       ! str_real_internal
      subroutine str_real_len(n)
      implicit none
      integer   n
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer m
      if(n.eq.0) then
        m = 6
      else if(n.gt.0) then
        m = n
      else
        return
      endif
      if(m.gt.9) m = 9
      if(m.ne.real_len) then
        real_len = m
        write (real_form1,100) m
  100   format('(F14.',i1,')')
        write (real_form2,110) m
  110   format('(F20.',i1,')')
      endif
      return
      end                       ! str_real_len
      subroutine str_real_len_get(n)
      implicit none
      integer n                 ! output
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      n = real_len
      return
      end                       ! str_real_len_get
      subroutine str_real_len_info
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer i
      call str_integer_out(real_len_p,'real-len stacksize=#')
      do i=1,real_len_p
        call str_2integer_out(i,real_len_stack(i),'pos=# len=#')
      enddo
      call str_integer_out(real_len,'current len=#')
      call str_flush
      return
      end                       ! str_real_len_info
      subroutine str_real_len_pop
      implicit none
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer m
      if(real_len_p.gt.0) then
        m = real_len_stack(real_len_p)
        real_len_p = real_len_p - 1
      else
        m = 6
      endif
      call str_real_len(m)
      return
      end                       ! str_real_len_pop
      subroutine str_real_len_push(n)
      implicit none
      integer n
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer   i
      real_len_p = real_len_p + 1
      if(real_len_p.gt.maxrealstack) then
        do i=1,maxrealstack-1
          real_len_stack(i) = real_len_stack(i+1)
        enddo
        real_len_p = maxrealstack
      endif
      real_len_stack(real_len_p) = real_len
      call str_real_len(n)
      return
      end                       ! str_real_len_push
      subroutine str_real_out(r,s)
      implicit none
      real      r
      character s*(*)
      character line*1024
      call str_real(r,s,line)
      call str_out(line)
      return
      end                       ! str_real_out
      subroutine str_real_write(unit,r,s)
      implicit none
      integer   unit
      real      r
      character s*(*)
      character line*1024
      call str_real(r,s,line)
      call str_write(unit,line)
      return
      end                       ! str_real_write
      subroutine str_regexp(source,result)
      character source*(*)      ! input
      character result*(*)      ! output
      logical   debug
      parameter (debug=.false.)
      integer   length
      character u*4096
      character v*4096
      integer   lv
      character field*256
      integer   lf
      integer   ls
      integer   lu
      integer   nchange
      ls = length(source)
      if(ls.eq.0) then
        result = ' '
        return
      endif
      call copystr(source(1:ls),u)
 10   continue
      if(debug) then
        call str_string_out(u,'REG1:#')
        call str_flush
      endif
      lu = length(u)
      call copystr(u(1:lu),v)
      lv = lu
      u  = ' '
      nchange = 0
      do while(lv.gt.0)
        call str_header(v(1:lv),field,lf,v,lv)
        if(debug) then
          call str_string_out(field,'rega:#')
          call str_flush
        endif
        call str_regexp1(field,field,nchange)
        if(debug) then
          call str_flush
          call str_string_out(field,'regb:#')
          call str_flush
        endif
        call str_add(u,field,u)
      enddo
      if(nchange.gt.0) goto 10
 20   continue
      if(debug) then
        call str_string_out(u,'REG2:#')
        call str_flush
      endif
      lu = length(u)
      call copystr(u(1:lu),v)
      lv = lu
      u  = ' '
      nchange = 0
      do while(lv.gt.0)
        call str_header(v(1:lv),field,lf,v,lv)
        if(debug) then
          call str_string_out(field,'regc:#')
          call str_flush
        endif
        call str_regexp2(field,field,nchange)
        if(debug) then
          call str_flush
          call str_string_out(field,'regd:#')
          call str_flush
        endif
        call str_add(u,field,u)
      enddo
      if(nchange.gt.0) goto 20
      call copystr(u,result)
      if(debug) then
        call str_string_out(u,'REG2:#')
        call str_flush
      endif
      return
      end                       ! str_regexp
      subroutine str_regexp1(source,result,n)
      character source*(*)      ! input
      character result*(*)      ! output
      integer   n               ! input/output
      integer   length
      integer   n1
      integer   n2
      integer   n3
      integer   n4
      integer   ls
      character u*4096
      integer   lu
      character v*4096
      integer   lv
      character field*80
      integer   lf
      integer   i
      integer   j
      character c*1
      ls = length(source)
      if(ls.eq.0) then
        result =  ' '
        return
      endif
      call copystr(source(1:ls),u)
      lu = ls
      call str_tags(u(1:lu),'[',']',n1,n2,n3,n4)
      if (n4.eq.0) then
        call copystr(u(1:lu),result)
        return
      endif
      n = n + 1
      v = ' '
      lv = 0
      do i=n2,n3
        if(u(i:i).eq.'-'.and.i.gt.n2.and.i.lt.n3) then
          do j = ichar(u(i-1:i-1))+1, ichar(u(i+1:i+1))-1
            c = char(j)
            if(n1.gt.1) then
              call str_concat(u(1:n1-1),c,field)
              lf = n1 - 1 + 1
            else
              field = c
              lf = 1
            endif
            if(ls.gt.n4) then
              call str_concat(field(1:lf),u(n4+1:ls),field)
              lf = lf + ls - n4
            endif
            call str_add(v(1:max(1,lv)),field(1:lf),v)
            lv = lv + 1 + lf
          enddo
        else if(u(i:i).ne.',') then
          c = u(i:i)
          if(n1.gt.1) then
            call str_concat(u(1:n1-1),c,field)
            lf = n1-1 + 1
          else
            field = c
            lf = 1
          endif
          if(ls.gt.n4) then
            call str_concat(field(1:lf),u(n4+1:ls),field)
            lf = lf + ls - n4
          endif
          call str_add(v(1:max(1,lv)),field(1:lf),v)
          lv = lv + 1 + lf
        endif
      enddo
      call copystr(v(1:lv),result)
      return
      end                       ! str_regexp1
      subroutine str_regexp2(source,result,n)
      character source*(*)      ! input
      character result*(*)      ! output
      integer   n               ! input/output
      integer   length
      integer   n1
      integer   n2
      integer   n3
      integer   n4
      integer   ls
      character u*4096
      integer   lu
      character v*4096
      integer   lv
      character field*80
      integer   lf
      character insert*80
      integer   li
      character todo*80
      integer   lt
      ls = length(source)
      if(ls.eq.0) then
        result =  ' '
        return
      endif
      call copystr(source(1:ls),u)
      lu = ls
      call str_tags(u(1:lu),'{','}',n1,n2,n3,n4)
      if (n4.eq.0) then
        call copystr(u(1:lu),result)
        return
      endif
      n = n + 1
      v = ' '
      lv = 0
      call copystr(u(n2:n3),todo)
      call str_substitute(todo,',;',' ;',todo)
      lt = n3 - n2 + 1
      do while(lt.gt.0)
        call str_header(todo(1:lt),insert,li,todo,lt)
        if(n1.gt.1) then
          call str_concat(u(1:n1-1),insert(1:li),field)
          lf = n1-1 + li
        else
          call copystr(insert(1:li),field)
          lf = li
        endif
        if(ls.gt.n4) then
          call str_concat(field(1:lf),u(n4+1:ls),field)
          lf = lf + ls - n4
        endif
        call str_add(v(1:max(1,lv)),field(1:lf),v)
        lv = lv + 1 + lf
      enddo
      call copystr(v(1:lv),result)
      return
      end                       ! str_regexp2
      subroutine str_remove(source,remove,result)
      implicit none
      character source*(*)
      character remove*(*)
      character result*(*)      ! output
      integer   length
      integer   lr
      character toremove*1024
      character c*1
      lr = length(remove)
      if(lr.eq.0) then
        call copystr(source,result)
      else
        c = ';'
        toremove = remove(1:lr)//c
        call str_substitute(source,toremove(1:lr+1),c,result)
      endif
      return
      end                       ! str_remove
      logical function str_startswith(s1,s2)
      character s1*(*)
      character s2*(*)
      integer   length
      integer   L
      logical   b
      character u1*1024
      character u2*1024
      L = min(length(s1),length(s2))
      if(L.eq.0) then
        b = .false.
      else
        call upcase(s1(1:L),u1)
        call upcase(s2(1:L),u2)
        b = (u1(1:L).eq.u2(1:L))
      endif
      str_startswith = b
      return
      end ! str_startswith
      subroutine str_string(string,s,dest)
      implicit none
      character string*(*)
      character s*(*)
      character dest*(*)        ! output
      integer   length
      character local*1024
      character replace*1024
      character c*1
      character from*2
      integer   ls
      integer   ls2
      integer   LL
      integer   LLL
      ls = length(s)
      ls2 = length(string)
      LLL = len(local)
      if(ls.eq.0) then
        if(ls2.gt.0) then
          call copystr(string(1:ls2),local)
          ll = min(ls2,LLL)
        else
          local = ' '
          ll = 1
        endif
      else if(index(s(1:ls),'#').eq.0) then
        if(ls2.gt.0) then
          call add2str(s(1:ls),string(1:ls2),local)
          ll = min(ls+ls2+1,LLL)
        else
          call copystr(s(1:ls),local)
          local = s(1:ls)
          ll = min(ls,LLL)
        endif
      else
        c = ';'
        from='#'//c
        if(ls2.eq.0) then
          call str_1substitute(s(1:ls),from,c,local)
          ll = min(ls - 1,LLL)
        else
          replace = string(1:ls2)//c
          call str_1substitute(s(1:ls),from,replace(1:ls2+1),local)
          ll = min(ls + ls2 - 1,LLL)
        endif
      endif
      call copystr(local(1:LL),dest)
      return
      end ! str_string
      subroutine str_string_out(string,s)
      implicit none
      character string*(*)
      character s*(*)
      character line*1024
      call str_string(string,s,line)
      call str_out(line)
      return
      end                       ! str_string_out
      subroutine str_string_write(unit,string,s)
      implicit none
      integer   unit
      character string*(*)
      character s*(*)
      character line*1024
      call str_string(string,s,line)
      call str_write(unit,line)
      return
      end                       ! str_string_write
      subroutine str_substitute(source,old,new,destination)
      implicit none
      character source*(*)     ! input
      character old*(*)        ! string to change. No Empty string
      character new*(*)        ! into this one.    Empty string allowed
      character destination*(*)! output
      integer   length
      integer   KL         ! length old
      integer   i
      integer   KN         ! length new
      integer   K
      integer   L
      character temp*4096   ! scratch
      integer   ls
      ls = length(source)
      if(ls.eq.0) then
        destination = ' '
        return
      endif
      KL = length(old)-1  ! changed into length 10-mar-2011
      if(KL.le.0) then
        call copystr(source(1:ls),destination)
        return
      endif
      i = index(source(1:ls),old(1:KL))
      if(i.eq.0) then
        call copystr(source(1:ls),destination)
        return
      endif
      KN = length(new) - 1  ! changed into length 10-mar-2011
      if(KN.lt.0) then
        call copystr(source(1:ls),destination)
        return
      endif
      K = 1
      L = 0
      do while(k.le.ls)
        if(source(K:K+KL-1).eq.old(1:KL)) then
          if (kn.gt.0) then
            L = L + 1
            temp(L:L+KN-1) = new(1:kn)
            L = L + KN - 1
          endif
          K = K + KL
        else
          L = L + 1
          temp(L:L) = source(K:K)
          K = K + 1
        endif
      enddo
      if(L.eq.0) then
        destination = ' '
      else
        call copystr(temp(1:L),destination)
      endif
      return
      end                       ! str_substitute
      subroutine str_table(n,s,ls)
      implicit none
      integer   n
      character s(*)*(*)
      integer   ls
      integer   lenstr
      character mask*4096
      integer   i,j,k
      if(n.le.0) then
        ls = 1
        return
      endif
      ls = lenstr(s(1))
      do j=2,n
        ls = max(ls,lenstr(s(j)))
      enddo
      if(ls.gt.len(mask)) then
        call str_2integer_write(6,ls,len(mask),
     +   'WARNING:Table is too large. Length=#, Maximum allowed=#')
        ls = len(mask)
      endif
      mask = ' '
      do i=1,ls
        do j=1,n
          if(s(j)(i:i).ne.' ') then
            mask(i:i) = '*'
            goto 10
          endif
        enddo
        mask(i:i) = 's'
   10   continue
      enddo
      i = 1
      do while(mask(i:i).eq.'s')
        i = i + 1
      enddo
      mask = mask(i:)
      do j=1,n
        s(j) = s(j)(i:)
      enddo
      ls = lenstr(mask)
   20 continue
      i = index(mask(1:ls),'ss')
      if(i.eq.0) then
        return
      endif
      k=i+2
      do while(mask(k:k).eq.'s')
        k = k + 1
        if(k.gt.ls) then
          call FatalMessage('OVERRUN in str_table')
        endif
      enddo
      call copy2str(mask(1:i),mask(k:ls),mask)
      do j=1,n
        call copy2str(s(j)(1:i), s(j)(k:ls), s(j))
      enddo
      ls = ls - (k-i-1)
      goto 20
      end                       ! str_table
      subroutine str_table_write(output_unit,n,s)
      implicit none
      integer   output_unit
      integer   n
      character s(*)*(*)
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer   length
      integer   gls,ls
      integer   i
      character form*80
      integer   lf
      if(n.le.0) return
      form = '(A)'
      lf = 3
      call str_flush
      call str_table(n,s,gls)
      do i=1,n
        ls = length(s(i))
        if(ls.eq.0) then
          call str_fill(s(i),gls,'=')
          ls = gls
        endif
        if(str_more_active.and.output_unit.eq.6) call more(1,s(1))
        call str_filtered_write(output_unit,s(i)(1:ls))
      enddo
      return
      end                       ! str_table_write
      subroutine str_tags(line,s1,s2,n1,n2,n3,n4)
      character line*(*)        ! input
      character s1*(*)          ! input
      character s2*(*)          ! input
      integer   n1              ! output start first tag
      integer   n2              ! output start substring
      integer   n3              ! output end substring
      integer   n4              ! output end second tag
      integer   length
      integer   ls1
      integer   ls2
      n1 = 0
      n2 = 0
      n3 = 0
      n4 = 0
      ls1 = length(s1)
      if(ls1.eq.0) return
      ls2 = length(s2)
      if(ls2.eq.0) return
      n1 = index(line,s1(1:ls1)) ! 5
      if(n1.eq.0) return
      n2 = n1 + ls1             ! 5+2 = 7
      n4 = index(line(n2:),s2(1:ls2)) ! 7
      if(n4.eq.0) return
      n3 = n2 + n4 - 2          ! 7+7-2 = 12
      n4 = n3 + ls2             ! 12+2 = 14
      return
      end                       ! str_tags
      subroutine str_unit(u)
      implicit none
      integer u
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer   page
      call str_flush  ! if there is anything left
      unit = u
      if(unit.eq.6) then
          call get_term_size(wrap6,page)
          wrap6 = min(wrap6,256)
        wrap = wrap6
      else
        inquire(unit=unit,recl=wrap)
        if(wrap.le.0) wrap=128
      endif
      wrap = min(wrap,len(str_buffer))
      call str_indent(indent)
      return
      end                       ! str_unit
      subroutine str_unit_pop
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer   u
      if(unitp.gt.0) then
        u = unitstack(unitp)
        if(unit.ne.u) then
          call str_unit(u)
        else
          call str_flush
        endif
        if(indent.ne.0.or.indentstack(unitp).ne.0) then
          call str_indent(indentstack(unitp))
        endif
        unitp = unitp - 1
      else
        call str_write(6,'Unit Stack Underflow.')
      endif
      return
      end                       ! str_unit_pop
      subroutine str_unit_push(u)
      integer   u
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer   i
      if(unitp.lt.maxunitstack) then
        unitp = unitp + 1
        unitstack(unitp) = unit
        indentstack(unitp) = indent
        if(unit.ne.u) then
          call str_unit(u)
        else
          call str_flush
        endif
        if(indent.gt.0) then
          call str_indent(0)
        endif
      else
        call str_integer_write(6,maxunitstack,
     +       'Unit Stack Overflow. Max=#')
        do i=1,maxunitstack
          call str_2integer_write(6,i,unitstack(i),'i=# unit=#')
        enddo
      endif
      return
      end                       ! str_unit_push
      subroutine str_vector(v,s,dest)
      implicit none
      real      v(3)
      character s*(*)
      character dest*(*)        ! output
      call str_array(3,v,s,dest)
      return
      end                       ! str_vector
      subroutine str_vector_out(v,s)
      implicit none
      real      v(3)
      character s*(*)
      call str_array_out(3,v,s)
      return
      end                       ! str_vector_out
      subroutine str_word_count(s,n)
      implicit none
      character s*(*)
      integer   n               ! output
      integer   str_compress
      character line*1024
      integer   i
      integer   ll
      ll = str_compress(s,line)
      n = 0
      if(ll.gt.0) then
        do i=1,ll
          if(line(i:i).eq.' ') n = n + 1
        enddo
        n = n + 1
      endif
      return
      end                       ! str_word_count
      subroutine str_wrap(n)
      implicit none
      integer n
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer page
      if(n.le.0) then
        if(unit.eq.6) then
          call get_term_size(wrap6,page)
          wrap6 = min(wrap6,132)
          wrap = wrap6
        else
          inquire(unit=unit,recl=wrap)
          if(wrap.le.0) wrap=80
        endif
      else
        wrap = n
      endif
      wrap = min(wrap,len(str_buffer))
      return
      end                       ! str_wrap
      subroutine str_write(output_unit,string)
      implicit none
      integer   output_unit
      character string*(*)
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      integer   lenstr
      integer   str_compress
      character s*1024
      integer   nc
      integer   ioerr
      if(write_compress) then
        nc = str_compress(string,s)
      else
        nc = lenstr(string)
        s = string(1:nc)
      endif
      if(str_more_active.and.output_unit.eq.6) call more(1,' ')
      if(changepercent) then
        call str_substitute(s(1:nc),'%;','#;',s)
      endif
      if(filterhtml) then
        call applyhtmlfilter(s,s)
        nc = lenstr(s)
      endif
      write (output_unit,flush_format(1:lff),iostat=ioerr) s(1:nc)
      if(ioerr.ne.0) call str_write_error(ioerr)
      return
      end                       ! str_write
      subroutine str_write_compress(set,previous)
      implicit none
      logical  set              ! input
      logical  previous         ! output
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      external StringsData
      logical tmp
      tmp = set
      previous = write_compress
      write_compress = tmp
      return
      end                       ! str_write_compress
      subroutine str_write_error(ioerr)
      integer ioerr
      print *,'Write error ',ioerr
      call exitfatal
      return
      end                       ! str_write_error
      subroutine str_writenewline(unit)
      integer unit
      write(unit,100)
 100  format()
      return
      end                       ! str_writenewline
      subroutine str_YesNo(b,s,dest)
      implicit none
      logical   b
      character s*(*)
      character dest*(*)        ! output
      call str_boolean(b,'yes','no',s,dest)
      return
      end                       ! str_YesNo
      subroutine str_zero(s1,s2,ls2)
      character s1*(*)
      character s2*(*)          ! output
      integer   ls2             ! output
      integer    lenstr
      character zero*1
      integer   ls1
      zero = char(0)
      ls1 = lenstr(s1)
      if(ls1+1.gt.len(s2)) then
        ls1 = len(s2)-1
      endif
      call copy2str(s1(1:ls1),zero,s2)
      ls2 = ls1 + 1
      return
      end                       ! str_zero
      block data StringsData
      integer   maxunitstack
      parameter (maxunitstack=5)
      integer   maxrealstack
      parameter (maxrealstack=5)
      integer   unit
      integer   wrap
      integer   wrap6
      integer   lb
      logical   dirtylb
      integer   indent
      integer   paragraph_length
      integer   append_length
      logical   str_more_active
      logical   OutConcat
      logical   OutCount
      integer   flush_count
      integer   lff
      integer   unitp
      logical   changepercent
      logical   filterhtml
      logical   boundcheck
      integer   unitstack(maxunitstack)
      integer   indentstack(maxunitstack)
      common /str___buf/ unit,wrap,wrap6,lb,dirtylb,indent,
     +     paragraph_length,append_length,str_more_active,OutConcat,
     +     OutCount,flush_count,lff,unitp,changepercent,filterhtml,
     +     boundcheck,unitstack,indentstack
      logical   write_compress
      common /str___buf2/ write_compress
      character paragraph_string*80
      character append_string*80
      character str_buffer*512
      character flush_format*80
      common /str___buf_char/ paragraph_string,append_string,
     +     str_buffer,flush_format
      logical   real_trim
      integer   real_len
      integer   real_len_stack(maxrealstack)
      integer   real_len_p
      common /str___real_common/ real_trim,real_len,real_len_stack,
     + real_len_p
      character real_form1*7
      character real_form2*7
      common /str___real_common_char/ real_form1,real_form2
      data unit   / 6/
      data wrap   /80/
      data wrap6  /0/
      data lb     / 0/
      data dirtylb /.false./
      data indent / 0/
      data flush_format /'(a)'/
      data lff /3/
      data unitp /0/
      data paragraph_length /0/
      data append_length /0/
      data str_more_active /.false./
      data OutConcat /.false./
      data OutCount /.true./
      data flush_count /-1/
      data write_compress /.true./
      data changepercent /.false./
      data filterhtml /.false./
      data boundcheck /.false./
      data real_len /6/
      data real_trim /.true./
      data real_len_p /0/
      data real_form1 /'(F14.6)'/
      data real_form2 /'(F20.6)'/
      end                       ! block data stringsdata
      subroutine Sum3Vec(u,v,w,x)
      implicit none
      real    u(3)              ! input
      real    v(3)              ! input
      real    w(3)              ! input
      real    x(3)              ! output
      x(1) = u(1) + v(1) + w(1)
      x(2) = u(2) + v(2) + w(2)
      x(3) = u(3) + v(3) + w(3)
      return
      end                       ! Sum3Vec
      subroutine SumVec(u,v,w)
      implicit none
      real    u(3)              ! input
      real    v(3)              ! input
      real    w(3)              ! output
      w(1) = u(1) + v(1)
      w(2) = u(2) + v(2)
      w(3) = u(3) + v(3)
      return
      end                       ! SumVec
      subroutine tableadd(line)
      character line*(*)
      integer maxtable
      parameter (maxtable=500)
      integer tableunit
      logical tableflushed
      integer itab
      common /table_com/ tableunit,tableflushed,itab
      character table(maxtable)*256
      common /table_com_char/ table
      if(itab.lt.maxtable) then
        itab = itab + 1
      else
        call tableflush
        itab = 1
      endif
      table(itab) = line
      return
      end                       ! tableadd
      subroutine tableflush
      integer maxtable
      parameter (maxtable=500)
      integer tableunit
      logical tableflushed
      integer itab
      common /table_com/ tableunit,tableflushed,itab
      character table(maxtable)*256
      common /table_com_char/ table
      integer lenstr
      integer i
      integer lt
      integer ioerr
      if(itab.gt.0) then
        do i=1,itab
          lt = lenstr(table(i))
          write (tableunit,600,iostat=ioerr) table(i)(1:lt)
          if(ioerr.ne.0) call str_write_error(ioerr)
  600     format(a)
        enddo
        tableflushed = .true.
      endif
      return
      end                       ! tableflush
      subroutine tablestart(unit)
      integer unit
      integer maxtable
      parameter (maxtable=500)
      integer tableunit
      logical tableflushed
      integer itab
      common /table_com/ tableunit,tableflushed,itab
      character table(maxtable)*256
      common /table_com_char/ table
      tableunit = unit
      itab = 0
      tableflushed = .false.
      return
      end                       ! tablestart
      subroutine tablestop
      integer maxtable
      parameter (maxtable=500)
      integer tableunit
      logical tableflushed
      integer itab
      common /table_com/ tableunit,tableflushed,itab
      character table(maxtable)*256
      common /table_com_char/ table
      if(itab.gt.0) then
        if(tableflushed) then
          call tableflush
        else
          call str_table_write(tableunit,itab,table)
        endif
      endif
      return
      end                       ! tablestop
      subroutine termline(prompt,answer,ier)
      implicit none
      character prompt*(*)
      character answer*(*)
      integer   ier
      integer   length
      integer   i
      character c*1
      call get_mode(c)
      if(c.eq.'I') then
        do i=1,length(prompt)
          call displayc(prompt(i:i))
        enddo
        call displayc(' ')
        read (5,500,iostat=ier) answer
  500   format(a)
      else
        ier = 1
      endif
      return
      end
      subroutine tilde(inp,out,lo)
      character inp*(*)
      character out*(*)
      integer   lo
      integer   length
      integer   lh
      character home*80
      lo = length(inp)
      if(lo.eq.0) then
        out = ' '
        return
      endif
      if(inp(1:2).eq.'~/') then
        call getenv('HOME',home)
        lh = length(home)
        if(lh.gt.0) then
          call copy2str(home(1:lh),inp(2:lo),out)
          lo = lo-1+lh
          return
        endif
      endif
      call copystr(inp(1:lo),out)
      return
      end                       ! tilde
      character*11 function today()
      implicit none
      call mydate(today)
      return
      end                       ! today
      subroutine TooManyFatal(n1,n2,what)
      integer   n1
      integer   n2
      character what*(*)
      character line*256
      call TooManyMessage(n1,n2,what,line)
      call FatalMessage(line)
      return
      end                       ! TooManyFatal
      subroutine TooManyMessage(n1,n2,what,result)
      integer   n1
      integer   n2
      character what*(*)
      character result*(*)
      if(n1.ne.n2) then
        call str_string(what,'Too many #. Value=# Maximum=#.',result)
        call str_2integer(n1,n2,result,result)
      else
        call str_string(what,'Too many #. Maximum=#.',result)
        call str_integer(n2,result,result)
      endif
      return
      end                       ! TooManyMessage
      subroutine TransMat(u,v)
      implicit none
      real    u(3,3)            ! input
      real    v(3,3)            ! output
      real    x(3,3)
      integer i
      integer j
      do j=1,3
        do i=1,3
          x(i,j) = u(j,i)
        enddo
      enddo
      call CopyMat(x,v)
      return
      end                       ! TransMat
      subroutine uniquename(u)
      implicit none
      character u*(*)
      character rolex*10
      character t*20
      character s*20
      s = '##'
      call get_processname(s)
      t = rolex()
      call str_substitute(t,':;',';',t)
      call str_expandconcat(s,t)
      call str_collapse(s,u)
      return
      end ! uniquename
      subroutine UnitMatrix(m)
      real m(3,3)               ! output
      call BuildMatrix(1.0,0.0,0.0, 0.0,1.0,0.0, 0.0,0.0,1.0,m)
      return
      end                       ! UnitMatrix
      subroutine upcase(string1,string2)
      implicit none
      character string1*(*)
      character string2*(*)     ! output
      integer   length
      character c*1
      integer   i
      integer   delta
      integer   ls
      delta = ichar('a')-ichar('A')
      ls = length(string1)
      if(ls.eq.0) then
        string2 = ' '
        return
      endif
      call CopyStr(string1(1:ls),string2)
      do i=1,ls
        c = string2(i:i)
        if(c.ge.'a'.and.c.le.'z') then
          string2(i:i) = char( ichar(c)-delta)
        endif
      enddo
      return
      end                       ! upcase
      subroutine Vec2Col(v,m,ColumnNumber)
      implicit none
      real    v(3)              ! input
      real    m(3,3)            ! input/output
      integer ColumnNumber      ! input
      integer i
      character message*80
      if(ColumnNumber.lt.1.or.ColumnNumber.gt.3) then
        call str_integer(ColumnNumber,'Vec2Col #',message)
        call AbortMessage(message)
      endif
      do i=1,3
        m(i,ColumnNumber) = v(i)
      enddo
      return
      end                       ! Vec2Col
      subroutine Vec2Diag(v,m)
      implicit none
      real    v(3)              ! input
      real    m(3,3)            ! input/output
      integer i
      do i=1,3
        m(i,i) = v(i)
      enddo
      return
      end                       ! Vec2Diag
      subroutine Vec2Row(v,m,RowNumber)
      implicit none
      real    v(3)              ! input
      real    m(3,3)            ! input/output
      integer RowNumber         ! input
      integer i
      character message*80
      if(RowNumber.lt.1.or.RowNumber.gt.3) then
        call str_integer(RowNumber,'Vec2Row #',message)
        call AbortMessage(message)
      endif
      do i=1,3
        m(RowNumber,i) = v(i)
      enddo
      return
      end                       ! Vec2Row
      subroutine VecProd(u,v,w)
      implicit none
      real u(3)                 ! input
      real v(3)                 ! input
      real w(3)                 ! output
      real    x1
      real    x2
      x1 =   (u(2)*v(3) - u(3)*v(2))
      x2 =   (u(3)*v(1) - u(1)*v(3))
      w(3) =   (u(1)*v(2) - u(2)*v(1))
      w(1) = x1
      w(2) = x2
      return
      end                       ! VecProd
      subroutine WarningMessage(s)
      character s*(*)
      call str_flush
      call str_string_out(s,'WARNING: #')
      call str_flush
      return
      end                       ! WarningMessage
      subroutine WebBrowser(s,ier)
      character s*(*)
      integer   ier
      integer   length
      integer   maxbrowser
      parameter (maxbrowser=4)
      character command*256
      character progname*80
      logical   newwindow
      character string*80
      integer   pid
      logical   localdisplay
      logical   isalpha
      logical   realurl
      character message*256
      character browsers(maxbrowser)*10
      integer   i
      save newwindow
      data newwindow /.true./
      data browsers /'iceweasel','firefox','mozilla','netscape'/
      call get_inp_get_alias('browser',progname,ier)
      if(ier.eq.0) then
        call which(progname,progname,message,ier)
        if(ier.ne.0) call str_out(message)
      endif
      if(ier.ne.0) then
        call getenv('BROWSER',progname)
        if(length(progname).eq.0) then
          ier = 1
        else
          call which(progname,progname,message,ier)
          if(ier.ne.0) call str_out(message)
        endif
      endif
      if(ier.ne.0) then
        do i=1,maxbrowser
          call which(browsers(i),progname,message,ier)
          if(ier.eq.0) goto 10
        enddo
      endif
 10   continue
      if(ier.ne.0) then
        message = 'no browser available. tried'
        call str_join(maxbrowser,browsers,message)
        call str_flush
        call str_write(6,message)
        ier = 2
        return
      endif
      realurl = (s(1:4).eq.'http')
      call getenv('DISPLAY',string)
      localdisplay = (string.eq.':0.0')
      call getenv('HOSTTYPE',string)
      isalpha = (string.eq.'alpha')
      if(realurl.or.localdisplay.or.isalpha) then
        if(realurl) then
          string = 'openURL'
        else
          string = 'OpenFile'
        endif
        if(newwindow) then
          call str_2string(progname,string,
     +         '# -remote "#(#,new-window)"',command)
        else
          call str_2string(progname,string,'# -remote "#(#)"',command)
        endif
        call str_string(s,command,command)
        call str_flush
        call str_string_write(6,command,'trying:#')
        call spawn(command,ier)
        if(ier.ne.0) then
          if(.not.newwindow) then
            call str_string_write(6,progname,'We seem to have lost #')
          endif
          if(isalpha) then
            call str_string_out(progname,
     +           'On alpha you have to start # manually.')
          else
            call str_string(progname,'# "#"',command)
            call str_string(s,command,command)
            call str_string_write(6,command,'trying:#')
            call spawn_nowait(command,pid,ier)
          endif
        endif
      else
        if(.not.newwindow) then
          call str_string(progname,'# -remote "openFile(#)"',
     +         command)
          call str_string(s,command,command)
          call str_string_write(6,command,'trying:#')
          call spawn(command,ier)
          if(ier.eq.0) goto 100
          call str_string_write(6,progname,'We seem to have lost #')
        endif
        call str_string(progname,'# "#"',command)
        call str_string(s,command,command)
        call str_string_write(6,command,'trying:#')
        call spawn_nowait(command,pid,ier)
      endif
  100 continue
      newwindow=.false.
      return
      end                       ! WebBrowser
      subroutine which(target,result,message,ier)
      character target*(*)  ! program to search
      character result*(*)  ! result if found
      character message*(*)
      integer   ier         ! 0=found 1=not found
      character ROUTINE*(*)
      parameter (ROUTINE='Which')
      logical   debug
      parameter (debug=.true.)
      integer   length
      character path*1024
      integer   lp
      integer   lt
      character field*80
      integer   lf
      character string*80
      integer   ls
      logical   exist
      lt = length(target)
      if(lt.eq.0) then
        call str_string(ROUTINE,'#: empty target',message)
        ier = 1
        return
      endif
      call image_path(path,lp)
      call path_join(path(1:lp),target(1:lt),string)
      ls = lt+lp+1
      inquire(file=string(1:ls),exist=exist)
      if(exist) then
        call str_3string(ROUTINE,target(1:lt),string(1:ls),'#(#)=#',
     +       message)
        result = string(1:ls)
        ier = 0
        return
      endif
      call getenv('PATH',path)
      lp = length(path)
      if(lp.eq.0) then
        call str_string(ROUTINE,'#: empty path',message)
        ier = 1
        return
      endif
      call str_substitute(path(1:lp),':;',' ;',path)
      lp = length(path)
      do while(lp.gt.0)
        call str_header(path(1:lp),field,lf,path,lp)
        call path_join(field(1:lf),target(1:lt),string)
        ls = lt+lf+1
        inquire(file=string(1:ls),exist=exist)
        if(exist) then
          call str_3string(ROUTINE,target(1:lt),string(1:ls),'#(#)=#',
     +         message)
          result = string(1:ls)
          ier = 0
          return
        endif
      enddo
      call str_2string(ROUTINE,target,'#:# not found',message)
      ier =  1
      return
      end                       ! which
      subroutine Write2Mat(out,r1,r2,s1,s2)
      implicit none
      integer   out             ! input
      real      r1(3,3)         ! input
      real      r2(3,3)         ! input
      character s1*(*)          ! input
      character s2*(*)          ! input
      integer   Length
      real      MatVol
      character line*80
      integer   position
      integer   ls1
      integer   ls2
      integer   i
      integer   mwidth
      integer   mbetween
      parameter (mwidth=36)  ! 3*f12.7
      parameter (mbetween=5)
      integer   ioerr
      real      v1(3)
      real      v2(3)
      logical   cmprs
      call str_write_compress(.false.,cmprs)
      line = ' '
      ls1 = length(s1)
      if(ls1.gt.0) then
        position = int(0.5*(mwidth-ls1))
        line(position:) = s1
      endif
      ls2 = length(s2)
      if(ls2.gt.0) then
        position = int(0.5*(mwidth-ls2))
        line(mwidth+mbetween+position:) = s2
      endif
      if(length(line).gt.0) then
        call str_write(out,line)
      endif
      do i=1,3
        call row2vec(i,r1,v1)
        call row2vec(i,r2,v2)
        write (line,100,iostat=ioerr) v1,v2
  100   format(3f12.7,5x,3f12.7)
        call str_write(out,line)
      enddo
      write (line,110,iostat=ioerr) MatVol(r1),MatVol(r2)
  110 format('Determinant:',g15.7,9x,5x,12x,g15.7)
      call str_write(out,line)
      call str_write_compress(cmprs,cmprs)
      return
      end                       ! Write2Mat
      subroutine WriteMat(out,r,s)
      implicit none
      integer   out             ! input
      real      r(3,3)          ! input
      character s*(*)           ! input
      integer   Length
      real      MatVol
      integer   ioerr
      real      v(3)
      logical   cmprs
      character line*80
      call str_write_compress(.false.,cmprs)
      if(length(s).gt.0) call str_write(out,s)
      call Row2Vec(1,r,v)
      write (line,100,iostat=ioerr) v
  100 format(3f12.7)
      call str_write(out,line)
      call Row2Vec(2,r,v)
      write (line,110,iostat=ioerr) v,matvol(r)
  110 format(3f12.7,' Determinant:',g14.7)
      call str_write(out,line)
      call Row2Vec(3,r,v)
      write (line,100,iostat=ioerr) v
      call str_write(out,line)
      call str_write_compress(cmprs,cmprs)
      return
      end                       ! WriteMat
      subroutine ZeroVector(v)
      real    v(3)              ! output
      integer i
      do i=1,3
        v(i) = 0.0
      enddo
      return
      end                       ! ZeroVector
